// Ctrl-S保存代码
import {querystring} from '@ywfe/utils'
interface RequestOptions {
  url:string,
  method?:string,
  params?:any
}
async function request({input}:{input:RequestOptions}){
  const method = input.method || 'GET';
  const basePathMap = new Map([
   ['prod', 'https://gateway.ywwl.com'],
   ['test', 'https://test-gateway.ywwl.com'],
   ['test2', 'https://test2-gateway.ywwl.com'],
   ['dev', 'https://dev-gateway.ywwl.com'],
  ])
  const getBasePath = () => {
   const env = '{{env}}';
   return basePathMap.get(env);
  };
  const isValidURL = (url:string)=> {
    var pattern = new RegExp(
        '^(https?:\\/\\/)?' + // protocol
        '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|' + // domain name
        '((\\d{1,3}\\.){3}\\d{1,3}))' + // OR ip (v4) address
        '(\\:\\d+)?(\\/[-a-z\\d%_.&#126;+]*)*' + // port and path
        '(\\?[;&a-z\\d%_.&#126;+=-]*)?' + // query string
        '(\\#[-a-z\\d_]*)?$','i'); // fragment locator
    return !!pattern.test(url);
}
  const prefix = getBasePath()
  let requestUrl = isValidURL(input.url) ? input.url :`${prefix}${input.url}`
  const fetchOption: {[key:string]:any} = {
    method: method,
    headers: {
      'Content-type': 'application/json',
      'x-token': '{{token}}',
    },
  };
  if (method.toUpperCase() === 'POST') {
     fetchOption.body = JSON.stringify(input.params);
  }else if(method.toUpperCase() === 'GET'){
    requestUrl = `${requestUrl}?${querystring.stringify(input.params || {})}`
    
  }
  
  const res = await fetch(requestUrl, fetchOption);
  return res.json();
}
export default request