'use strict';

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */
/* global Reflect, Promise, SuppressedError, Symbol */


function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

function getAugmentedNamespace(n) {
  if (n.__esModule) return n;
  var f = n.default;
	if (typeof f == "function") {
		var a = function a () {
			if (this instanceof a) {
        return Reflect.construct(f, arguments, this.constructor);
			}
			return f.apply(this, arguments);
		};
		a.prototype = f.prototype;
  } else a = {};
  Object.defineProperty(a, '__esModule', {value: true});
	Object.keys(n).forEach(function (k) {
		var d = Object.getOwnPropertyDescriptor(n, k);
		Object.defineProperty(a, k, d.get ? d : {
			enumerable: true,
			get: function () {
				return n[k];
			}
		});
	});
	return a;
}

var ywfeUtils_esm = {};

var empty = {};

var empty$1 = /*#__PURE__*/Object.freeze({
    __proto__: null,
    default: empty
});

var require$$1 = /*@__PURE__*/getAugmentedNamespace(empty$1);

(function (exports) {

	Object.defineProperty(exports, '__esModule', { value: true });

	var require$$0 = require$$1;

	function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

	var require$$0__default = /*#__PURE__*/_interopDefaultLegacy(require$$0);

	/*
	 * @author 春风
	 * @date 2021/7/8 下午2:53
	 **/
	function basePullAt(array, indexes) {
	    let length = array ? indexes.length : 0, lastIndex = length - 1, previous = 0;
	    while (length--) {
	        const index = indexes[length];
	        if (length == lastIndex || index !== previous) {
	            previous = index;
	            Array.prototype.splice.call(array, index, 1);
	        }
	    }
	    return array;
	}

	function remove(array, predicate) {
	    const result = [];
	    if (!(array && array.length)) {
	        return result;
	    }
	    let index = -1, indexes = [], length = array.length;
	    while (++index < length) {
	        const value = array[index];
	        if (predicate(value, index, array)) {
	            result.push(value);
	            indexes.push(index);
	        }
	    }
	    basePullAt(array, indexes);
	    return result;
	}

	function _isPlaceholder(a) {
	  return a != null && typeof a === 'object' && a['@@functional/placeholder'] === true;
	}

	/**
	 * Optimized internal one-arity curry function.
	 *
	 * @private
	 * @category Function
	 * @param {Function} fn The function to curry.
	 * @return {Function} The curried function.
	 */

	function _curry1(fn) {
	  return function f1(a) {
	    if (arguments.length === 0 || _isPlaceholder(a)) {
	      return f1;
	    } else {
	      return fn.apply(this, arguments);
	    }
	  };
	}

	/**
	 * Optimized internal two-arity curry function.
	 *
	 * @private
	 * @category Function
	 * @param {Function} fn The function to curry.
	 * @return {Function} The curried function.
	 */

	function _curry2(fn) {
	  return function f2(a, b) {
	    switch (arguments.length) {
	      case 0:
	        return f2;

	      case 1:
	        return _isPlaceholder(a) ? f2 : _curry1(function (_b) {
	          return fn(a, _b);
	        });

	      default:
	        return _isPlaceholder(a) && _isPlaceholder(b) ? f2 : _isPlaceholder(a) ? _curry1(function (_a) {
	          return fn(_a, b);
	        }) : _isPlaceholder(b) ? _curry1(function (_b) {
	          return fn(a, _b);
	        }) : fn(a, b);
	    }
	  };
	}

	/**
	 * Private `concat` function to merge two array-like objects.
	 *
	 * @private
	 * @param {Array|Arguments} [set1=[]] An array-like object.
	 * @param {Array|Arguments} [set2=[]] An array-like object.
	 * @return {Array} A new, merged array.
	 * @example
	 *
	 *      _concat([4, 5, 6], [1, 2, 3]); //=> [4, 5, 6, 1, 2, 3]
	 */
	function _concat(set1, set2) {
	  set1 = set1 || [];
	  set2 = set2 || [];
	  var idx;
	  var len1 = set1.length;
	  var len2 = set2.length;
	  var result = [];
	  idx = 0;

	  while (idx < len1) {
	    result[result.length] = set1[idx];
	    idx += 1;
	  }

	  idx = 0;

	  while (idx < len2) {
	    result[result.length] = set2[idx];
	    idx += 1;
	  }

	  return result;
	}

	function _arity(n, fn) {
	  /* eslint-disable no-unused-vars */
	  switch (n) {
	    case 0:
	      return function () {
	        return fn.apply(this, arguments);
	      };

	    case 1:
	      return function (a0) {
	        return fn.apply(this, arguments);
	      };

	    case 2:
	      return function (a0, a1) {
	        return fn.apply(this, arguments);
	      };

	    case 3:
	      return function (a0, a1, a2) {
	        return fn.apply(this, arguments);
	      };

	    case 4:
	      return function (a0, a1, a2, a3) {
	        return fn.apply(this, arguments);
	      };

	    case 5:
	      return function (a0, a1, a2, a3, a4) {
	        return fn.apply(this, arguments);
	      };

	    case 6:
	      return function (a0, a1, a2, a3, a4, a5) {
	        return fn.apply(this, arguments);
	      };

	    case 7:
	      return function (a0, a1, a2, a3, a4, a5, a6) {
	        return fn.apply(this, arguments);
	      };

	    case 8:
	      return function (a0, a1, a2, a3, a4, a5, a6, a7) {
	        return fn.apply(this, arguments);
	      };

	    case 9:
	      return function (a0, a1, a2, a3, a4, a5, a6, a7, a8) {
	        return fn.apply(this, arguments);
	      };

	    case 10:
	      return function (a0, a1, a2, a3, a4, a5, a6, a7, a8, a9) {
	        return fn.apply(this, arguments);
	      };

	    default:
	      throw new Error('First argument to _arity must be a non-negative integer no greater than ten');
	  }
	}

	/**
	 * Internal curryN function.
	 *
	 * @private
	 * @category Function
	 * @param {Number} length The arity of the curried function.
	 * @param {Array} received An array of arguments received thus far.
	 * @param {Function} fn The function to curry.
	 * @return {Function} The curried function.
	 */

	function _curryN(length, received, fn) {
	  return function () {
	    var combined = [];
	    var argsIdx = 0;
	    var left = length;
	    var combinedIdx = 0;

	    while (combinedIdx < received.length || argsIdx < arguments.length) {
	      var result;

	      if (combinedIdx < received.length && (!_isPlaceholder(received[combinedIdx]) || argsIdx >= arguments.length)) {
	        result = received[combinedIdx];
	      } else {
	        result = arguments[argsIdx];
	        argsIdx += 1;
	      }

	      combined[combinedIdx] = result;

	      if (!_isPlaceholder(result)) {
	        left -= 1;
	      }

	      combinedIdx += 1;
	    }

	    return left <= 0 ? fn.apply(this, combined) : _arity(left, _curryN(length, combined, fn));
	  };
	}

	/**
	 * Returns a curried equivalent of the provided function, with the specified
	 * arity. The curried function has two unusual capabilities. First, its
	 * arguments needn't be provided one at a time. If `g` is `R.curryN(3, f)`, the
	 * following are equivalent:
	 *
	 *   - `g(1)(2)(3)`
	 *   - `g(1)(2, 3)`
	 *   - `g(1, 2)(3)`
	 *   - `g(1, 2, 3)`
	 *
	 * Secondly, the special placeholder value [`R.__`](#__) may be used to specify
	 * "gaps", allowing partial application of any combination of arguments,
	 * regardless of their positions. If `g` is as above and `_` is [`R.__`](#__),
	 * the following are equivalent:
	 *
	 *   - `g(1, 2, 3)`
	 *   - `g(_, 2, 3)(1)`
	 *   - `g(_, _, 3)(1)(2)`
	 *   - `g(_, _, 3)(1, 2)`
	 *   - `g(_, 2)(1)(3)`
	 *   - `g(_, 2)(1, 3)`
	 *   - `g(_, 2)(_, 3)(1)`
	 *
	 * @func
	 * @memberOf R
	 * @since v0.5.0
	 * @category Function
	 * @sig Number -> (* -> a) -> (* -> a)
	 * @param {Number} length The arity for the returned function.
	 * @param {Function} fn The function to curry.
	 * @return {Function} A new, curried function.
	 * @see R.curry
	 * @example
	 *
	 *      const sumArgs = (...args) => R.sum(args);
	 *
	 *      const curriedAddFourNumbers = R.curryN(4, sumArgs);
	 *      const f = curriedAddFourNumbers(1, 2);
	 *      const g = f(3);
	 *      g(4); //=> 10
	 */

	var curryN =
	/*#__PURE__*/
	_curry2(function curryN(length, fn) {
	  if (length === 1) {
	    return _curry1(fn);
	  }

	  return _arity(length, _curryN(length, [], fn));
	});

	var curryN$1 = curryN;

	/**
	 * Optimized internal three-arity curry function.
	 *
	 * @private
	 * @category Function
	 * @param {Function} fn The function to curry.
	 * @return {Function} The curried function.
	 */

	function _curry3(fn) {
	  return function f3(a, b, c) {
	    switch (arguments.length) {
	      case 0:
	        return f3;

	      case 1:
	        return _isPlaceholder(a) ? f3 : _curry2(function (_b, _c) {
	          return fn(a, _b, _c);
	        });

	      case 2:
	        return _isPlaceholder(a) && _isPlaceholder(b) ? f3 : _isPlaceholder(a) ? _curry2(function (_a, _c) {
	          return fn(_a, b, _c);
	        }) : _isPlaceholder(b) ? _curry2(function (_b, _c) {
	          return fn(a, _b, _c);
	        }) : _curry1(function (_c) {
	          return fn(a, b, _c);
	        });

	      default:
	        return _isPlaceholder(a) && _isPlaceholder(b) && _isPlaceholder(c) ? f3 : _isPlaceholder(a) && _isPlaceholder(b) ? _curry2(function (_a, _b) {
	          return fn(_a, _b, c);
	        }) : _isPlaceholder(a) && _isPlaceholder(c) ? _curry2(function (_a, _c) {
	          return fn(_a, b, _c);
	        }) : _isPlaceholder(b) && _isPlaceholder(c) ? _curry2(function (_b, _c) {
	          return fn(a, _b, _c);
	        }) : _isPlaceholder(a) ? _curry1(function (_a) {
	          return fn(_a, b, c);
	        }) : _isPlaceholder(b) ? _curry1(function (_b) {
	          return fn(a, _b, c);
	        }) : _isPlaceholder(c) ? _curry1(function (_c) {
	          return fn(a, b, _c);
	        }) : fn(a, b, c);
	    }
	  };
	}

	/**
	 * Tests whether or not an object is an array.
	 *
	 * @private
	 * @param {*} val The object to test.
	 * @return {Boolean} `true` if `val` is an array, `false` otherwise.
	 * @example
	 *
	 *      _isArray([]); //=> true
	 *      _isArray(null); //=> false
	 *      _isArray({}); //=> false
	 */
	var _isArray = Array.isArray || function _isArray(val) {
	  return val != null && val.length >= 0 && Object.prototype.toString.call(val) === '[object Array]';
	};

	function _isTransformer(obj) {
	  return obj != null && typeof obj['@@transducer/step'] === 'function';
	}

	/**
	 * Returns a function that dispatches with different strategies based on the
	 * object in list position (last argument). If it is an array, executes [fn].
	 * Otherwise, if it has a function with one of the given method names, it will
	 * execute that function (functor case). Otherwise, if it is a transformer,
	 * uses transducer [xf] to return a new transformer (transducer case).
	 * Otherwise, it will default to executing [fn].
	 *
	 * @private
	 * @param {Array} methodNames properties to check for a custom implementation
	 * @param {Function} xf transducer to initialize if object is transformer
	 * @param {Function} fn default ramda implementation
	 * @return {Function} A function that dispatches on object in list position
	 */

	function _dispatchable(methodNames, xf, fn) {
	  return function () {
	    if (arguments.length === 0) {
	      return fn();
	    }

	    var args = Array.prototype.slice.call(arguments, 0);
	    var obj = args.pop();

	    if (!_isArray(obj)) {
	      var idx = 0;

	      while (idx < methodNames.length) {
	        if (typeof obj[methodNames[idx]] === 'function') {
	          return obj[methodNames[idx]].apply(obj, args);
	        }

	        idx += 1;
	      }

	      if (_isTransformer(obj)) {
	        var transducer = xf.apply(null, args);
	        return transducer(obj);
	      }
	    }

	    return fn.apply(this, arguments);
	  };
	}

	function _reduced(x) {
	  return x && x['@@transducer/reduced'] ? x : {
	    '@@transducer/value': x,
	    '@@transducer/reduced': true
	  };
	}

	var _xfBase = {
	  init: function () {
	    return this.xf['@@transducer/init']();
	  },
	  result: function (result) {
	    return this.xf['@@transducer/result'](result);
	  }
	};

	function _map(fn, functor) {
	  var idx = 0;
	  var len = functor.length;
	  var result = Array(len);

	  while (idx < len) {
	    result[idx] = fn(functor[idx]);
	    idx += 1;
	  }

	  return result;
	}

	function _isString(x) {
	  return Object.prototype.toString.call(x) === '[object String]';
	}

	/**
	 * Tests whether or not an object is similar to an array.
	 *
	 * @private
	 * @category Type
	 * @category List
	 * @sig * -> Boolean
	 * @param {*} x The object to test.
	 * @return {Boolean} `true` if `x` has a numeric length property and extreme indices defined; `false` otherwise.
	 * @example
	 *
	 *      _isArrayLike([]); //=> true
	 *      _isArrayLike(true); //=> false
	 *      _isArrayLike({}); //=> false
	 *      _isArrayLike({length: 10}); //=> false
	 *      _isArrayLike({0: 'zero', 9: 'nine', length: 10}); //=> true
	 */

	var _isArrayLike =
	/*#__PURE__*/
	_curry1(function isArrayLike(x) {
	  if (_isArray(x)) {
	    return true;
	  }

	  if (!x) {
	    return false;
	  }

	  if (typeof x !== 'object') {
	    return false;
	  }

	  if (_isString(x)) {
	    return false;
	  }

	  if (x.nodeType === 1) {
	    return !!x.length;
	  }

	  if (x.length === 0) {
	    return true;
	  }

	  if (x.length > 0) {
	    return x.hasOwnProperty(0) && x.hasOwnProperty(x.length - 1);
	  }

	  return false;
	});

	var _isArrayLike$1 = _isArrayLike;

	var XWrap =
	/*#__PURE__*/
	function () {
	  function XWrap(fn) {
	    this.f = fn;
	  }

	  XWrap.prototype['@@transducer/init'] = function () {
	    throw new Error('init not implemented on XWrap');
	  };

	  XWrap.prototype['@@transducer/result'] = function (acc) {
	    return acc;
	  };

	  XWrap.prototype['@@transducer/step'] = function (acc, x) {
	    return this.f(acc, x);
	  };

	  return XWrap;
	}();

	function _xwrap(fn) {
	  return new XWrap(fn);
	}

	/**
	 * Creates a function that is bound to a context.
	 * Note: `R.bind` does not provide the additional argument-binding capabilities of
	 * [Function.prototype.bind](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Function/bind).
	 *
	 * @func
	 * @memberOf R
	 * @since v0.6.0
	 * @category Function
	 * @category Object
	 * @sig (* -> *) -> {*} -> (* -> *)
	 * @param {Function} fn The function to bind to context
	 * @param {Object} thisObj The context to bind `fn` to
	 * @return {Function} A function that will execute in the context of `thisObj`.
	 * @see R.partial
	 * @example
	 *
	 *      const log = R.bind(console.log, console);
	 *      R.pipe(R.assoc('a', 2), R.tap(log), R.assoc('a', 3))({a: 1}); //=> {a: 3}
	 *      // logs {a: 2}
	 * @symb R.bind(f, o)(a, b) = f.call(o, a, b)
	 */

	var bind =
	/*#__PURE__*/
	_curry2(function bind(fn, thisObj) {
	  return _arity(fn.length, function () {
	    return fn.apply(thisObj, arguments);
	  });
	});

	var bind$1 = bind;

	function _arrayReduce(xf, acc, list) {
	  var idx = 0;
	  var len = list.length;

	  while (idx < len) {
	    acc = xf['@@transducer/step'](acc, list[idx]);

	    if (acc && acc['@@transducer/reduced']) {
	      acc = acc['@@transducer/value'];
	      break;
	    }

	    idx += 1;
	  }

	  return xf['@@transducer/result'](acc);
	}

	function _iterableReduce(xf, acc, iter) {
	  var step = iter.next();

	  while (!step.done) {
	    acc = xf['@@transducer/step'](acc, step.value);

	    if (acc && acc['@@transducer/reduced']) {
	      acc = acc['@@transducer/value'];
	      break;
	    }

	    step = iter.next();
	  }

	  return xf['@@transducer/result'](acc);
	}

	function _methodReduce(xf, acc, obj, methodName) {
	  return xf['@@transducer/result'](obj[methodName](bind$1(xf['@@transducer/step'], xf), acc));
	}

	var symIterator = typeof Symbol !== 'undefined' ? Symbol.iterator : '@@iterator';
	function _reduce(fn, acc, list) {
	  if (typeof fn === 'function') {
	    fn = _xwrap(fn);
	  }

	  if (_isArrayLike$1(list)) {
	    return _arrayReduce(fn, acc, list);
	  }

	  if (typeof list['fantasy-land/reduce'] === 'function') {
	    return _methodReduce(fn, acc, list, 'fantasy-land/reduce');
	  }

	  if (list[symIterator] != null) {
	    return _iterableReduce(fn, acc, list[symIterator]());
	  }

	  if (typeof list.next === 'function') {
	    return _iterableReduce(fn, acc, list);
	  }

	  if (typeof list.reduce === 'function') {
	    return _methodReduce(fn, acc, list, 'reduce');
	  }

	  throw new TypeError('reduce: list must be array or iterable');
	}

	var XMap =
	/*#__PURE__*/
	function () {
	  function XMap(f, xf) {
	    this.xf = xf;
	    this.f = f;
	  }

	  XMap.prototype['@@transducer/init'] = _xfBase.init;
	  XMap.prototype['@@transducer/result'] = _xfBase.result;

	  XMap.prototype['@@transducer/step'] = function (result, input) {
	    return this.xf['@@transducer/step'](result, this.f(input));
	  };

	  return XMap;
	}();

	var _xmap =
	/*#__PURE__*/
	_curry2(function _xmap(f, xf) {
	  return new XMap(f, xf);
	});

	var _xmap$1 = _xmap;

	function _has(prop, obj) {
	  return Object.prototype.hasOwnProperty.call(obj, prop);
	}

	var toString$2 = Object.prototype.toString;

	var _isArguments =
	/*#__PURE__*/
	function () {
	  return toString$2.call(arguments) === '[object Arguments]' ? function _isArguments(x) {
	    return toString$2.call(x) === '[object Arguments]';
	  } : function _isArguments(x) {
	    return _has('callee', x);
	  };
	}();

	var _isArguments$1 = _isArguments;

	var hasEnumBug = !
	/*#__PURE__*/
	{
	  toString: null
	}.propertyIsEnumerable('toString');
	var nonEnumerableProps = ['constructor', 'valueOf', 'isPrototypeOf', 'toString', 'propertyIsEnumerable', 'hasOwnProperty', 'toLocaleString']; // Safari bug

	var hasArgsEnumBug =
	/*#__PURE__*/
	function () {

	  return arguments.propertyIsEnumerable('length');
	}();

	var contains = function contains(list, item) {
	  var idx = 0;

	  while (idx < list.length) {
	    if (list[idx] === item) {
	      return true;
	    }

	    idx += 1;
	  }

	  return false;
	};
	/**
	 * Returns a list containing the names of all the enumerable own properties of
	 * the supplied object.
	 * Note that the order of the output array is not guaranteed to be consistent
	 * across different JS platforms.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Object
	 * @sig {k: v} -> [k]
	 * @param {Object} obj The object to extract properties from
	 * @return {Array} An array of the object's own properties.
	 * @see R.keysIn, R.values
	 * @example
	 *
	 *      R.keys({a: 1, b: 2, c: 3}); //=> ['a', 'b', 'c']
	 */


	var keys = typeof Object.keys === 'function' && !hasArgsEnumBug ?
	/*#__PURE__*/
	_curry1(function keys(obj) {
	  return Object(obj) !== obj ? [] : Object.keys(obj);
	}) :
	/*#__PURE__*/
	_curry1(function keys(obj) {
	  if (Object(obj) !== obj) {
	    return [];
	  }

	  var prop, nIdx;
	  var ks = [];

	  var checkArgsLength = hasArgsEnumBug && _isArguments$1(obj);

	  for (prop in obj) {
	    if (_has(prop, obj) && (!checkArgsLength || prop !== 'length')) {
	      ks[ks.length] = prop;
	    }
	  }

	  if (hasEnumBug) {
	    nIdx = nonEnumerableProps.length - 1;

	    while (nIdx >= 0) {
	      prop = nonEnumerableProps[nIdx];

	      if (_has(prop, obj) && !contains(ks, prop)) {
	        ks[ks.length] = prop;
	      }

	      nIdx -= 1;
	    }
	  }

	  return ks;
	});
	var keys$1 = keys;

	/**
	 * Takes a function and
	 * a [functor](https://github.com/fantasyland/fantasy-land#functor),
	 * applies the function to each of the functor's values, and returns
	 * a functor of the same shape.
	 *
	 * Ramda provides suitable `map` implementations for `Array` and `Object`,
	 * so this function may be applied to `[1, 2, 3]` or `{x: 1, y: 2, z: 3}`.
	 *
	 * Dispatches to the `map` method of the second argument, if present.
	 *
	 * Acts as a transducer if a transformer is given in list position.
	 *
	 * Also treats functions as functors and will compose them together.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig Functor f => (a -> b) -> f a -> f b
	 * @param {Function} fn The function to be called on every element of the input `list`.
	 * @param {Array} list The list to be iterated over.
	 * @return {Array} The new list.
	 * @see R.transduce, R.addIndex
	 * @example
	 *
	 *      const double = x => x * 2;
	 *
	 *      R.map(double, [1, 2, 3]); //=> [2, 4, 6]
	 *
	 *      R.map(double, {x: 1, y: 2, z: 3}); //=> {x: 2, y: 4, z: 6}
	 * @symb R.map(f, [a, b]) = [f(a), f(b)]
	 * @symb R.map(f, { x: a, y: b }) = { x: f(a), y: f(b) }
	 * @symb R.map(f, functor_o) = functor_o.map(f)
	 */

	var map =
	/*#__PURE__*/
	_curry2(
	/*#__PURE__*/
	_dispatchable(['fantasy-land/map', 'map'], _xmap$1, function map(fn, functor) {
	  switch (Object.prototype.toString.call(functor)) {
	    case '[object Function]':
	      return curryN$1(functor.length, function () {
	        return fn.call(this, functor.apply(this, arguments));
	      });

	    case '[object Object]':
	      return _reduce(function (acc, key) {
	        acc[key] = fn(functor[key]);
	        return acc;
	      }, {}, keys$1(functor));

	    default:
	      return _map(fn, functor);
	  }
	}));

	var map$1 = map;

	/**
	 * Determine if the passed argument is an integer.
	 *
	 * @private
	 * @param {*} n
	 * @category Type
	 * @return {Boolean}
	 */
	var _isInteger = Number.isInteger || function _isInteger(n) {
	  return n << 0 === n;
	};

	/**
	 * Returns the nth element of the given list or string. If n is negative the
	 * element at index length + n is returned.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig Number -> [a] -> a | Undefined
	 * @sig Number -> String -> String
	 * @param {Number} offset
	 * @param {*} list
	 * @return {*}
	 * @example
	 *
	 *      const list = ['foo', 'bar', 'baz', 'quux'];
	 *      R.nth(1, list); //=> 'bar'
	 *      R.nth(-1, list); //=> 'quux'
	 *      R.nth(-99, list); //=> undefined
	 *
	 *      R.nth(2, 'abc'); //=> 'c'
	 *      R.nth(3, 'abc'); //=> ''
	 * @symb R.nth(-1, [a, b, c]) = c
	 * @symb R.nth(0, [a, b, c]) = a
	 * @symb R.nth(1, [a, b, c]) = b
	 */

	var nth =
	/*#__PURE__*/
	_curry2(function nth(offset, list) {
	  var idx = offset < 0 ? list.length + offset : offset;
	  return _isString(list) ? list.charAt(idx) : list[idx];
	});

	var nth$1 = nth;

	/**
	 * Retrieves the values at given paths of an object.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.27.1
	 * @category Object
	 * @typedefn Idx = [String | Int]
	 * @sig [Idx] -> {a} -> [a | Undefined]
	 * @param {Array} pathsArray The array of paths to be fetched.
	 * @param {Object} obj The object to retrieve the nested properties from.
	 * @return {Array} A list consisting of values at paths specified by "pathsArray".
	 * @see R.path
	 * @example
	 *
	 *      R.paths([['a', 'b'], ['p', 0, 'q']], {a: {b: 2}, p: [{q: 3}]}); //=> [2, 3]
	 *      R.paths([['a', 'b'], ['p', 'r']], {a: {b: 2}, p: [{q: 3}]}); //=> [2, undefined]
	 */

	var paths =
	/*#__PURE__*/
	_curry2(function paths(pathsArray, obj) {
	  return pathsArray.map(function (paths) {
	    var val = obj;
	    var idx = 0;
	    var p;

	    while (idx < paths.length) {
	      if (val == null) {
	        return;
	      }

	      p = paths[idx];
	      val = _isInteger(p) ? nth$1(p, val) : val[p];
	      idx += 1;
	    }

	    return val;
	  });
	});

	var paths$1 = paths;

	/**
	 * Retrieve the value at a given path.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.2.0
	 * @category Object
	 * @typedefn Idx = String | Int
	 * @sig [Idx] -> {a} -> a | Undefined
	 * @param {Array} path The path to use.
	 * @param {Object} obj The object to retrieve the nested property from.
	 * @return {*} The data at `path`.
	 * @see R.prop, R.nth
	 * @example
	 *
	 *      R.path(['a', 'b'], {a: {b: 2}}); //=> 2
	 *      R.path(['a', 'b'], {c: {b: 2}}); //=> undefined
	 *      R.path(['a', 'b', 0], {a: {b: [1, 2, 3]}}); //=> 1
	 *      R.path(['a', 'b', -2], {a: {b: [1, 2, 3]}}); //=> 2
	 */

	var path =
	/*#__PURE__*/
	_curry2(function path(pathAr, obj) {
	  return paths$1([pathAr], obj)[0];
	});

	var path$1 = path;

	/**
	 * Returns a function that when supplied an object returns the indicated
	 * property of that object, if it exists.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Object
	 * @typedefn Idx = String | Int
	 * @sig Idx -> {s: a} -> a | Undefined
	 * @param {String|Number} p The property name or array index
	 * @param {Object} obj The object to query
	 * @return {*} The value at `obj.p`.
	 * @see R.path, R.nth
	 * @example
	 *
	 *      R.prop('x', {x: 100}); //=> 100
	 *      R.prop('x', {}); //=> undefined
	 *      R.prop(0, [100]); //=> 100
	 *      R.compose(R.inc, R.prop('x'))({ x: 3 }) //=> 4
	 */

	var prop =
	/*#__PURE__*/
	_curry2(function prop(p, obj) {
	  return path$1([p], obj);
	});

	var prop$1 = prop;

	/**
	 * Returns a single item by iterating through the list, successively calling
	 * the iterator function and passing it an accumulator value and the current
	 * value from the array, and then passing the result to the next call.
	 *
	 * The iterator function receives two values: *(acc, value)*. It may use
	 * [`R.reduced`](#reduced) to shortcut the iteration.
	 *
	 * The arguments' order of [`reduceRight`](#reduceRight)'s iterator function
	 * is *(value, acc)*.
	 *
	 * Note: `R.reduce` does not skip deleted or unassigned indices (sparse
	 * arrays), unlike the native `Array.prototype.reduce` method. For more details
	 * on this behavior, see:
	 * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/reduce#Description
	 *
	 * Dispatches to the `reduce` method of the third argument, if present. When
	 * doing so, it is up to the user to handle the [`R.reduced`](#reduced)
	 * shortcuting, as this is not implemented by `reduce`.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig ((a, b) -> a) -> a -> [b] -> a
	 * @param {Function} fn The iterator function. Receives two values, the accumulator and the
	 *        current element from the array.
	 * @param {*} acc The accumulator value.
	 * @param {Array} list The list to iterate over.
	 * @return {*} The final, accumulated value.
	 * @see R.reduced, R.addIndex, R.reduceRight
	 * @example
	 *
	 *      R.reduce(R.subtract, 0, [1, 2, 3, 4]) // => ((((0 - 1) - 2) - 3) - 4) = -10
	 *      //          -               -10
	 *      //         / \              / \
	 *      //        -   4           -6   4
	 *      //       / \              / \
	 *      //      -   3   ==>     -3   3
	 *      //     / \              / \
	 *      //    -   2           -1   2
	 *      //   / \              / \
	 *      //  0   1            0   1
	 *
	 * @symb R.reduce(f, a, [b, c, d]) = f(f(f(a, b), c), d)
	 */

	var reduce =
	/*#__PURE__*/
	_curry3(_reduce);

	var reduce$1 = reduce;

	/**
	 * ap applies a list of functions to a list of values.
	 *
	 * Dispatches to the `ap` method of the second argument, if present. Also
	 * treats curried functions as applicatives.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.3.0
	 * @category Function
	 * @sig [a -> b] -> [a] -> [b]
	 * @sig Apply f => f (a -> b) -> f a -> f b
	 * @sig (r -> a -> b) -> (r -> a) -> (r -> b)
	 * @param {*} applyF
	 * @param {*} applyX
	 * @return {*}
	 * @example
	 *
	 *      R.ap([R.multiply(2), R.add(3)], [1,2,3]); //=> [2, 4, 6, 4, 5, 6]
	 *      R.ap([R.concat('tasty '), R.toUpper], ['pizza', 'salad']); //=> ["tasty pizza", "tasty salad", "PIZZA", "SALAD"]
	 *
	 *      // R.ap can also be used as S combinator
	 *      // when only two functions are passed
	 *      R.ap(R.concat, R.toUpper)('Ramda') //=> 'RamdaRAMDA'
	 * @symb R.ap([f, g], [a, b]) = [f(a), f(b), g(a), g(b)]
	 */

	var ap =
	/*#__PURE__*/
	_curry2(function ap(applyF, applyX) {
	  return typeof applyX['fantasy-land/ap'] === 'function' ? applyX['fantasy-land/ap'](applyF) : typeof applyF.ap === 'function' ? applyF.ap(applyX) : typeof applyF === 'function' ? function (x) {
	    return applyF(x)(applyX(x));
	  } : _reduce(function (acc, f) {
	    return _concat(acc, map$1(f, applyX));
	  }, [], applyF);
	});

	var ap$1 = ap;

	/**
	 * Returns a list of all the enumerable own properties of the supplied object.
	 * Note that the order of the output array is not guaranteed across different
	 * JS platforms.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Object
	 * @sig {k: v} -> [v]
	 * @param {Object} obj The object to extract values from
	 * @return {Array} An array of the values of the object's own properties.
	 * @see R.valuesIn, R.keys
	 * @example
	 *
	 *      R.values({a: 1, b: 2, c: 3}); //=> [1, 2, 3]
	 */

	var values =
	/*#__PURE__*/
	_curry1(function values(obj) {
	  var props = keys$1(obj);
	  var len = props.length;
	  var vals = [];
	  var idx = 0;

	  while (idx < len) {
	    vals[idx] = obj[props[idx]];
	    idx += 1;
	  }

	  return vals;
	});

	var values$1 = values;

	/**
	 * Checks if the input value is `null` or `undefined`.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.9.0
	 * @category Type
	 * @sig * -> Boolean
	 * @param {*} x The value to test.
	 * @return {Boolean} `true` if `x` is `undefined` or `null`, otherwise `false`.
	 * @example
	 *
	 *      R.isNil(null); //=> true
	 *      R.isNil(undefined); //=> true
	 *      R.isNil(0); //=> false
	 *      R.isNil([]); //=> false
	 */

	var isNil =
	/*#__PURE__*/
	_curry1(function isNil(x) {
	  return x == null;
	});

	var isNil$1 = isNil;

	function _isFunction(x) {
	  var type = Object.prototype.toString.call(x);
	  return type === '[object Function]' || type === '[object AsyncFunction]' || type === '[object GeneratorFunction]' || type === '[object AsyncGeneratorFunction]';
	}

	/**
	 * "lifts" a function to be the specified arity, so that it may "map over" that
	 * many lists, Functions or other objects that satisfy the [FantasyLand Apply spec](https://github.com/fantasyland/fantasy-land#apply).
	 *
	 * @func
	 * @memberOf R
	 * @since v0.7.0
	 * @category Function
	 * @sig Number -> (*... -> *) -> ([*]... -> [*])
	 * @param {Function} fn The function to lift into higher context
	 * @return {Function} The lifted function.
	 * @see R.lift, R.ap
	 * @example
	 *
	 *      const madd3 = R.liftN(3, (...args) => R.sum(args));
	 *      madd3([1,2,3], [1,2,3], [1]); //=> [3, 4, 5, 4, 5, 6, 5, 6, 7]
	 */

	var liftN =
	/*#__PURE__*/
	_curry2(function liftN(arity, fn) {
	  var lifted = curryN$1(arity, fn);
	  return curryN$1(arity, function () {
	    return _reduce(ap$1, map$1(lifted, arguments[0]), Array.prototype.slice.call(arguments, 1));
	  });
	});

	var liftN$1 = liftN;

	/**
	 * "lifts" a function of arity > 1 so that it may "map over" a list, Function or other
	 * object that satisfies the [FantasyLand Apply spec](https://github.com/fantasyland/fantasy-land#apply).
	 *
	 * @func
	 * @memberOf R
	 * @since v0.7.0
	 * @category Function
	 * @sig (*... -> *) -> ([*]... -> [*])
	 * @param {Function} fn The function to lift into higher context
	 * @return {Function} The lifted function.
	 * @see R.liftN
	 * @example
	 *
	 *      const madd3 = R.lift((a, b, c) => a + b + c);
	 *
	 *      madd3([1,2,3], [1,2,3], [1]); //=> [3, 4, 5, 4, 5, 6, 5, 6, 7]
	 *
	 *      const madd5 = R.lift((a, b, c, d, e) => a + b + c + d + e);
	 *
	 *      madd5([1,2], [3], [4, 5], [6], [7, 8]); //=> [21, 22, 22, 23, 22, 23, 23, 24]
	 */

	var lift =
	/*#__PURE__*/
	_curry1(function lift(fn) {
	  return liftN$1(fn.length, fn);
	});

	var lift$1 = lift;

	/**
	 * Returns a curried equivalent of the provided function. The curried function
	 * has two unusual capabilities. First, its arguments needn't be provided one
	 * at a time. If `f` is a ternary function and `g` is `R.curry(f)`, the
	 * following are equivalent:
	 *
	 *   - `g(1)(2)(3)`
	 *   - `g(1)(2, 3)`
	 *   - `g(1, 2)(3)`
	 *   - `g(1, 2, 3)`
	 *
	 * Secondly, the special placeholder value [`R.__`](#__) may be used to specify
	 * "gaps", allowing partial application of any combination of arguments,
	 * regardless of their positions. If `g` is as above and `_` is [`R.__`](#__),
	 * the following are equivalent:
	 *
	 *   - `g(1, 2, 3)`
	 *   - `g(_, 2, 3)(1)`
	 *   - `g(_, _, 3)(1)(2)`
	 *   - `g(_, _, 3)(1, 2)`
	 *   - `g(_, 2)(1)(3)`
	 *   - `g(_, 2)(1, 3)`
	 *   - `g(_, 2)(_, 3)(1)`
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Function
	 * @sig (* -> a) -> (* -> a)
	 * @param {Function} fn The function to curry.
	 * @return {Function} A new, curried function.
	 * @see R.curryN, R.partial
	 * @example
	 *
	 *      const addFourNumbers = (a, b, c, d) => a + b + c + d;
	 *
	 *      const curriedAddFourNumbers = R.curry(addFourNumbers);
	 *      const f = curriedAddFourNumbers(1, 2);
	 *      const g = f(3);
	 *      g(4); //=> 10
	 */

	var curry =
	/*#__PURE__*/
	_curry1(function curry(fn) {
	  return curryN$1(fn.length, fn);
	});

	var curry$1 = curry;

	/**
	 * `_makeFlat` is a helper function that returns a one-level or fully recursive
	 * function based on the flag passed in.
	 *
	 * @private
	 */

	function _makeFlat(recursive) {
	  return function flatt(list) {
	    var value, jlen, j;
	    var result = [];
	    var idx = 0;
	    var ilen = list.length;

	    while (idx < ilen) {
	      if (_isArrayLike$1(list[idx])) {
	        value = flatt(list[idx]) ;
	        j = 0;
	        jlen = value.length;

	        while (j < jlen) {
	          result[result.length] = value[j];
	          j += 1;
	        }
	      } else {
	        result[result.length] = list[idx];
	      }

	      idx += 1;
	    }

	    return result;
	  };
	}

	/**
	 * Gives a single-word string description of the (native) type of a value,
	 * returning such answers as 'Object', 'Number', 'Array', or 'Null'. Does not
	 * attempt to distinguish user Object types any further, reporting them all as
	 * 'Object'.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.8.0
	 * @category Type
	 * @sig (* -> {*}) -> String
	 * @param {*} val The value to test
	 * @return {String}
	 * @example
	 *
	 *      R.type({}); //=> "Object"
	 *      R.type(1); //=> "Number"
	 *      R.type(false); //=> "Boolean"
	 *      R.type('s'); //=> "String"
	 *      R.type(null); //=> "Null"
	 *      R.type([]); //=> "Array"
	 *      R.type(/[A-z]/); //=> "RegExp"
	 *      R.type(() => {}); //=> "Function"
	 *      R.type(undefined); //=> "Undefined"
	 */

	var type =
	/*#__PURE__*/
	_curry1(function type(val) {
	  return val === null ? 'Null' : val === undefined ? 'Undefined' : Object.prototype.toString.call(val).slice(8, -1);
	});

	var type$1 = type;

	/**
	 * A function that returns the `!` of its argument. It will return `true` when
	 * passed false-y value, and `false` when passed a truth-y one.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Logic
	 * @sig * -> Boolean
	 * @param {*} a any value
	 * @return {Boolean} the logical inverse of passed argument.
	 * @see R.complement
	 * @example
	 *
	 *      R.not(true); //=> false
	 *      R.not(false); //=> true
	 *      R.not(0); //=> true
	 *      R.not(1); //=> false
	 */

	var not =
	/*#__PURE__*/
	_curry1(function not(a) {
	  return !a;
	});

	var not$1 = not;

	/**
	 * Takes a function `f` and returns a function `g` such that if called with the same arguments
	 * when `f` returns a "truthy" value, `g` returns `false` and when `f` returns a "falsy" value `g` returns `true`.
	 *
	 * `R.complement` may be applied to any functor
	 *
	 * @func
	 * @memberOf R
	 * @since v0.12.0
	 * @category Logic
	 * @sig (*... -> *) -> (*... -> Boolean)
	 * @param {Function} f
	 * @return {Function}
	 * @see R.not
	 * @example
	 *
	 *      const isNotNil = R.complement(R.isNil);
	 *      isNil(null); //=> true
	 *      isNotNil(null); //=> false
	 *      isNil(7); //=> false
	 *      isNotNil(7); //=> true
	 */

	var complement =
	/*#__PURE__*/
	lift$1(not$1);
	var complement$1 = complement;

	function _pipe(f, g) {
	  return function () {
	    return g.call(this, f.apply(this, arguments));
	  };
	}

	/**
	 * This checks whether a function has a [methodname] function. If it isn't an
	 * array it will execute that function otherwise it will default to the ramda
	 * implementation.
	 *
	 * @private
	 * @param {Function} fn ramda implemtation
	 * @param {String} methodname property to check for a custom implementation
	 * @return {Object} Whatever the return value of the method is.
	 */

	function _checkForMethod(methodname, fn) {
	  return function () {
	    var length = arguments.length;

	    if (length === 0) {
	      return fn();
	    }

	    var obj = arguments[length - 1];
	    return _isArray(obj) || typeof obj[methodname] !== 'function' ? fn.apply(this, arguments) : obj[methodname].apply(obj, Array.prototype.slice.call(arguments, 0, length - 1));
	  };
	}

	/**
	 * Returns the elements of the given list or string (or object with a `slice`
	 * method) from `fromIndex` (inclusive) to `toIndex` (exclusive).
	 *
	 * Dispatches to the `slice` method of the third argument, if present.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.4
	 * @category List
	 * @sig Number -> Number -> [a] -> [a]
	 * @sig Number -> Number -> String -> String
	 * @param {Number} fromIndex The start index (inclusive).
	 * @param {Number} toIndex The end index (exclusive).
	 * @param {*} list
	 * @return {*}
	 * @example
	 *
	 *      R.slice(1, 3, ['a', 'b', 'c', 'd']);        //=> ['b', 'c']
	 *      R.slice(1, Infinity, ['a', 'b', 'c', 'd']); //=> ['b', 'c', 'd']
	 *      R.slice(0, -1, ['a', 'b', 'c', 'd']);       //=> ['a', 'b', 'c']
	 *      R.slice(-3, -1, ['a', 'b', 'c', 'd']);      //=> ['b', 'c']
	 *      R.slice(0, 3, 'ramda');                     //=> 'ram'
	 */

	var slice =
	/*#__PURE__*/
	_curry3(
	/*#__PURE__*/
	_checkForMethod('slice', function slice(fromIndex, toIndex, list) {
	  return Array.prototype.slice.call(list, fromIndex, toIndex);
	}));

	var slice$1 = slice;

	/**
	 * Returns all but the first element of the given list or string (or object
	 * with a `tail` method).
	 *
	 * Dispatches to the `slice` method of the first argument, if present.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig [a] -> [a]
	 * @sig String -> String
	 * @param {*} list
	 * @return {*}
	 * @see R.head, R.init, R.last
	 * @example
	 *
	 *      R.tail([1, 2, 3]);  //=> [2, 3]
	 *      R.tail([1, 2]);     //=> [2]
	 *      R.tail([1]);        //=> []
	 *      R.tail([]);         //=> []
	 *
	 *      R.tail('abc');  //=> 'bc'
	 *      R.tail('ab');   //=> 'b'
	 *      R.tail('a');    //=> ''
	 *      R.tail('');     //=> ''
	 */

	var tail =
	/*#__PURE__*/
	_curry1(
	/*#__PURE__*/
	_checkForMethod('tail',
	/*#__PURE__*/
	slice$1(1, Infinity)));

	var tail$1 = tail;

	/**
	 * Performs left-to-right function composition. The first argument may have
	 * any arity; the remaining arguments must be unary.
	 *
	 * In some libraries this function is named `sequence`.
	 *
	 * **Note:** The result of pipe is not automatically curried.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Function
	 * @sig (((a, b, ..., n) -> o), (o -> p), ..., (x -> y), (y -> z)) -> ((a, b, ..., n) -> z)
	 * @param {...Function} functions
	 * @return {Function}
	 * @see R.compose
	 * @example
	 *
	 *      const f = R.pipe(Math.pow, R.negate, R.inc);
	 *
	 *      f(3, 4); // -(3^4) + 1
	 * @symb R.pipe(f, g, h)(a, b) = h(g(f(a, b)))
	 */

	function pipe() {
	  if (arguments.length === 0) {
	    throw new Error('pipe requires at least one argument');
	  }

	  return _arity(arguments[0].length, reduce$1(_pipe, arguments[0], tail$1(arguments)));
	}

	/**
	 * Returns a new list or string with the elements or characters in reverse
	 * order.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig [a] -> [a]
	 * @sig String -> String
	 * @param {Array|String} list
	 * @return {Array|String}
	 * @example
	 *
	 *      R.reverse([1, 2, 3]);  //=> [3, 2, 1]
	 *      R.reverse([1, 2]);     //=> [2, 1]
	 *      R.reverse([1]);        //=> [1]
	 *      R.reverse([]);         //=> []
	 *
	 *      R.reverse('abc');      //=> 'cba'
	 *      R.reverse('ab');       //=> 'ba'
	 *      R.reverse('a');        //=> 'a'
	 *      R.reverse('');         //=> ''
	 */

	var reverse =
	/*#__PURE__*/
	_curry1(function reverse(list) {
	  return _isString(list) ? list.split('').reverse().join('') : Array.prototype.slice.call(list, 0).reverse();
	});

	var reverse$1 = reverse;

	/**
	 * Performs right-to-left function composition. The last argument may have
	 * any arity; the remaining arguments must be unary.
	 *
	 * **Note:** The result of compose is not automatically curried.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Function
	 * @sig ((y -> z), (x -> y), ..., (o -> p), ((a, b, ..., n) -> o)) -> ((a, b, ..., n) -> z)
	 * @param {...Function} ...functions The functions to compose
	 * @return {Function}
	 * @see R.pipe
	 * @example
	 *
	 *      const classyGreeting = (firstName, lastName) => "The name's " + lastName + ", " + firstName + " " + lastName
	 *      const yellGreeting = R.compose(R.toUpper, classyGreeting);
	 *      yellGreeting('James', 'Bond'); //=> "THE NAME'S BOND, JAMES BOND"
	 *
	 *      R.compose(Math.abs, R.add(1), R.multiply(2))(-4) //=> 7
	 *
	 * @symb R.compose(f, g, h)(a, b) = f(g(h(a, b)))
	 */

	function compose() {
	  if (arguments.length === 0) {
	    throw new Error('compose requires at least one argument');
	  }

	  return pipe.apply(this, reverse$1(arguments));
	}

	function _identity(x) {
	  return x;
	}

	/**
	 * A function that does nothing but return the parameter supplied to it. Good
	 * as a default or placeholder function.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Function
	 * @sig a -> a
	 * @param {*} x The value to return.
	 * @return {*} The input value, `x`.
	 * @example
	 *
	 *      R.identity(1); //=> 1
	 *
	 *      const obj = {};
	 *      R.identity(obj) === obj; //=> true
	 * @symb R.identity(a) = a
	 */

	var identity =
	/*#__PURE__*/
	_curry1(_identity);

	var identity$1 = identity;

	function _arrayFromIterator(iter) {
	  var list = [];
	  var next;

	  while (!(next = iter.next()).done) {
	    list.push(next.value);
	  }

	  return list;
	}

	function _includesWith(pred, x, list) {
	  var idx = 0;
	  var len = list.length;

	  while (idx < len) {
	    if (pred(x, list[idx])) {
	      return true;
	    }

	    idx += 1;
	  }

	  return false;
	}

	function _functionName(f) {
	  // String(x => x) evaluates to "x => x", so the pattern may not match.
	  var match = String(f).match(/^function (\w*)/);
	  return match == null ? '' : match[1];
	}

	// Based on https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
	function _objectIs(a, b) {
	  // SameValue algorithm
	  if (a === b) {
	    // Steps 1-5, 7-10
	    // Steps 6.b-6.e: +0 != -0
	    return a !== 0 || 1 / a === 1 / b;
	  } else {
	    // Step 6.a: NaN == NaN
	    return a !== a && b !== b;
	  }
	}

	var _objectIs$1 = typeof Object.is === 'function' ? Object.is : _objectIs;

	/**
	 * private _uniqContentEquals function.
	 * That function is checking equality of 2 iterator contents with 2 assumptions
	 * - iterators lengths are the same
	 * - iterators values are unique
	 *
	 * false-positive result will be returned for comparision of, e.g.
	 * - [1,2,3] and [1,2,3,4]
	 * - [1,1,1] and [1,2,3]
	 * */

	function _uniqContentEquals(aIterator, bIterator, stackA, stackB) {
	  var a = _arrayFromIterator(aIterator);

	  var b = _arrayFromIterator(bIterator);

	  function eq(_a, _b) {
	    return _equals(_a, _b, stackA.slice(), stackB.slice());
	  } // if *a* array contains any element that is not included in *b*


	  return !_includesWith(function (b, aItem) {
	    return !_includesWith(eq, aItem, b);
	  }, b, a);
	}

	function _equals(a, b, stackA, stackB) {
	  if (_objectIs$1(a, b)) {
	    return true;
	  }

	  var typeA = type$1(a);

	  if (typeA !== type$1(b)) {
	    return false;
	  }

	  if (a == null || b == null) {
	    return false;
	  }

	  if (typeof a['fantasy-land/equals'] === 'function' || typeof b['fantasy-land/equals'] === 'function') {
	    return typeof a['fantasy-land/equals'] === 'function' && a['fantasy-land/equals'](b) && typeof b['fantasy-land/equals'] === 'function' && b['fantasy-land/equals'](a);
	  }

	  if (typeof a.equals === 'function' || typeof b.equals === 'function') {
	    return typeof a.equals === 'function' && a.equals(b) && typeof b.equals === 'function' && b.equals(a);
	  }

	  switch (typeA) {
	    case 'Arguments':
	    case 'Array':
	    case 'Object':
	      if (typeof a.constructor === 'function' && _functionName(a.constructor) === 'Promise') {
	        return a === b;
	      }

	      break;

	    case 'Boolean':
	    case 'Number':
	    case 'String':
	      if (!(typeof a === typeof b && _objectIs$1(a.valueOf(), b.valueOf()))) {
	        return false;
	      }

	      break;

	    case 'Date':
	      if (!_objectIs$1(a.valueOf(), b.valueOf())) {
	        return false;
	      }

	      break;

	    case 'Error':
	      return a.name === b.name && a.message === b.message;

	    case 'RegExp':
	      if (!(a.source === b.source && a.global === b.global && a.ignoreCase === b.ignoreCase && a.multiline === b.multiline && a.sticky === b.sticky && a.unicode === b.unicode)) {
	        return false;
	      }

	      break;
	  }

	  var idx = stackA.length - 1;

	  while (idx >= 0) {
	    if (stackA[idx] === a) {
	      return stackB[idx] === b;
	    }

	    idx -= 1;
	  }

	  switch (typeA) {
	    case 'Map':
	      if (a.size !== b.size) {
	        return false;
	      }

	      return _uniqContentEquals(a.entries(), b.entries(), stackA.concat([a]), stackB.concat([b]));

	    case 'Set':
	      if (a.size !== b.size) {
	        return false;
	      }

	      return _uniqContentEquals(a.values(), b.values(), stackA.concat([a]), stackB.concat([b]));

	    case 'Arguments':
	    case 'Array':
	    case 'Object':
	    case 'Boolean':
	    case 'Number':
	    case 'String':
	    case 'Date':
	    case 'Error':
	    case 'RegExp':
	    case 'Int8Array':
	    case 'Uint8Array':
	    case 'Uint8ClampedArray':
	    case 'Int16Array':
	    case 'Uint16Array':
	    case 'Int32Array':
	    case 'Uint32Array':
	    case 'Float32Array':
	    case 'Float64Array':
	    case 'ArrayBuffer':
	      break;

	    default:
	      // Values of other types are only equal if identical.
	      return false;
	  }

	  var keysA = keys$1(a);

	  if (keysA.length !== keys$1(b).length) {
	    return false;
	  }

	  var extendedStackA = stackA.concat([a]);
	  var extendedStackB = stackB.concat([b]);
	  idx = keysA.length - 1;

	  while (idx >= 0) {
	    var key = keysA[idx];

	    if (!(_has(key, b) && _equals(b[key], a[key], extendedStackA, extendedStackB))) {
	      return false;
	    }

	    idx -= 1;
	  }

	  return true;
	}

	/**
	 * Returns `true` if its arguments are equivalent, `false` otherwise. Handles
	 * cyclical data structures.
	 *
	 * Dispatches symmetrically to the `equals` methods of both arguments, if
	 * present.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.15.0
	 * @category Relation
	 * @sig a -> b -> Boolean
	 * @param {*} a
	 * @param {*} b
	 * @return {Boolean}
	 * @example
	 *
	 *      R.equals(1, 1); //=> true
	 *      R.equals(1, '1'); //=> false
	 *      R.equals([1, 2, 3], [1, 2, 3]); //=> true
	 *
	 *      const a = {}; a.v = a;
	 *      const b = {}; b.v = b;
	 *      R.equals(a, b); //=> true
	 */

	var equals =
	/*#__PURE__*/
	_curry2(function equals(a, b) {
	  return _equals(a, b, [], []);
	});

	var equals$1 = equals;

	function _indexOf(list, a, idx) {
	  var inf, item; // Array.prototype.indexOf doesn't exist below IE9

	  if (typeof list.indexOf === 'function') {
	    switch (typeof a) {
	      case 'number':
	        if (a === 0) {
	          // manually crawl the list to distinguish between +0 and -0
	          inf = 1 / a;

	          while (idx < list.length) {
	            item = list[idx];

	            if (item === 0 && 1 / item === inf) {
	              return idx;
	            }

	            idx += 1;
	          }

	          return -1;
	        } else if (a !== a) {
	          // NaN
	          while (idx < list.length) {
	            item = list[idx];

	            if (typeof item === 'number' && item !== item) {
	              return idx;
	            }

	            idx += 1;
	          }

	          return -1;
	        } // non-zero numbers can utilise Set


	        return list.indexOf(a, idx);
	      // all these types can utilise Set

	      case 'string':
	      case 'boolean':
	      case 'function':
	      case 'undefined':
	        return list.indexOf(a, idx);

	      case 'object':
	        if (a === null) {
	          // null can utilise Set
	          return list.indexOf(a, idx);
	        }

	    }
	  } // anything else not covered above, defer to R.equals


	  while (idx < list.length) {
	    if (equals$1(list[idx], a)) {
	      return idx;
	    }

	    idx += 1;
	  }

	  return -1;
	}

	function _includes(a, list) {
	  return _indexOf(list, a, 0) >= 0;
	}

	function _quote(s) {
	  var escaped = s.replace(/\\/g, '\\\\').replace(/[\b]/g, '\\b') // \b matches word boundary; [\b] matches backspace
	  .replace(/\f/g, '\\f').replace(/\n/g, '\\n').replace(/\r/g, '\\r').replace(/\t/g, '\\t').replace(/\v/g, '\\v').replace(/\0/g, '\\0');
	  return '"' + escaped.replace(/"/g, '\\"') + '"';
	}

	/**
	 * Polyfill from <https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/toISOString>.
	 */
	var pad = function pad(n) {
	  return (n < 10 ? '0' : '') + n;
	};

	var _toISOString = typeof Date.prototype.toISOString === 'function' ? function _toISOString(d) {
	  return d.toISOString();
	} : function _toISOString(d) {
	  return d.getUTCFullYear() + '-' + pad(d.getUTCMonth() + 1) + '-' + pad(d.getUTCDate()) + 'T' + pad(d.getUTCHours()) + ':' + pad(d.getUTCMinutes()) + ':' + pad(d.getUTCSeconds()) + '.' + (d.getUTCMilliseconds() / 1000).toFixed(3).slice(2, 5) + 'Z';
	};

	var _toISOString$1 = _toISOString;

	function _complement(f) {
	  return function () {
	    return !f.apply(this, arguments);
	  };
	}

	function _filter(fn, list) {
	  var idx = 0;
	  var len = list.length;
	  var result = [];

	  while (idx < len) {
	    if (fn(list[idx])) {
	      result[result.length] = list[idx];
	    }

	    idx += 1;
	  }

	  return result;
	}

	function _isObject(x) {
	  return Object.prototype.toString.call(x) === '[object Object]';
	}

	var XFilter =
	/*#__PURE__*/
	function () {
	  function XFilter(f, xf) {
	    this.xf = xf;
	    this.f = f;
	  }

	  XFilter.prototype['@@transducer/init'] = _xfBase.init;
	  XFilter.prototype['@@transducer/result'] = _xfBase.result;

	  XFilter.prototype['@@transducer/step'] = function (result, input) {
	    return this.f(input) ? this.xf['@@transducer/step'](result, input) : result;
	  };

	  return XFilter;
	}();

	var _xfilter =
	/*#__PURE__*/
	_curry2(function _xfilter(f, xf) {
	  return new XFilter(f, xf);
	});

	var _xfilter$1 = _xfilter;

	/**
	 * Takes a predicate and a `Filterable`, and returns a new filterable of the
	 * same type containing the members of the given filterable which satisfy the
	 * given predicate. Filterable objects include plain objects or any object
	 * that has a filter method such as `Array`.
	 *
	 * Dispatches to the `filter` method of the second argument, if present.
	 *
	 * Acts as a transducer if a transformer is given in list position.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig Filterable f => (a -> Boolean) -> f a -> f a
	 * @param {Function} pred
	 * @param {Array} filterable
	 * @return {Array} Filterable
	 * @see R.reject, R.transduce, R.addIndex
	 * @example
	 *
	 *      const isEven = n => n % 2 === 0;
	 *
	 *      R.filter(isEven, [1, 2, 3, 4]); //=> [2, 4]
	 *
	 *      R.filter(isEven, {a: 1, b: 2, c: 3, d: 4}); //=> {b: 2, d: 4}
	 */

	var filter =
	/*#__PURE__*/
	_curry2(
	/*#__PURE__*/
	_dispatchable(['filter'], _xfilter$1, function (pred, filterable) {
	  return _isObject(filterable) ? _reduce(function (acc, key) {
	    if (pred(filterable[key])) {
	      acc[key] = filterable[key];
	    }

	    return acc;
	  }, {}, keys$1(filterable)) : // else
	  _filter(pred, filterable);
	}));

	var filter$1 = filter;

	/**
	 * The complement of [`filter`](#filter).
	 *
	 * Acts as a transducer if a transformer is given in list position. Filterable
	 * objects include plain objects or any object that has a filter method such
	 * as `Array`.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig Filterable f => (a -> Boolean) -> f a -> f a
	 * @param {Function} pred
	 * @param {Array} filterable
	 * @return {Array}
	 * @see R.filter, R.transduce, R.addIndex
	 * @example
	 *
	 *      const isOdd = (n) => n % 2 === 1;
	 *
	 *      R.reject(isOdd, [1, 2, 3, 4]); //=> [2, 4]
	 *
	 *      R.reject(isOdd, {a: 1, b: 2, c: 3, d: 4}); //=> {b: 2, d: 4}
	 */

	var reject =
	/*#__PURE__*/
	_curry2(function reject(pred, filterable) {
	  return filter$1(_complement(pred), filterable);
	});

	var reject$1 = reject;

	function _toString(x, seen) {
	  var recur = function recur(y) {
	    var xs = seen.concat([x]);
	    return _includes(y, xs) ? '<Circular>' : _toString(y, xs);
	  }; //  mapPairs :: (Object, [String]) -> [String]


	  var mapPairs = function (obj, keys) {
	    return _map(function (k) {
	      return _quote(k) + ': ' + recur(obj[k]);
	    }, keys.slice().sort());
	  };

	  switch (Object.prototype.toString.call(x)) {
	    case '[object Arguments]':
	      return '(function() { return arguments; }(' + _map(recur, x).join(', ') + '))';

	    case '[object Array]':
	      return '[' + _map(recur, x).concat(mapPairs(x, reject$1(function (k) {
	        return /^\d+$/.test(k);
	      }, keys$1(x)))).join(', ') + ']';

	    case '[object Boolean]':
	      return typeof x === 'object' ? 'new Boolean(' + recur(x.valueOf()) + ')' : x.toString();

	    case '[object Date]':
	      return 'new Date(' + (isNaN(x.valueOf()) ? recur(NaN) : _quote(_toISOString$1(x))) + ')';

	    case '[object Null]':
	      return 'null';

	    case '[object Number]':
	      return typeof x === 'object' ? 'new Number(' + recur(x.valueOf()) + ')' : 1 / x === -Infinity ? '-0' : x.toString(10);

	    case '[object String]':
	      return typeof x === 'object' ? 'new String(' + recur(x.valueOf()) + ')' : _quote(x);

	    case '[object Undefined]':
	      return 'undefined';

	    default:
	      if (typeof x.toString === 'function') {
	        var repr = x.toString();

	        if (repr !== '[object Object]') {
	          return repr;
	        }
	      }

	      return '{' + mapPairs(x, keys$1(x)).join(', ') + '}';
	  }
	}

	/**
	 * Returns the string representation of the given value. `eval`'ing the output
	 * should result in a value equivalent to the input value. Many of the built-in
	 * `toString` methods do not satisfy this requirement.
	 *
	 * If the given value is an `[object Object]` with a `toString` method other
	 * than `Object.prototype.toString`, this method is invoked with no arguments
	 * to produce the return value. This means user-defined constructor functions
	 * can provide a suitable `toString` method. For example:
	 *
	 *     function Point(x, y) {
	 *       this.x = x;
	 *       this.y = y;
	 *     }
	 *
	 *     Point.prototype.toString = function() {
	 *       return 'new Point(' + this.x + ', ' + this.y + ')';
	 *     };
	 *
	 *     R.toString(new Point(1, 2)); //=> 'new Point(1, 2)'
	 *
	 * @func
	 * @memberOf R
	 * @since v0.14.0
	 * @category String
	 * @sig * -> String
	 * @param {*} val
	 * @return {String}
	 * @example
	 *
	 *      R.toString(42); //=> '42'
	 *      R.toString('abc'); //=> '"abc"'
	 *      R.toString([1, 2, 3]); //=> '[1, 2, 3]'
	 *      R.toString({foo: 1, bar: 2, baz: 3}); //=> '{"bar": 2, "baz": 3, "foo": 1}'
	 *      R.toString(new Date('2001-02-03T04:05:06Z')); //=> 'new Date("2001-02-03T04:05:06.000Z")'
	 */

	var toString =
	/*#__PURE__*/
	_curry1(function toString(val) {
	  return _toString(val, []);
	});

	var toString$1 = toString;

	/**
	 * Returns the result of concatenating the given lists or strings.
	 *
	 * Note: `R.concat` expects both arguments to be of the same type,
	 * unlike the native `Array.prototype.concat` method. It will throw
	 * an error if you `concat` an Array with a non-Array value.
	 *
	 * Dispatches to the `concat` method of the first argument, if present.
	 * Can also concatenate two members of a [fantasy-land
	 * compatible semigroup](https://github.com/fantasyland/fantasy-land#semigroup).
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig [a] -> [a] -> [a]
	 * @sig String -> String -> String
	 * @param {Array|String} firstList The first list
	 * @param {Array|String} secondList The second list
	 * @return {Array|String} A list consisting of the elements of `firstList` followed by the elements of
	 * `secondList`.
	 *
	 * @example
	 *
	 *      R.concat('ABC', 'DEF'); // 'ABCDEF'
	 *      R.concat([4, 5, 6], [1, 2, 3]); //=> [4, 5, 6, 1, 2, 3]
	 *      R.concat([], []); //=> []
	 */

	var concat =
	/*#__PURE__*/
	_curry2(function concat(a, b) {
	  if (_isArray(a)) {
	    if (_isArray(b)) {
	      return a.concat(b);
	    }

	    throw new TypeError(toString$1(b) + ' is not an array');
	  }

	  if (_isString(a)) {
	    if (_isString(b)) {
	      return a + b;
	    }

	    throw new TypeError(toString$1(b) + ' is not a string');
	  }

	  if (a != null && _isFunction(a['fantasy-land/concat'])) {
	    return a['fantasy-land/concat'](b);
	  }

	  if (a != null && _isFunction(a.concat)) {
	    return a.concat(b);
	  }

	  throw new TypeError(toString$1(a) + ' does not have a method named "concat" or "fantasy-land/concat"');
	});

	var concat$1 = concat;

	var _Set =
	/*#__PURE__*/
	function () {
	  function _Set() {
	    /* globals Set */
	    this._nativeSet = typeof Set === 'function' ? new Set() : null;
	    this._items = {};
	  }

	  // until we figure out why jsdoc chokes on this
	  // @param item The item to add to the Set
	  // @returns {boolean} true if the item did not exist prior, otherwise false
	  //
	  _Set.prototype.add = function (item) {
	    return !hasOrAdd(item, true, this);
	  }; //
	  // @param item The item to check for existence in the Set
	  // @returns {boolean} true if the item exists in the Set, otherwise false
	  //


	  _Set.prototype.has = function (item) {
	    return hasOrAdd(item, false, this);
	  }; //
	  // Combines the logic for checking whether an item is a member of the set and
	  // for adding a new item to the set.
	  //
	  // @param item       The item to check or add to the Set instance.
	  // @param shouldAdd  If true, the item will be added to the set if it doesn't
	  //                   already exist.
	  // @param set        The set instance to check or add to.
	  // @return {boolean} true if the item already existed, otherwise false.
	  //


	  return _Set;
	}();

	function hasOrAdd(item, shouldAdd, set) {
	  var type = typeof item;
	  var prevSize, newSize;

	  switch (type) {
	    case 'string':
	    case 'number':
	      // distinguish between +0 and -0
	      if (item === 0 && 1 / item === -Infinity) {
	        if (set._items['-0']) {
	          return true;
	        } else {
	          if (shouldAdd) {
	            set._items['-0'] = true;
	          }

	          return false;
	        }
	      } // these types can all utilise the native Set


	      if (set._nativeSet !== null) {
	        if (shouldAdd) {
	          prevSize = set._nativeSet.size;

	          set._nativeSet.add(item);

	          newSize = set._nativeSet.size;
	          return newSize === prevSize;
	        } else {
	          return set._nativeSet.has(item);
	        }
	      } else {
	        if (!(type in set._items)) {
	          if (shouldAdd) {
	            set._items[type] = {};
	            set._items[type][item] = true;
	          }

	          return false;
	        } else if (item in set._items[type]) {
	          return true;
	        } else {
	          if (shouldAdd) {
	            set._items[type][item] = true;
	          }

	          return false;
	        }
	      }

	    case 'boolean':
	      // set._items['boolean'] holds a two element array
	      // representing [ falseExists, trueExists ]
	      if (type in set._items) {
	        var bIdx = item ? 1 : 0;

	        if (set._items[type][bIdx]) {
	          return true;
	        } else {
	          if (shouldAdd) {
	            set._items[type][bIdx] = true;
	          }

	          return false;
	        }
	      } else {
	        if (shouldAdd) {
	          set._items[type] = item ? [false, true] : [true, false];
	        }

	        return false;
	      }

	    case 'function':
	      // compare functions for reference equality
	      if (set._nativeSet !== null) {
	        if (shouldAdd) {
	          prevSize = set._nativeSet.size;

	          set._nativeSet.add(item);

	          newSize = set._nativeSet.size;
	          return newSize === prevSize;
	        } else {
	          return set._nativeSet.has(item);
	        }
	      } else {
	        if (!(type in set._items)) {
	          if (shouldAdd) {
	            set._items[type] = [item];
	          }

	          return false;
	        }

	        if (!_includes(item, set._items[type])) {
	          if (shouldAdd) {
	            set._items[type].push(item);
	          }

	          return false;
	        }

	        return true;
	      }

	    case 'undefined':
	      if (set._items[type]) {
	        return true;
	      } else {
	        if (shouldAdd) {
	          set._items[type] = true;
	        }

	        return false;
	      }

	    case 'object':
	      if (item === null) {
	        if (!set._items['null']) {
	          if (shouldAdd) {
	            set._items['null'] = true;
	          }

	          return false;
	        }

	        return true;
	      }

	    /* falls through */

	    default:
	      // reduce the search size of heterogeneous sets by creating buckets
	      // for each type.
	      type = Object.prototype.toString.call(item);

	      if (!(type in set._items)) {
	        if (shouldAdd) {
	          set._items[type] = [item];
	        }

	        return false;
	      } // scan through all previously applied items


	      if (!_includes(item, set._items[type])) {
	        if (shouldAdd) {
	          set._items[type].push(item);
	        }

	        return false;
	      }

	      return true;
	  }
	} // A simple Set type that honours R.equals semantics


	var _Set$1 = _Set;

	/**
	 * Returns the empty value of its argument's type. Ramda defines the empty
	 * value of Array (`[]`), Object (`{}`), String (`''`), and Arguments. Other
	 * types are supported if they define `<Type>.empty`,
	 * `<Type>.prototype.empty` or implement the
	 * [FantasyLand Monoid spec](https://github.com/fantasyland/fantasy-land#monoid).
	 *
	 * Dispatches to the `empty` method of the first argument, if present.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.3.0
	 * @category Function
	 * @sig a -> a
	 * @param {*} x
	 * @return {*}
	 * @example
	 *
	 *      R.empty(Just(42));      //=> Nothing()
	 *      R.empty([1, 2, 3]);     //=> []
	 *      R.empty('unicorns');    //=> ''
	 *      R.empty({x: 1, y: 2});  //=> {}
	 */

	var empty =
	/*#__PURE__*/
	_curry1(function empty(x) {
	  return x != null && typeof x['fantasy-land/empty'] === 'function' ? x['fantasy-land/empty']() : x != null && x.constructor != null && typeof x.constructor['fantasy-land/empty'] === 'function' ? x.constructor['fantasy-land/empty']() : x != null && typeof x.empty === 'function' ? x.empty() : x != null && x.constructor != null && typeof x.constructor.empty === 'function' ? x.constructor.empty() : _isArray(x) ? [] : _isString(x) ? '' : _isObject(x) ? {} : _isArguments$1(x) ? function () {
	    return arguments;
	  }() : void 0 // else
	  ;
	});

	var empty$1 = empty;

	var XFind =
	/*#__PURE__*/
	function () {
	  function XFind(f, xf) {
	    this.xf = xf;
	    this.f = f;
	    this.found = false;
	  }

	  XFind.prototype['@@transducer/init'] = _xfBase.init;

	  XFind.prototype['@@transducer/result'] = function (result) {
	    if (!this.found) {
	      result = this.xf['@@transducer/step'](result, void 0);
	    }

	    return this.xf['@@transducer/result'](result);
	  };

	  XFind.prototype['@@transducer/step'] = function (result, input) {
	    if (this.f(input)) {
	      this.found = true;
	      result = _reduced(this.xf['@@transducer/step'](result, input));
	    }

	    return result;
	  };

	  return XFind;
	}();

	var _xfind =
	/*#__PURE__*/
	_curry2(function _xfind(f, xf) {
	  return new XFind(f, xf);
	});

	var _xfind$1 = _xfind;

	/**
	 * Returns the first element of the list which matches the predicate, or
	 * `undefined` if no element matches.
	 *
	 * Dispatches to the `find` method of the second argument, if present.
	 *
	 * Acts as a transducer if a transformer is given in list position.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig (a -> Boolean) -> [a] -> a | undefined
	 * @param {Function} fn The predicate function used to determine if the element is the
	 *        desired one.
	 * @param {Array} list The array to consider.
	 * @return {Object} The element found, or `undefined`.
	 * @see R.transduce
	 * @example
	 *
	 *      const xs = [{a: 1}, {a: 2}, {a: 3}];
	 *      R.find(R.propEq('a', 2))(xs); //=> {a: 2}
	 *      R.find(R.propEq('a', 4))(xs); //=> undefined
	 */

	var find =
	/*#__PURE__*/
	_curry2(
	/*#__PURE__*/
	_dispatchable(['find'], _xfind$1, function find(fn, list) {
	  var idx = 0;
	  var len = list.length;

	  while (idx < len) {
	    if (fn(list[idx])) {
	      return list[idx];
	    }

	    idx += 1;
	  }
	}));

	var find$1 = find;

	/**
	 * Returns a new list by pulling every item out of it (and all its sub-arrays)
	 * and putting them in a new array, depth-first.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig [a] -> [b]
	 * @param {Array} list The array to consider.
	 * @return {Array} The flattened list.
	 * @see R.unnest
	 * @example
	 *
	 *      R.flatten([1, 2, [3, 4], 5, [6, [7, 8, [9, [10, 11], 12]]]]);
	 *      //=> [1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]
	 */

	var flatten =
	/*#__PURE__*/
	_curry1(
	/*#__PURE__*/
	_makeFlat());

	var flatten$1 = flatten;

	/**
	 * Creates a new object from a list key-value pairs. If a key appears in
	 * multiple pairs, the rightmost pair is included in the object.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.3.0
	 * @category List
	 * @sig [[k,v]] -> {k: v}
	 * @param {Array} pairs An array of two-element arrays that will be the keys and values of the output object.
	 * @return {Object} The object made by pairing up `keys` and `values`.
	 * @see R.toPairs, R.pair
	 * @example
	 *
	 *      R.fromPairs([['a', 1], ['b', 2], ['c', 3]]); //=> {a: 1, b: 2, c: 3}
	 */

	var fromPairs =
	/*#__PURE__*/
	_curry1(function fromPairs(pairs) {
	  var result = {};
	  var idx = 0;

	  while (idx < pairs.length) {
	    result[pairs[idx][0]] = pairs[idx][1];
	    idx += 1;
	  }

	  return result;
	});

	var fromPairs$1 = fromPairs;

	/**
	 * Returns whether or not a path exists in an object. Only the object's
	 * own properties are checked.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.26.0
	 * @category Object
	 * @typedefn Idx = String | Int
	 * @sig [Idx] -> {a} -> Boolean
	 * @param {Array} path The path to use.
	 * @param {Object} obj The object to check the path in.
	 * @return {Boolean} Whether the path exists.
	 * @see R.has
	 * @example
	 *
	 *      R.hasPath(['a', 'b'], {a: {b: 2}});         // => true
	 *      R.hasPath(['a', 'b'], {a: {b: undefined}}); // => true
	 *      R.hasPath(['a', 'b'], {a: {c: 2}});         // => false
	 *      R.hasPath(['a', 'b'], {});                  // => false
	 */

	var hasPath =
	/*#__PURE__*/
	_curry2(function hasPath(_path, obj) {
	  if (_path.length === 0 || isNil$1(obj)) {
	    return false;
	  }

	  var val = obj;
	  var idx = 0;

	  while (idx < _path.length) {
	    if (!isNil$1(val) && _has(_path[idx], val)) {
	      val = val[_path[idx]];
	      idx += 1;
	    } else {
	      return false;
	    }
	  }

	  return true;
	});

	var hasPath$1 = hasPath;

	/**
	 * Returns a new list containing only one copy of each element in the original
	 * list, based upon the value returned by applying the supplied function to
	 * each list element. Prefers the first item if the supplied function produces
	 * the same value on two items. [`R.equals`](#equals) is used for comparison.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.16.0
	 * @category List
	 * @sig (a -> b) -> [a] -> [a]
	 * @param {Function} fn A function used to produce a value to use during comparisons.
	 * @param {Array} list The array to consider.
	 * @return {Array} The list of unique items.
	 * @example
	 *
	 *      R.uniqBy(Math.abs, [-1, -5, 2, 10, 1, 2]); //=> [-1, -5, 2, 10]
	 */

	var uniqBy =
	/*#__PURE__*/
	_curry2(function uniqBy(fn, list) {
	  var set = new _Set$1();
	  var result = [];
	  var idx = 0;
	  var appliedItem, item;

	  while (idx < list.length) {
	    item = list[idx];
	    appliedItem = fn(item);

	    if (set.add(appliedItem)) {
	      result.push(item);
	    }

	    idx += 1;
	  }

	  return result;
	});

	var uniqBy$1 = uniqBy;

	/**
	 * Returns a new list containing only one copy of each element in the original
	 * list. [`R.equals`](#equals) is used to determine equality.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category List
	 * @sig [a] -> [a]
	 * @param {Array} list The array to consider.
	 * @return {Array} The list of unique items.
	 * @example
	 *
	 *      R.uniq([1, 1, 2, 1]); //=> [1, 2]
	 *      R.uniq([1, '1']);     //=> [1, '1']
	 *      R.uniq([[42], [42]]); //=> [[42]]
	 */

	var uniq =
	/*#__PURE__*/
	uniqBy$1(identity$1);
	var uniq$1 = uniq;

	function _objectAssign(target) {
	  if (target == null) {
	    throw new TypeError('Cannot convert undefined or null to object');
	  }

	  var output = Object(target);
	  var idx = 1;
	  var length = arguments.length;

	  while (idx < length) {
	    var source = arguments[idx];

	    if (source != null) {
	      for (var nextKey in source) {
	        if (_has(nextKey, source)) {
	          output[nextKey] = source[nextKey];
	        }
	      }
	    }

	    idx += 1;
	  }

	  return output;
	}

	var _objectAssign$1 = typeof Object.assign === 'function' ? Object.assign : _objectAssign;

	/**
	 * Turns a named method with a specified arity into a function that can be
	 * called directly supplied with arguments and a target object.
	 *
	 * The returned function is curried and accepts `arity + 1` parameters where
	 * the final parameter is the target object.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Function
	 * @sig Number -> String -> (a -> b -> ... -> n -> Object -> *)
	 * @param {Number} arity Number of arguments the returned function should take
	 *        before the target object.
	 * @param {String} method Name of any of the target object's methods to call.
	 * @return {Function} A new curried function.
	 * @see R.construct
	 * @example
	 *
	 *      const sliceFrom = R.invoker(1, 'slice');
	 *      sliceFrom(6, 'abcdefghijklm'); //=> 'ghijklm'
	 *      const sliceFrom6 = R.invoker(2, 'slice')(6);
	 *      sliceFrom6(8, 'abcdefghijklm'); //=> 'gh'
	 *
	 *      const dog = {
	 *        speak: async () => 'Woof!'
	 *      };
	 *      const speak = R.invoker(0, 'speak');
	 *      speak(dog).then(console.log) //~> 'Woof!'
	 *
	 * @symb R.invoker(0, 'method')(o) = o['method']()
	 * @symb R.invoker(1, 'method')(a, o) = o['method'](a)
	 * @symb R.invoker(2, 'method')(a, b, o) = o['method'](a, b)
	 */

	var invoker =
	/*#__PURE__*/
	_curry2(function invoker(arity, method) {
	  return curryN$1(arity + 1, function () {
	    var target = arguments[arity];

	    if (target != null && _isFunction(target[method])) {
	      return target[method].apply(target, Array.prototype.slice.call(arguments, 0, arity));
	    }

	    throw new TypeError(toString$1(target) + ' does not have a method named "' + method + '"');
	  });
	});

	var invoker$1 = invoker;

	/**
	 * See if an object (`val`) is an instance of the supplied constructor. This
	 * function will check up the inheritance chain, if any.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.3.0
	 * @category Type
	 * @sig (* -> {*}) -> a -> Boolean
	 * @param {Object} ctor A constructor
	 * @param {*} val The value to test
	 * @return {Boolean}
	 * @example
	 *
	 *      R.is(Object, {}); //=> true
	 *      R.is(Number, 1); //=> true
	 *      R.is(Object, 1); //=> false
	 *      R.is(String, 's'); //=> true
	 *      R.is(String, new String('')); //=> true
	 *      R.is(Object, new String('')); //=> true
	 *      R.is(Object, 's'); //=> false
	 *      R.is(Number, {}); //=> false
	 */

	var is =
	/*#__PURE__*/
	_curry2(function is(Ctor, val) {
	  return val != null && val.constructor === Ctor || val instanceof Ctor;
	});

	var is$1 = is;

	/**
	 * Returns `true` if the given value is its type's empty value; `false`
	 * otherwise.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Logic
	 * @sig a -> Boolean
	 * @param {*} x
	 * @return {Boolean}
	 * @see R.empty
	 * @example
	 *
	 *      R.isEmpty([1, 2, 3]);   //=> false
	 *      R.isEmpty([]);          //=> true
	 *      R.isEmpty('');          //=> true
	 *      R.isEmpty(null);        //=> false
	 *      R.isEmpty({});          //=> true
	 *      R.isEmpty({length: 0}); //=> false
	 */

	var isEmpty =
	/*#__PURE__*/
	_curry1(function isEmpty(x) {
	  return x != null && equals$1(x, empty$1(x));
	});

	var isEmpty$1 = isEmpty;

	/**
	 * Merges a list of objects together into one object.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.10.0
	 * @category List
	 * @sig [{k: v}] -> {k: v}
	 * @param {Array} list An array of objects
	 * @return {Object} A merged object.
	 * @see R.reduce
	 * @example
	 *
	 *      R.mergeAll([{foo:1},{bar:2},{baz:3}]); //=> {foo:1,bar:2,baz:3}
	 *      R.mergeAll([{foo:1},{foo:2},{bar:2}]); //=> {foo:2,bar:2}
	 * @symb R.mergeAll([{ x: 1 }, { y: 2 }, { z: 3 }]) = { x: 1, y: 2, z: 3 }
	 */

	var mergeAll =
	/*#__PURE__*/
	_curry1(function mergeAll(list) {
	  return _objectAssign$1.apply(null, [{}].concat(list));
	});

	var mergeAll$1 = mergeAll;

	/**
	 * Returns a partial copy of an object omitting the keys specified.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Object
	 * @sig [String] -> {String: *} -> {String: *}
	 * @param {Array} names an array of String property names to omit from the new object
	 * @param {Object} obj The object to copy from
	 * @return {Object} A new object with properties from `names` not on it.
	 * @see R.pick
	 * @example
	 *
	 *      R.omit(['a', 'd'], {a: 1, b: 2, c: 3, d: 4}); //=> {b: 2, c: 3}
	 */

	var omit =
	/*#__PURE__*/
	_curry2(function omit(names, obj) {
	  var result = {};
	  var index = {};
	  var idx = 0;
	  var len = names.length;

	  while (idx < len) {
	    index[names[idx]] = 1;
	    idx += 1;
	  }

	  for (var prop in obj) {
	    if (!index.hasOwnProperty(prop)) {
	      result[prop] = obj[prop];
	    }
	  }

	  return result;
	});

	var omit$1 = omit;

	/**
	 * Returns `true` if the specified object property is equal, in
	 * [`R.equals`](#equals) terms, to the given value; `false` otherwise.
	 * You can test multiple properties with [`R.whereEq`](#whereEq).
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Relation
	 * @sig String -> a -> Object -> Boolean
	 * @param {String} name
	 * @param {*} val
	 * @param {*} obj
	 * @return {Boolean}
	 * @see R.whereEq, R.propSatisfies, R.equals
	 * @example
	 *
	 *      const abby = {name: 'Abby', age: 7, hair: 'blond'};
	 *      const fred = {name: 'Fred', age: 12, hair: 'brown'};
	 *      const rusty = {name: 'Rusty', age: 10, hair: 'brown'};
	 *      const alois = {name: 'Alois', age: 15, disposition: 'surly'};
	 *      const kids = [abby, fred, rusty, alois];
	 *      const hasBrownHair = R.propEq('hair', 'brown');
	 *      R.filter(hasBrownHair, kids); //=> [fred, rusty]
	 */

	var propEq =
	/*#__PURE__*/
	_curry3(function propEq(name, val, obj) {
	  return equals$1(val, obj[name]);
	});

	var propEq$1 = propEq;

	/**
	 * Replace a substring or regex match in a string with a replacement.
	 *
	 * The first two parameters correspond to the parameters of the
	 * `String.prototype.replace()` function, so the second parameter can also be a
	 * function.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.7.0
	 * @category String
	 * @sig RegExp|String -> String -> String -> String
	 * @param {RegExp|String} pattern A regular expression or a substring to match.
	 * @param {String} replacement The string to replace the matches with.
	 * @param {String} str The String to do the search and replacement in.
	 * @return {String} The result.
	 * @example
	 *
	 *      R.replace('foo', 'bar', 'foo foo foo'); //=> 'bar foo foo'
	 *      R.replace(/foo/, 'bar', 'foo foo foo'); //=> 'bar foo foo'
	 *
	 *      // Use the "g" (global) flag to replace all occurrences:
	 *      R.replace(/foo/g, 'bar', 'foo foo foo'); //=> 'bar bar bar'
	 */

	var replace =
	/*#__PURE__*/
	_curry3(function replace(regex, replacement, str) {
	  return str.replace(regex, replacement);
	});

	var replace$1 = replace;

	/**
	 * Splits a string into an array of strings based on the given
	 * separator.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category String
	 * @sig (String | RegExp) -> String -> [String]
	 * @param {String|RegExp} sep The pattern.
	 * @param {String} str The string to separate into an array.
	 * @return {Array} The array of strings from `str` separated by `sep`.
	 * @see R.join
	 * @example
	 *
	 *      const pathComponents = R.split('/');
	 *      R.tail(pathComponents('/usr/local/bin/node')); //=> ['usr', 'local', 'bin', 'node']
	 *
	 *      R.split('.', 'a.b.c.xyz.d'); //=> ['a', 'b', 'c', 'xyz', 'd']
	 */

	var split$1 =
	/*#__PURE__*/
	invoker$1(1, 'split');
	var split$2 = split$1;

	var ws = '\x09\x0A\x0B\x0C\x0D\x20\xA0\u1680\u2000\u2001\u2002\u2003' + '\u2004\u2005\u2006\u2007\u2008\u2009\u200A\u202F\u205F\u3000\u2028' + '\u2029\uFEFF';
	var zeroWidth = '\u200b';
	var hasProtoTrim = typeof String.prototype.trim === 'function';
	/**
	 * Removes (strips) whitespace from both ends of the string.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.6.0
	 * @category String
	 * @sig String -> String
	 * @param {String} str The string to trim.
	 * @return {String} Trimmed version of `str`.
	 * @example
	 *
	 *      R.trim('   xyz  '); //=> 'xyz'
	 *      R.map(R.trim, R.split(',', 'x, y, z')); //=> ['x', 'y', 'z']
	 */

	var trim = !hasProtoTrim ||
	/*#__PURE__*/
	ws.trim() || !
	/*#__PURE__*/
	zeroWidth.trim() ?
	/*#__PURE__*/
	_curry1(function trim(str) {
	  var beginRx = new RegExp('^[' + ws + '][' + ws + ']*');
	  var endRx = new RegExp('[' + ws + '][' + ws + ']*$');
	  return str.replace(beginRx, '').replace(endRx, '');
	}) :
	/*#__PURE__*/
	_curry1(function trim(str) {
	  return str.trim();
	});
	var trim$1 = trim;

	/**
	 * Combines two lists into a set (i.e. no duplicates) composed of the elements
	 * of each list.
	 *
	 * @func
	 * @memberOf R
	 * @since v0.1.0
	 * @category Relation
	 * @sig [*] -> [*] -> [*]
	 * @param {Array} as The first list.
	 * @param {Array} bs The second list.
	 * @return {Array} The first and second lists concatenated, with
	 *         duplicates removed.
	 * @example
	 *
	 *      R.union([1, 2, 3], [2, 3, 4]); //=> [1, 2, 3, 4]
	 */

	var union =
	/*#__PURE__*/
	_curry2(
	/*#__PURE__*/
	compose(uniq$1, _concat));

	var union$1 = union;

	const trimAll = (data) => {
	    if (isNil$1(data) || isEmpty$1(data)) {
	        return data;
	    }
	    const type = type$1(data);
	    switch (type) {
	        case 'String': {
	            return trim$1(data);
	        }
	        case 'Array': {
	            return filter$1(complement$1(isEmpty$1))(data);
	        }
	        default: {
	            return data;
	        }
	    }
	};

	const split = (separator, data) => {
	    if (isEmpty$1(data) || isNil$1(data)) {
	        return [];
	    }
	    return pipe(split$2(separator), trimAll)(data);
	};

	// sessionStorage
	const YS = {
	    set: (name, value) => {
	        if (typeof window !== 'undefined') {
	            window.sessionStorage.setItem(name, value);
	        }
	    },
	    get: (name) => {
	        if (typeof window !== 'undefined') {
	            return window.sessionStorage.getItem(name);
	        }
	        return null;
	    },
	    remove: (name) => {
	        if (typeof window !== 'undefined') {
	            window.sessionStorage.removeItem(name);
	        }
	    },
	    clear: () => {
	        if (typeof window !== 'undefined') {
	            window.sessionStorage.clear();
	        }
	    }
	};
	// locationStorage
	const YL = {
	    set: (name, value) => {
	        if (typeof window !== 'undefined') {
	            window.localStorage.setItem(name, value);
	        }
	    },
	    get: (name) => {
	        if (typeof window !== 'undefined') {
	            return window.localStorage.getItem(name);
	        }
	        return null;
	    },
	    remove: (name) => {
	        if (typeof window !== 'undefined') {
	            window.localStorage.removeItem(name);
	        }
	    },
	    clear: () => {
	        if (typeof window !== 'undefined') {
	            window.localStorage.clear();
	        }
	    }
	};

	// cookie
	const YC = {
	    set: (name, value, exdays) => {
	        const d = new Date();
	        d.setTime(d.getTime() + exdays * 24 * 60 * 60 * 1000);
	        const expires = `expires=${d.toUTCString()}`;
	        document.cookie = `${name}=${escape(value)};${expires};path=/`;
	    },
	    get: (name) => {
	        const str = `${name}=`;
	        const ca = document.cookie.split(';');
	        for (let i = 0; i < ca.length; i += 1) {
	            let c = ca[i];
	            while (c.charAt(0) === ' ')
	                c = c.substring(1);
	            if (c.indexOf(str) !== -1)
	                return c.substring(str.length, c.length);
	        }
	        return undefined;
	    },
	};

	/**
	 * 仅触发一次事件
	 *
	 * @private
	 *
	 * @param node      DOM 节点
	 * @param name      事件名称
	 * @param callback  回调函数
	 */
	function once(node, name, fn, options) {
	    function listener(event) {
	        node.removeEventListener(name, listener);
	        fn(event);
	    }
	    node.addEventListener(name, listener, options);
	}
	/**
	 * 监听脚本加载事件 - IE 兼容
	 *
	 * @private
	 *
	 * @param node     DOM 节点
	 * @param callback 回调函数
	 */
	function listenWithIE(node, callback) {
	    node.onreadystatechange = function () {
	        if (node.readyState === 'loaded' || node.readyState === 'complete') {
	            node.onreadystatechange = null;
	            callback();
	        }
	    };
	}
	/**
	 * 监听脚本加载事件 - 其他浏览器
	 *
	 * @private
	 *
	 * @param node     DOM 节点
	 * @param callback 回调函数
	 */
	function listen(node, onSuccess, onError) {
	    once(node, 'load', onSuccess);
	    once(node, 'error', onError);
	}
	// 允许的属性名单
	const allowLists = [
	    'id',
	    'type',
	    'async',
	    'defer',
	    'crossOrigin',
	    'integrity',
	    'noModule',
	];
	/**
	 * 动态加载脚本
	 *
	 * @param src    文件地址
	 * @param attrs  可选的属性
	 *
	 * @returns dom 节点
	 *
	 * @example
	 *
	 * try {
	 *  const src = 'https://cdn.bootcdn.net/ajax/libs/jquery/3.6.0/jquery.min.js'
	 *
	 *  await loadScript(src, { id: 'jquery.3.6.0.min' })
	 * } catch {
	 *   alert('加载失败')
	 * }
	 */
	function loadScript(umd, progectId, attrs) {
	    return new Promise((resolve, reject) => {
	        const scriptNode = document.createElement('script');
	        // const styleNode: HTMLLinkElement = document.createElement('link');
	        // const id = uuidv4();
	        scriptNode.id = progectId;
	        // styleNode.id = id;
	        // 监听事件
	        if (scriptNode.readyState) {
	            listenWithIE(scriptNode, () => resolve(scriptNode));
	        }
	        else {
	            listen(scriptNode, () => resolve(scriptNode), () => {
	                reject();
	                document.removeChild(document.getElementById(progectId));
	            });
	        }
	        // 设置白名单属性
	        if (attrs) {
	            allowLists.forEach(attrName => {
	                if (attrName in attrs) {
	                    const value = attrs[attrName];
	                    if (typeof value === 'string') {
	                        scriptNode.setAttribute(attrName, value);
	                        // styleNode.setAttribute(attrName, value);
	                    }
	                    else if (typeof value === 'boolean') {
	                        // 布尔值与字符串的设置不太一样
	                        scriptNode[attrName] = value;
	                    }
	                }
	            });
	        }
	        // 设置资源地址
	        scriptNode.src = umd.js;
	        // styleNode.href = umd.css;
	        // 插入到页面中
	        document.body.appendChild(scriptNode);
	        // document.body.appendChild(styleNode);
	    });
	}
	function unLoadScript(progectId) {
	    if (document.getElementById(progectId)) {
	        const scriptNode = document.getElementById(progectId);
	        document.body.removeChild(scriptNode);
	    }
	}

	const isDate = (value) => {
	    let date = value;
	    if (value instanceof Date) {
	        date = value;
	    }
	    else if (typeof value === 'string' &&
	        String(value).length >= 13 &&
	        !isNaN(value)) {
	        date = Number(value);
	    }
	    else if (typeof value === 'string' && value.includes('-')) {
	        date = value.replace(/-/g, '/');
	    }
	    return new Date(date) && String(new Date(date)) !== 'Invalid Date';
	};

	const toDate = (value) => {
	    if (isDate(value)) {
	        let date = value;
	        if (value instanceof Date) {
	            date = value;
	        }
	        else if (typeof value === 'string' &&
	            String(value).length >= 13 &&
	            !isNaN(value)) {
	            date = Number(value);
	        }
	        else if (typeof value === 'string' && value.includes('-')) {
	            date = value.replace(/-/g, '/');
	        }
	        return new Date(date).getTime();
	    }
	    return 0;
	};

	/**
	 * 获取时间搓 消除-连接时，默认时间为8点的问题
	 * @param date 时间
	 * return number 时间搓。单位:毫秒
	 * */
	const getDate = (date) => {
	    const dateStr = date.replace(/-/g, '/');
	    return new Date(dateStr).valueOf();
	};

	const dateFormat = (date, format) => {
	    if (!isDate(date))
	        return null;
	    // 时间格式化函数
	    let time;
	    if (!isNaN(date)) {
	        date = Number(date);
	    }
	    else if (typeof date === 'string' && date.includes('-')) {
	        date = date.replace(/-/g, '/');
	    }
	    time = new Date(date);
	    const o = {
	        YYYY: time.getFullYear(),
	        YY: `${time.getFullYear()}`.slice(-2),
	        MM: `0${time.getMonth() + 1}`.slice(-2),
	        M: time.getMonth() + 1,
	        DD: `0${time.getDate()}`.slice(-2),
	        D: time.getDate(),
	        HH: `0${time.getHours()}`.slice(-2),
	        H: time.getHours(),
	        hh: `0${time.getHours() % 12}`.slice(-2),
	        h: time.getHours() % 12,
	        mm: `0${time.getMinutes()}`.slice(-2),
	        m: time.getMinutes(),
	        ss: `0${time.getSeconds()}`.slice(-2),
	        s: time.getSeconds(),
	        w: (function () {
	            return ['日', '一', '二', '三', '四', '五', '六'][time.getDay()];
	        })(),
	    };
	    for (const k in o) {
	        format = format.replace(k, o[k]);
	    }
	    return format;
	};

	/**
	 *  时光流逝
	 *  @param startDate string 开始时间
	 *  @param flowTime number 流逝时长 单位秒
	 *  @param format string 返回格式 默认: 'HH:mm:ss'
	 */
	const timeFlow = (startDate, flowTime, format = 'HH:mm:ss') => (dateFormat(getDate(startDate) + flowTime * 1000, format));

	/**
	 * 字符串填充
	 * @param type sting 填充左侧还是右侧
	 * @param sourceStr string 原字符串
	 * @param len number 填充后长度
	 * @param charStr string 填充的字符
	 * @returns string
	 */
	const strPad = (type, sourceStr, len, charStr) => {
	    let retStr = '';
	    if (sourceStr.length > len)
	        return sourceStr;
	    if (type === 'left') {
	        // leftPad
	        retStr = new Array(len - sourceStr.length + 1).join(charStr) + sourceStr;
	    }
	    else {
	        // rightPad
	        retStr = sourceStr + new Array(len - sourceStr.length + 1).join(charStr);
	    }
	    return retStr;
	};

	/**
	 * 时长展示 比如：300秒 展示为：0:5
	 * @param time number 单位:秒
	 * @param format 返回的结果格式 {mm}
	 * @param allowEmpty 是否允许time为空
	 */
	const [oneDay$1, oneHour$1, oneMinute$1] = [86400, 3600, 60];
	const formatTime = (time, format, allowEmpty = true) => {
	    let timelen = time < 0 ? 0 : parseFloat(`${time}`);
	    if ((isNaN(timelen) || !timelen) && !(allowEmpty && timelen === 0)) { // 0代表无数据，显示-
	        return '-';
	    }
	    let [days, hours, minutes, seconds] = [undefined, undefined, undefined, undefined];
	    if (format.indexOf('{DD}') > -1) {
	        days = Math.floor(timelen / oneDay$1);
	        timelen = Math.floor(timelen % oneDay$1);
	    }
	    if (format.indexOf('{HH}') > -1) {
	        hours = Math.floor(timelen / oneHour$1);
	        timelen = Math.floor(timelen % oneHour$1);
	    }
	    if (format.indexOf('{mm}') > -1) {
	        minutes = Math.floor(timelen / oneMinute$1);
	        timelen = Math.floor(timelen % oneMinute$1);
	    }
	    seconds = timelen;
	    const timeStr = format
	        .replace('{ss}', typeof seconds === 'number' ? strPad('left', String(seconds), 2, '0') : '')
	        .replace('{mm}', typeof minutes === 'number' ? strPad('left', String(minutes), 2, '0') : '')
	        .replace('{HH}', typeof hours === 'number' ? strPad('left', String(hours), 2, '0') : '')
	        .replace('{DD}', typeof days === 'number' ? strPad('left', String(days), 2, '0') : '');
	    return timeStr;
	};

	/**
	 * 计算两个时间の间隔
	 * @param startTime 开始时间
	 * @param endTime  结束时间
	 * @param unit  返回的时间单位 s:秒(默认) m:分钟 h: 小时 d: 天
	 * @param fixed  小数位
	 * return number 间隔时长。单位:秒
	 * */
	const [oneDay, oneHour, oneMinute] = [86400, 3600, 60];
	const calTimeLen = (startTime, endTime, unit = 's', fixed) => {
	    let unitTime;
	    switch (unit) {
	        case 'm':
	            unitTime = 1000 * oneMinute;
	            break;
	        case 'h':
	            unitTime = 1000 * oneHour;
	            break;
	        case 'd':
	            unitTime = 1000 * oneDay;
	            break;
	        default:
	            unitTime = 1000;
	    }
	    let interval = (getDate(endTime) - getDate(startTime)) / unitTime;
	    // 四舍五入
	    interval = typeof fixed === 'number' ? Number(interval.toFixed(fixed)) : interval;
	    return interval;
	};

	const treeReduce = (target, childKey, data) => {
	    const hasChildren = (node) => {
	        return hasPath$1([childKey], node);
	    };
	    const Tree = {
	        reduce: curry$1((reducerFn, init, node) => {
	            const acc = reducerFn(init, node);
	            if (!hasChildren(node)) {
	                return acc;
	            }
	            return node[childKey]
	                ? node[childKey].reduce(Tree.reduce(reducerFn), acc)
	                : acc;
	        }),
	        find: curry$1((findFn, init, node) => {
	            return pipe(map$1(Tree.reduce(findFn, init)), flatten$1)(node);
	        })
	    };
	    const fn = (arr, data) => {
	        if ((target.value && data[target.key] && data[target.key] === target.value) ||
	            (!target.value && data[target.key])) {
	            return arr.concat([omit$1([childKey], data)]);
	        }
	        else {
	            return arr;
	        }
	    };
	    const type = type$1(data);
	    switch (type) {
	        case 'Object': {
	            return Tree.reduce(fn, [])(data);
	        }
	        case 'Array': {
	            return Tree.find(fn, [])(data);
	        }
	        default: {
	            return data;
	        }
	    }
	};

	const treeFind = (target, childKey, data) => {
	    const hasChildren = (node) => {
	        return childKey && hasPath$1([childKey], node) && !isEmpty$1(node[childKey]);
	    };
	    const Tree = {
	        reduce: curry$1((fn, init, node) => {
	            const acc = fn(init, node);
	            if (!hasChildren(node) && node[target.key] === target.value) {
	                return acc;
	            }
	            return childKey && node[childKey] && !isEmpty$1(node[childKey]) ? Tree.reduce(findFn, acc)(node[childKey]) : acc;
	        }),
	        find: curry$1((fn, init, node) => {
	            return pipe(map$1(Tree.reduce(fn, init)), flatten$1, union$1(init))(node);
	        })
	    };
	    const reducerFn = (arr, data) => {
	        if ((target.value && data[target.key] && data[target.key] === target.value) ||
	            (!target.value && data[target.key])) {
	            return childKey ? arr.concat([omit$1([childKey], data)]) : arr.concat([data]);
	        }
	        else {
	            return arr;
	        }
	    };
	    const findFn = (arr, data) => {
	        const keys = Object.keys(data);
	        const result = [];
	        keys.map((key) => {
	            result.push(data[key]);
	        });
	        return Tree.find(reducerFn, arr)(result);
	    };
	    const type = type$1(data);
	    switch (type) {
	        case 'Object': {
	            return Tree.reduce(findFn, [])(data);
	        }
	        case 'Array': {
	            return Tree.find(reducerFn, [])(data);
	        }
	        default: {
	            return [];
	        }
	    }
	};

	const treePaths = (target, childKey, data) => {
	    const hasChildren = (node) => {
	        return hasPath$1([childKey], node) && !isEmpty$1(node[childKey]);
	    };
	    const Tree = {
	        reduce: curry$1((reducerFn, init, preNode, node) => {
	            const acc = reducerFn(init, preNode, node);
	            if (!hasChildren(node) && node[target.key] === target.value) {
	                if (preNode.path) {
	                    acc.splice(0, 0, preNode.path);
	                }
	                return acc;
	            }
	            return node[childKey] && !isEmpty$1(node[childKey]) ? Tree.reduce(findFn, [], omit$1([childKey], node))(node[childKey]) : acc;
	        }),
	        find: curry$1((findFn, init, preNode, node) => {
	            return pipe(map$1(Tree.reduce(findFn, init, preNode)), flatten$1)(node);
	        })
	    };
	    const reducerFn = (arr, _preNode, data) => {
	        if ((target.value && data[target.key] && data[target.key] === target.value) ||
	            (!target.value && data[target.key])) {
	            return arr.concat([data.path]);
	        }
	        else {
	            return arr;
	        }
	    };
	    const findFn = (arr, preNode, data) => {
	        if (!data || isEmpty$1(data)) {
	            return arr;
	        }
	        const keys = Object.keys(data);
	        const result = [];
	        keys.map((key) => {
	            result.push(data[key]);
	        });
	        return Tree.find(reducerFn, arr, preNode)(result);
	    };
	    const type = type$1(data);
	    switch (type) {
	        case 'Object': {
	            return Tree.reduce(findFn, [], {})(data);
	        }
	        case 'Array': {
	            return Tree.find(reducerFn, [], {})(data);
	        }
	        default: {
	            return [];
	        }
	    }
	};

	const pickAll = (key, childKey, data) => {
	    const hasChildren = (node) => {
	        return hasPath$1([childKey], node);
	    };
	    const Tree = {
	        reduce: curry$1((reducerFn, init, node) => {
	            const acc = reducerFn(init, node);
	            if (!hasChildren(node)) {
	                const res = acc && acc.length ? map$1((item) => {
	                    return item[key] || item;
	                })(acc) : [];
	                return res;
	            }
	            return node[childKey]
	                ? node[childKey].reduce(Tree.reduce(reducerFn), acc)
	                : acc;
	        }),
	        find: curry$1((findFn, init, node) => {
	            return pipe(map$1(Tree.reduce(findFn, init)), flatten$1)(node);
	        })
	    };
	    const fn = (arr, data) => {
	        if (data[key]) {
	            return arr.concat([omit$1([childKey], data)]);
	        }
	        else {
	            return arr;
	        }
	    };
	    const type = type$1(data);
	    switch (type) {
	        case 'Object': {
	            return Tree.reduce(fn, [])(data);
	        }
	        case 'Array': {
	            return Tree.find(fn, [])(data);
	        }
	        default: {
	            return data;
	        }
	    }
	};

	const getRoutes = (permissionList, routerConfig, defaultConfig, pathname) => {
	    if (isEmpty$1(permissionList) || isEmpty$1(routerConfig)) {
	        return {
	            menus: [],
	            defaultSelectedMenus: [],
	            defaultOpenMenus: [],
	            defaultMenu: {},
	            permissions: [],
	        };
	    }
	    let paths;
	    if (pathname !== '/' && pathname !== '/undefined' && pathname !== '/null') {
	        paths = split('/', pathname);
	    }
	    else {
	        paths = [];
	    }
	    let defaultOpenMenus = [];
	    let defaultSelectedMenus = [];
	    let defaultMenu = {};
	    const resetData = (item) => {
	        const currentItem = routerConfig[item.url];
	        if (!currentItem) {
	            return {};
	        }
	        const path = item.url.indexOf('/') === 0 ? item.url || '' : `/${item.url}`;
	        const result = {
	            path,
	            param: currentItem.param || '',
	            url: currentItem.url,
	            name: item.resourceId,
	            meta: {
	                title: item.name,
	                icon: currentItem.icon,
	            },
	            component: currentItem.component,
	            hidden: currentItem.hidden,
	            origion_url: path,
	        };
	        if (((defaultConfig === null || defaultConfig === void 0 ? void 0 : defaultConfig.primaryDefaultMenu) &&
	            item.url === (defaultConfig === null || defaultConfig === void 0 ? void 0 : defaultConfig.primaryDefaultMenu)) ||
	            ((defaultConfig === null || defaultConfig === void 0 ? void 0 : defaultConfig.secondaryDefaultMenu) &&
	                item.url === (defaultConfig === null || defaultConfig === void 0 ? void 0 : defaultConfig.secondaryDefaultMenu))) {
	            defaultOpenMenus = [item.resourceParentId];
	            defaultSelectedMenus = [item.resourceId];
	            defaultMenu = result;
	        }
	        return result;
	    };
	    const result = [];
	    let permissions = [];
	    permissionList.map((item) => {
	        const children = [];
	        const currentItem = routerConfig[item.url];
	        const btns = treeReduce({ key: 'resourceType', value: 'BUTTON' }, 'childMenus', item);
	        if (btns && btns.length) {
	            const urls = pipe(map$1(prop$1('url')))(btns);
	            permissions = concat$1(permissions, urls);
	        }
	        if (item.childMenus && item.childMenus.length) {
	            const childMenus = treeReduce({ key: 'resourceId' }, 'childMenus', item.childMenus);
	            childMenus.map((child) => {
	                if (child) {
	                    const data = resetData(child);
	                    if (data && data.name) {
	                        children.push(data);
	                    }
	                }
	            });
	        }
	        const data = resetData(item);
	        if (currentItem) {
	            result.push(Object.assign(Object.assign({}, data), { children }));
	        }
	    });
	    if (paths.length && result.length) {
	        const res = setPathToDefaultMenu(paths, result);
	        defaultSelectedMenus = res.defaultSelectedMenus;
	        defaultOpenMenus = res.defaultOpenMenus;
	        defaultMenu = res.defaultMenu;
	    }
	    else if (!defaultSelectedMenus.length ||
	        !defaultOpenMenus.length ||
	        !defaultMenu) {
	        const res = setFistChildToDefaultMenu(result);
	        defaultSelectedMenus = res.defaultSelectedMenus;
	        defaultOpenMenus = res.defaultOpenMenus;
	        defaultMenu = res.defaultMenu;
	    }
	    return {
	        menus: result,
	        defaultSelectedMenus,
	        defaultOpenMenus,
	        defaultMenu: defaultMenu,
	        permissions,
	    };
	};
	const setPathToDefaultMenu = (paths, menus) => {
	    let defaultOpenMenus = [];
	    let defaultSelectedMenus = [];
	    let defaultMenu = {};
	    const openMenus = find$1(propEq$1('origion_url', `/${paths[0]}`))(menus);
	    if (openMenus) {
	        defaultOpenMenus = [openMenus.name];
	        if (paths.length > 1 && openMenus.children && openMenus.children.length) {
	            const defaultPath = paths.join('/');
	            defaultMenu = find$1(propEq$1('origion_url', `/${defaultPath}`))(openMenus.children);
	        }
	        else {
	            defaultMenu =
	                openMenus.children && openMenus.children.length
	                    ? openMenus.children[0]
	                    : openMenus;
	        }
	        defaultSelectedMenus = (defaultMenu === null || defaultMenu === void 0 ? void 0 : defaultMenu.name) ? [defaultMenu.name] : [];
	    }
	    return {
	        defaultOpenMenus,
	        defaultSelectedMenus,
	        defaultMenu,
	    };
	};
	const setFistChildToDefaultMenu = (menus) => {
	    var _a, _b;
	    let defaultOpenMenus = [];
	    let defaultSelectedMenus = [];
	    let defaultMenu = {};
	    if (menus[0] && menus[0].children && menus[0].children.length) {
	        defaultOpenMenus = [menus[0].name];
	        defaultSelectedMenus = [menus[0].children[0].name];
	        defaultMenu = menus[0].children[0];
	    }
	    else if (menus[0]) {
	        defaultOpenMenus = [(_a = menus[0]) === null || _a === void 0 ? void 0 : _a.name];
	        defaultSelectedMenus = [(_b = menus[0]) === null || _b === void 0 ? void 0 : _b.name];
	        defaultMenu = menus[0];
	    }
	    return {
	        defaultOpenMenus,
	        defaultSelectedMenus,
	        defaultMenu,
	    };
	};

	/**
	 * 转换为带单位的短数据
	 * @param num 需要转换的数字（非数字 或是 - 将直接返回 -）
	 * @param decimal 返回的小数位
	 * @param addUnit 返回值是否添加单位:(万或亿)
	 * @param retInt 当数据小于1万时，是否返回无小数位的整数
	 */
	const transformShortNum = (num, decimal = 0, addUnit = true, retInt = false) => {
	    let formatValue = parseFloat(num);
	    if (isNaN(formatValue) || (num !== 0 && !num)) {
	        return '-';
	    }
	    let isNegativeNumber = false;
	    let ret = '';
	    if (formatValue < 0) {
	        isNegativeNumber = true;
	        formatValue = Math.abs(formatValue);
	    }
	    if (formatValue >= 100000000) {
	        ret = (formatValue / 100000000).toFixed(decimal) + (addUnit ? '亿' : '');
	    }
	    else if (formatValue >= 10000) {
	        ret = (formatValue / 10000).toFixed(decimal) + (addUnit ? '万' : '');
	    }
	    else {
	        ret = retInt ? formatValue.toFixed(0) : formatValue.toString();
	        ret = !retInt && !isNaN(decimal) ? formatValue.toFixed(decimal) : ret;
	    }
	    return isNegativeNumber ? `-${ret}` : ret;
	};

	/**
	 * 特定类型数字的统一格式处理
	 * @param num 需要转换的数字（非数字 或是 - 将直接返回 -）
	 * @param decimal 返回的小数位
	 * @param addUnit 返回值是否添加单位:(万或亿)
	 * @param retInt 当数据小于1万时，是否返回无小数位的整数
	 */
	const formatData = (config) => {
	    let { afterUnit } = config;
	    const { type, value, isAbs, beforeUnit } = config;
	    if (Number(value) === -2147483648) {
	        return '无权限';
	    }
	    if (type === 'text') { // 文字类型
	        return value || value === 0 ? value : '-';
	    }
	    if (isNaN(value) || (value !== 0 && !value)) {
	        return '-';
	    }
	    let val;
	    switch (type) {
	        case 'yuan': // 接口数据，单位为元
	            val = transformShortNum(value, 2);
	            break;
	        case 'fen': // 接口数据，单位为分
	            val = transformShortNum(value / 100, 2);
	            break;
	        case 'decimalToPercentSave2Decimal': // 小数转百分比, 保留两位小数
	            val = transformShortNum(value * 100, 2);
	            afterUnit = typeof afterUnit === 'string' ? afterUnit : '%';
	            break;
	        case 'decimalToPercentSave0Decimal': // 小数转百分比, 不保留两位小数
	            val = transformShortNum(value * 100, 0);
	            afterUnit = typeof afterUnit === 'string' ? afterUnit : '%';
	            break;
	        case 'percentSave2Decimal': // 百分比, 保留两位小数
	            val = transformShortNum(value, 2);
	            afterUnit = typeof afterUnit === 'string' ? afterUnit : '%';
	            break;
	        case 'percentSave0Decimal': // 百分比, 不保留两位小数
	            val = transformShortNum(value, 0);
	            afterUnit = typeof afterUnit === 'string' ? afterUnit : '%';
	            break;
	        case 'int': // 数量, 小于1万时,舍弃小数点，仅保留整数
	            val = transformShortNum(value, 2, true, true);
	            break;
	        case 'decimal': // 数量, 小于1万时,保留小数点
	            val = transformShortNum(value, 2, true, false);
	            break;
	        case 'secToTimeHM': // 秒转为 xxhyym
	            val = formatTime(value, '{HH}h{mm}m');
	            break;
	        case 'secToTimeChMS': // 秒转为 xx分yy秒
	            val = formatTime(value, '{mm}分{ss}秒');
	            break;
	        case 'secToTimeMS': // 秒转为 xxmyys
	            val = formatTime(value, '{mm}m{ss}s');
	            break;
	        case 'secToTime': // 秒转为 {DD}d{HH}h{mm}m{ss}s,天数和小时为零时不展示
	            val = formatTime(value, '{DD}d{HH}h{mm}m{ss}s', false);
	            val = val.replace('00d', '').replace('00h', '');
	            break;
	        default:
	            val = transformShortNum(value);
	    }
	    val = val !== '-' && isAbs ? val.replace('-', '') : val;
	    return val === '-' ? '-' : `${beforeUnit || ''}${val}${afterUnit || ''}`;
	};

	const niceNumShow = (val, spiltPoint = false) => {
	    if ((val !== 0 && !val) || val === '-') {
	        return [{ type: 'num', text: '-' }];
	    }
	    const resultList = [];
	    const list = val.toString().split('');
	    let text = '';
	    let type; // 1: 数字 2: . 3: 非数字
	    list.forEach((character) => {
	        let characterType = (/^[0-9\\.]*$/.test(character)) ? 'num' : 'character';
	        characterType = ((character === '.' && spiltPoint) || (characterType === 'num' && type === 'suffixNum')) ? 'suffixNum' : characterType;
	        if (type !== characterType && type) {
	            resultList.push({ type, text });
	            text = character;
	        }
	        else {
	            text = `${text}${character}`;
	        }
	        type = characterType;
	    });
	    type = type || 'num';
	    resultList.push({ type, text });
	    return resultList;
	};

	const isChinaMobile = (value) => {
	    return /^((\+86)|(86)|(086))?(13[0-9]|15[0-9]|166|17[0-9]|18[0-9]|14[0-9]|19[0-9])[0-9]{8}$/.test(String(value));
	};

	const isURL = (value) => {
	    return /^((?:(?:https?|ftp):|)\/\/)(?:\S+(?::\S*)?@)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,}))\.?)(?::\d{2,5})?(?:[/?#]\S*)?$/i.test(String(value));
	};

	const YR = {
	    email: /\w+([-+.']\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*/,
	    phone: /^1[3|4|5|6|7|8][0-9]{9}$/,
	    fixedPhone: /(^0\d{2,3}-\d{7,8}$)|(^1[3|4|5|6|7|8][0-9]{9}$)/,
	    qq: /[1-9][0-9]{4,}/,
	    zipcode: /[1-9]\d{5}(?!\d)/,
	    IDCard: /^\d{17}[\d|X|x]|\d{15}$/,
	    chinese: /^[\u0391-\uFFE5]+$/,
	    chineseNumberLine: /^[\u4E00-\u9FA5A-Za-z0-9_]+$/,
	    chineseNumberNoLine: /^[\u4E00-\u9FA5A-Za-z0-9]+$/,
	    integerZ: /^[1-9]\d*$/,
	    integerF: /^-[1-9]\d*$/,
	    number: /^\d+(\.\d+)?$/,
	    numberNoMoreThan1: /^\-?([0-9](\d+)?(\.\d{1,1})?$)|(^0$)|(^\d\.\d{1,1})$/,
	    numberNoMoreThan2: /^\-?([0-9](\d+)?(\.\d{1,2})?$)|(^0$)|(^\d\.\d{1,2})$/,
	    numberNoMoreThan3: /^\-?([0-9](\d+)?(\.\d{1,3})?$)|(^0$)|(^\d\.\d{1,3})$/,
	    numberNoMoreThan4: /^\-?([0-9](\d+)?(\.\d{1,4})?$)|(^0$)|(^\d\.\d{1,4})$/,
	    greaterZero1: /^(0|[1-9]\d*)(\.\d{1,1})?$/,
	    greaterZero2: /^(0|[1-9]\d*)(\.\d{1,2})?$/,
	    greaterZero3: /^(0|[1-9]\d*)(\.\d{1,3})?$/,
	    greaterZero4: /^(0|[1-9]\d*)(\.\d{1,4})?$/,
	    zeroTo100: /^((\d|[1-9]\d)(\.\d{1,2})?$)|(^100|100.0|100.00$)$/,
	    zeroTo1000: /^((\d|[1-9]{1,2}\d)(\.\d{1,2})?$)|(^1000|1000.0|1000.00$)$/, // 零到1000，最多保留两位数字
	};

	const getQueryOfNextPageContext = (ctx) => {
	    if (!ctx) {
	        return {};
	    }
	    const { pathname = '', asPath = '', query } = ctx;
	    const routes = pipe(split$2('/'), filter$1((item) => /\[\w+\]/.test(item)), map$1((item) => replace$1(']', '', replace$1('[', '', item))))(pathname);
	    const path = pipe((split$2('#')), slice$1(0, 1))(asPath) || [];
	    const paths = path.length
	        ? pipe(split$2('/'), filter$1((item) => item !== ''))(path[0])
	        : [];
	    const result = routes.map((key, index) => {
	        return {
	            [`${key}`]: paths[index],
	        };
	    });
	    let newQuery = {};
	    if (!routes.length) {
	        newQuery.path = paths[0] || 'desktop';
	    }
	    else {
	        newQuery = mergeAll$1(result) || {};
	    }
	    return Object.assign(Object.assign({}, query), newQuery);
	};

	const getEnv = () => {
	    return window.localStorage.getItem('env') || 'prod';
	};
	const getMock = () => {
	    return window.localStorage.getItem('isMock');
	};

	const getHost = (projectId, yapiProjectid, isMock) => {
	    const configs = window.configs ? window.configs : {};
	    let env = isMock && getMock() ? 'mock' : getEnv();
	    const basePath = configs[projectId]
	        ? configs[projectId][env].API_BASE_URL +
	            `${env === 'mock' ? '/' + yapiProjectid : ''}`
	        : '';
	    const loginPath = configs['AUTH'] ? configs['AUTH'][env].APPLICATION_URL : '';
	    return {
	        basePath,
	        loginPath,
	    };
	};

	const parseParams = (params) => {
	    return values$1(params).join('/');
	};

	const reduceParams = (data) => {
	    if (!data) {
	        return {};
	    }
	    if (data instanceof FormData) {
	        return data;
	    }
	    const result = filter$1(item => !isNil$1(item) && !isEmpty$1(item))(data) || {};
	    return result;
	};

	const parse$1 = (str) => {
	  if(!str) {
	    return {};
	  }
	  const result = pipe(
	    replace$1('?', ''),
	    split$2('&'),
	    map$1((item) => split$2('=', decodeURI(item))),
	    fromPairs$1,
	  )(str);
	  return result
	};

	const stringify$2 = (query) => {
	  if(isEmpty$1(query)){
	    return ''
	  }
	  const keys = Object.keys(query);
	  let result = '';
	  keys.map((key) => {
	    result += `&${key}=${query[key]}`;
	  });
	  const params = new URLSearchParams(result);
	  return params.toString() || '';
	};

	var querystring = /*#__PURE__*/Object.freeze({
	    __proto__: null,
	    parse: parse$1,
	    stringify: stringify$2
	});

	/**
	 * 获取地址对应参数
	 * @param name
	 * @param search
	 * @returns
	 */
	const getQuery = (name, search) => {
	    const reg = new RegExp(`(\\?|&)${name}=([^&]*)(&|$)`, 'i');
	    let searchParams = window.location.href;
	    const values = reg.exec((search || searchParams));
	    if (values != null) {
	        return decodeURIComponent(values[2]) || '';
	    }
	    return '';
	};
	/**
	 * 获取地址所有参数
	 * @param search
	 * @returns
	 */
	const getQueries = (search) => {
	    let str = search || window.location.search;
	    str = str.replace('?', '');
	    let result = parse$1(str);
	    return (result || {});
	};
	/**
	 * 获取地址对应参数
	 * @param name
	 * @param urlStr
	 * @returns
	 */
	const getQueryName = (name, urlStr) => {
	    let url = urlStr || decodeURI(window.location.href);
	    url = url.split('?')[1];
	    const querys = new Object();
	    if (url.indexOf('?') === -1) {
	        const strs = url.split('&');
	        for (let i = 0; i < strs.length; i++) {
	            const oneStr = strs[i];
	            const index = oneStr.indexOf('=');
	            if (index > 0) {
	                querys[oneStr.substr(0, index)] = decodeURI(oneStr.substr(index + 1));
	            }
	        }
	    }
	    return querys[name] || '';
	};

	const joinPath = (params) => {
	    if (!params || isEmpty$1(params)) {
	        return '';
	    }
	    const keys = Object.keys(params);
	    let result = '';
	    keys.map((key) => {
	        if (params[key] && key !== 'search') {
	            result += `/${params[key]}`;
	        }
	        if (key === 'search') {
	            result += params[key];
	        }
	    });
	    return result;
	};

	const slicePath = (path, start = 0, end) => {
	    const paths = split('/', path);
	    if (!end) {
	        end = paths.length - 1;
	    }
	    const newPaths = paths.slice(start, end);
	    return '/' + newPaths.join('/');
	};

	/**
	 * map 结构转 array
	 * @param map
	 * @param useAllSelect 全部默认选项
	 * @param allSelectLabel 全部项默认lable
	 * @param allSelectValue 全部项默认value
	 * @returns OptionsItem[]
	 */
	const translateMapToArray = (map, useAllSelect = false, allSelectLabel = '全部', allSelectValue = null) => {
	    // 全部项
	    const allSelect = { label: allSelectLabel, value: allSelectValue };
	    let array = useAllSelect ? [allSelect] : [];
	    for (const [key, value] of map.entries()) {
	        array.push({
	            label: value,
	            value: key,
	        });
	    }
	    return array;
	};

	const addQueries = (params) => {
	    const arr = [];
	    Object.keys(params).forEach((key) => {
	        if (!(isEmpty$1(params[key]) || isNil$1(params[key]))) {
	            arr.push(`${key}=${params[key]}`);
	        }
	    });
	    return arr.join('&');
	};
	/**
	 *
	 * @param url 下载地址
	 * @param params 参数集合
	 */
	const exportExcel = (url, params = {}) => {
	    let token;
	    if (typeof window !== 'undefined') {
	        token = window.localStorage.getItem('token');
	        const data = Object.assign(Object.assign({}, params), { token });
	        if (!/^https.*/.test(url)) {
	            // eslint-disable-next-line no-param-reassign
	            url = url.replace('http', 'https');
	        }
	        const downloadUrl = `${url}?${addQueries(data)}`;
	        console.log('YWFE下载地址=>', downloadUrl);
	        const id = `alink_${new Date().getTime()}`;
	        const aDom = document.createElement('a');
	        aDom.setAttribute('href', downloadUrl);
	        aDom.setAttribute('target', '_blank');
	        aDom.setAttribute('id', id);
	        if (!document.getElementById(id)) {
	            document.body.appendChild(aDom);
	        }
	        aDom.click();
	        setTimeout(() => {
	            document.body.removeChild(aDom);
	        }, 0);
	    }
	};

	/**
	 * 同步下载
	 * @param data 带转换的arraybuffer数据
	 * @param name 文件名
	 */
	const omadownload = (data, name, fileType) => {
	    const uint8Msg = new Uint8Array(data);
	    try {
	        const uint8String = String.fromCharCode.apply(null, uint8Msg);
	        if (uint8String.indexOf('success') > -1) {
	            // message.error('导出失败');
	            return JSON.parse(uint8String);
	        }
	    }
	    catch (error) {
	        console.warn(error);
	    }
	    const url = window.URL.createObjectURL(new Blob([data], { type: fileType || 'application/vnd.ms-excel' }));
	    const link = document.createElement('a');
	    link.style.display = 'none';
	    link.href = url;
	    link.setAttribute('download', decodeURIComponent(name));
	    document.body.appendChild(link);
	    link.click();
	    link.remove();
	};

	/*
	 *  big.js v5.2.2
	 *  A small, fast, easy-to-use library for arbitrary-precision decimal arithmetic.
	 *  Copyright (c) 2018 Michael Mclaughlin <M8ch88l@gmail.com>
	 *  https://github.com/MikeMcl/big.js/LICENCE
	 */


	/************************************** EDITABLE DEFAULTS *****************************************/


	  // The default values below must be integers within the stated ranges.

	  /*
	   * The maximum number of decimal places (DP) of the results of operations involving division:
	   * div and sqrt, and pow with negative exponents.
	   */
	var DP = 20,          // 0 to MAX_DP

	  /*
	   * The rounding mode (RM) used when rounding to the above decimal places.
	   *
	   *  0  Towards zero (i.e. truncate, no rounding).       (ROUND_DOWN)
	   *  1  To nearest neighbour. If equidistant, round up.  (ROUND_HALF_UP)
	   *  2  To nearest neighbour. If equidistant, to even.   (ROUND_HALF_EVEN)
	   *  3  Away from zero.                                  (ROUND_UP)
	   */
	  RM = 1,             // 0, 1, 2 or 3

	  // The maximum value of DP and Big.DP.
	  MAX_DP = 1E6,       // 0 to 1000000

	  // The maximum magnitude of the exponent argument to the pow method.
	  MAX_POWER = 1E6,    // 1 to 1000000

	  /*
	   * The negative exponent (NE) at and beneath which toString returns exponential notation.
	   * (JavaScript numbers: -7)
	   * -1000000 is the minimum recommended exponent value of a Big.
	   */
	  NE = -7,            // 0 to -1000000

	  /*
	   * The positive exponent (PE) at and above which toString returns exponential notation.
	   * (JavaScript numbers: 21)
	   * 1000000 is the maximum recommended exponent value of a Big.
	   * (This limit is not enforced or checked.)
	   */
	  PE = 21,            // 0 to 1000000


	/**************************************************************************************************/


	  // Error messages.
	  NAME = '[big.js] ',
	  INVALID = NAME + 'Invalid ',
	  INVALID_DP = INVALID + 'decimal places',
	  INVALID_RM = INVALID + 'rounding mode',
	  DIV_BY_ZERO = NAME + 'Division by zero',

	  // The shared prototype object.
	  P = {},
	  UNDEFINED = void 0,
	  NUMERIC = /^-?(\d+(\.\d*)?|\.\d+)(e[+-]?\d+)?$/i;


	/*
	 * Create and return a Big constructor.
	 *
	 */
	function _Big_() {

	  /*
	   * The Big constructor and exported function.
	   * Create and return a new instance of a Big number object.
	   *
	   * n {number|string|Big} A numeric value.
	   */
	  function Big(n) {
	    var x = this;

	    // Enable constructor usage without new.
	    if (!(x instanceof Big)) return n === UNDEFINED ? _Big_() : new Big(n);

	    // Duplicate.
	    if (n instanceof Big) {
	      x.s = n.s;
	      x.e = n.e;
	      x.c = n.c.slice();
	    } else {
	      parse(x, n);
	    }

	    /*
	     * Retain a reference to this Big constructor, and shadow Big.prototype.constructor which
	     * points to Object.
	     */
	    x.constructor = Big;
	  }

	  Big.prototype = P;
	  Big.DP = DP;
	  Big.RM = RM;
	  Big.NE = NE;
	  Big.PE = PE;
	  Big.version = '5.2.2';

	  return Big;
	}


	/*
	 * Parse the number or string value passed to a Big constructor.
	 *
	 * x {Big} A Big number instance.
	 * n {number|string} A numeric value.
	 */
	function parse(x, n) {
	  var e, i, nl;

	  // Minus zero?
	  if (n === 0 && 1 / n < 0) n = '-0';
	  else if (!NUMERIC.test(n += '')) throw Error(INVALID + 'number');

	  // Determine sign.
	  x.s = n.charAt(0) == '-' ? (n = n.slice(1), -1) : 1;

	  // Decimal point?
	  if ((e = n.indexOf('.')) > -1) n = n.replace('.', '');

	  // Exponential form?
	  if ((i = n.search(/e/i)) > 0) {

	    // Determine exponent.
	    if (e < 0) e = i;
	    e += +n.slice(i + 1);
	    n = n.substring(0, i);
	  } else if (e < 0) {

	    // Integer.
	    e = n.length;
	  }

	  nl = n.length;

	  // Determine leading zeros.
	  for (i = 0; i < nl && n.charAt(i) == '0';) ++i;

	  if (i == nl) {

	    // Zero.
	    x.c = [x.e = 0];
	  } else {

	    // Determine trailing zeros.
	    for (; nl > 0 && n.charAt(--nl) == '0';);
	    x.e = e - i - 1;
	    x.c = [];

	    // Convert string to array of digits without leading/trailing zeros.
	    for (e = 0; i <= nl;) x.c[e++] = +n.charAt(i++);
	  }

	  return x;
	}


	/*
	 * Round Big x to a maximum of dp decimal places using rounding mode rm.
	 * Called by stringify, P.div, P.round and P.sqrt.
	 *
	 * x {Big} The Big to round.
	 * dp {number} Integer, 0 to MAX_DP inclusive.
	 * rm {number} 0, 1, 2 or 3 (DOWN, HALF_UP, HALF_EVEN, UP)
	 * [more] {boolean} Whether the result of division was truncated.
	 */
	function round$1(x, dp, rm, more) {
	  var xc = x.c,
	    i = x.e + dp + 1;

	  if (i < xc.length) {
	    if (rm === 1) {

	      // xc[i] is the digit after the digit that may be rounded up.
	      more = xc[i] >= 5;
	    } else if (rm === 2) {
	      more = xc[i] > 5 || xc[i] == 5 &&
	        (more || i < 0 || xc[i + 1] !== UNDEFINED || xc[i - 1] & 1);
	    } else if (rm === 3) {
	      more = more || !!xc[0];
	    } else {
	      more = false;
	      if (rm !== 0) throw Error(INVALID_RM);
	    }

	    if (i < 1) {
	      xc.length = 1;

	      if (more) {

	        // 1, 0.1, 0.01, 0.001, 0.0001 etc.
	        x.e = -dp;
	        xc[0] = 1;
	      } else {

	        // Zero.
	        xc[0] = x.e = 0;
	      }
	    } else {

	      // Remove any digits after the required decimal places.
	      xc.length = i--;

	      // Round up?
	      if (more) {

	        // Rounding up may mean the previous digit has to be rounded up.
	        for (; ++xc[i] > 9;) {
	          xc[i] = 0;
	          if (!i--) {
	            ++x.e;
	            xc.unshift(1);
	          }
	        }
	      }

	      // Remove trailing zeros.
	      for (i = xc.length; !xc[--i];) xc.pop();
	    }
	  } else if (rm < 0 || rm > 3 || rm !== ~~rm) {
	    throw Error(INVALID_RM);
	  }

	  return x;
	}


	/*
	 * Return a string representing the value of Big x in normal or exponential notation.
	 * Handles P.toExponential, P.toFixed, P.toJSON, P.toPrecision, P.toString and P.valueOf.
	 *
	 * x {Big}
	 * id? {number} Caller id.
	 *         1 toExponential
	 *         2 toFixed
	 *         3 toPrecision
	 *         4 valueOf
	 * n? {number|undefined} Caller's argument.
	 * k? {number|undefined}
	 */
	function stringify$1(x, id, n, k) {
	  var e, s,
	    Big = x.constructor,
	    z = !x.c[0];

	  if (n !== UNDEFINED) {
	    if (n !== ~~n || n < (id == 3) || n > MAX_DP) {
	      throw Error(id == 3 ? INVALID + 'precision' : INVALID_DP);
	    }

	    x = new Big(x);

	    // The index of the digit that may be rounded up.
	    n = k - x.e;

	    // Round?
	    if (x.c.length > ++k) round$1(x, n, Big.RM);

	    // toFixed: recalculate k as x.e may have changed if value rounded up.
	    if (id == 2) k = x.e + n + 1;

	    // Append zeros?
	    for (; x.c.length < k;) x.c.push(0);
	  }

	  e = x.e;
	  s = x.c.join('');
	  n = s.length;

	  // Exponential notation?
	  if (id != 2 && (id == 1 || id == 3 && k <= e || e <= Big.NE || e >= Big.PE)) {
	    s = s.charAt(0) + (n > 1 ? '.' + s.slice(1) : '') + (e < 0 ? 'e' : 'e+') + e;

	  // Normal notation.
	  } else if (e < 0) {
	    for (; ++e;) s = '0' + s;
	    s = '0.' + s;
	  } else if (e > 0) {
	    if (++e > n) for (e -= n; e--;) s += '0';
	    else if (e < n) s = s.slice(0, e) + '.' + s.slice(e);
	  } else if (n > 1) {
	    s = s.charAt(0) + '.' + s.slice(1);
	  }

	  return x.s < 0 && (!z || id == 4) ? '-' + s : s;
	}


	// Prototype/instance methods


	/*
	 * Return a new Big whose value is the absolute value of this Big.
	 */
	P.abs = function () {
	  var x = new this.constructor(this);
	  x.s = 1;
	  return x;
	};


	/*
	 * Return 1 if the value of this Big is greater than the value of Big y,
	 *       -1 if the value of this Big is less than the value of Big y, or
	 *        0 if they have the same value.
	*/
	P.cmp = function (y) {
	  var isneg,
	    x = this,
	    xc = x.c,
	    yc = (y = new x.constructor(y)).c,
	    i = x.s,
	    j = y.s,
	    k = x.e,
	    l = y.e;

	  // Either zero?
	  if (!xc[0] || !yc[0]) return !xc[0] ? !yc[0] ? 0 : -j : i;

	  // Signs differ?
	  if (i != j) return i;

	  isneg = i < 0;

	  // Compare exponents.
	  if (k != l) return k > l ^ isneg ? 1 : -1;

	  j = (k = xc.length) < (l = yc.length) ? k : l;

	  // Compare digit by digit.
	  for (i = -1; ++i < j;) {
	    if (xc[i] != yc[i]) return xc[i] > yc[i] ^ isneg ? 1 : -1;
	  }

	  // Compare lengths.
	  return k == l ? 0 : k > l ^ isneg ? 1 : -1;
	};


	/*
	 * Return a new Big whose value is the value of this Big divided by the value of Big y, rounded,
	 * if necessary, to a maximum of Big.DP decimal places using rounding mode Big.RM.
	 */
	P.div = function (y) {
	  var x = this,
	    Big = x.constructor,
	    a = x.c,                  // dividend
	    b = (y = new Big(y)).c,   // divisor
	    k = x.s == y.s ? 1 : -1,
	    dp = Big.DP;

	  if (dp !== ~~dp || dp < 0 || dp > MAX_DP) throw Error(INVALID_DP);

	  // Divisor is zero?
	  if (!b[0]) throw Error(DIV_BY_ZERO);

	  // Dividend is 0? Return +-0.
	  if (!a[0]) return new Big(k * 0);

	  var bl, bt, n, cmp, ri,
	    bz = b.slice(),
	    ai = bl = b.length,
	    al = a.length,
	    r = a.slice(0, bl),   // remainder
	    rl = r.length,
	    q = y,                // quotient
	    qc = q.c = [],
	    qi = 0,
	    d = dp + (q.e = x.e - y.e) + 1;    // number of digits of the result

	  q.s = k;
	  k = d < 0 ? 0 : d;

	  // Create version of divisor with leading zero.
	  bz.unshift(0);

	  // Add zeros to make remainder as long as divisor.
	  for (; rl++ < bl;) r.push(0);

	  do {

	    // n is how many times the divisor goes into current remainder.
	    for (n = 0; n < 10; n++) {

	      // Compare divisor and remainder.
	      if (bl != (rl = r.length)) {
	        cmp = bl > rl ? 1 : -1;
	      } else {
	        for (ri = -1, cmp = 0; ++ri < bl;) {
	          if (b[ri] != r[ri]) {
	            cmp = b[ri] > r[ri] ? 1 : -1;
	            break;
	          }
	        }
	      }

	      // If divisor < remainder, subtract divisor from remainder.
	      if (cmp < 0) {

	        // Remainder can't be more than 1 digit longer than divisor.
	        // Equalise lengths using divisor with extra leading zero?
	        for (bt = rl == bl ? b : bz; rl;) {
	          if (r[--rl] < bt[rl]) {
	            ri = rl;
	            for (; ri && !r[--ri];) r[ri] = 9;
	            --r[ri];
	            r[rl] += 10;
	          }
	          r[rl] -= bt[rl];
	        }

	        for (; !r[0];) r.shift();
	      } else {
	        break;
	      }
	    }

	    // Add the digit n to the result array.
	    qc[qi++] = cmp ? n : ++n;

	    // Update the remainder.
	    if (r[0] && cmp) r[rl] = a[ai] || 0;
	    else r = [a[ai]];

	  } while ((ai++ < al || r[0] !== UNDEFINED) && k--);

	  // Leading zero? Do not remove if result is simply zero (qi == 1).
	  if (!qc[0] && qi != 1) {

	    // There can't be more than one zero.
	    qc.shift();
	    q.e--;
	  }

	  // Round?
	  if (qi > d) round$1(q, dp, Big.RM, r[0] !== UNDEFINED);

	  return q;
	};


	/*
	 * Return true if the value of this Big is equal to the value of Big y, otherwise return false.
	 */
	P.eq = function (y) {
	  return !this.cmp(y);
	};


	/*
	 * Return true if the value of this Big is greater than the value of Big y, otherwise return
	 * false.
	 */
	P.gt = function (y) {
	  return this.cmp(y) > 0;
	};


	/*
	 * Return true if the value of this Big is greater than or equal to the value of Big y, otherwise
	 * return false.
	 */
	P.gte = function (y) {
	  return this.cmp(y) > -1;
	};


	/*
	 * Return true if the value of this Big is less than the value of Big y, otherwise return false.
	 */
	P.lt = function (y) {
	  return this.cmp(y) < 0;
	};


	/*
	 * Return true if the value of this Big is less than or equal to the value of Big y, otherwise
	 * return false.
	 */
	P.lte = function (y) {
	  return this.cmp(y) < 1;
	};


	/*
	 * Return a new Big whose value is the value of this Big minus the value of Big y.
	 */
	P.minus = P.sub = function (y) {
	  var i, j, t, xlty,
	    x = this,
	    Big = x.constructor,
	    a = x.s,
	    b = (y = new Big(y)).s;

	  // Signs differ?
	  if (a != b) {
	    y.s = -b;
	    return x.plus(y);
	  }

	  var xc = x.c.slice(),
	    xe = x.e,
	    yc = y.c,
	    ye = y.e;

	  // Either zero?
	  if (!xc[0] || !yc[0]) {

	    // y is non-zero? x is non-zero? Or both are zero.
	    return yc[0] ? (y.s = -b, y) : new Big(xc[0] ? x : 0);
	  }

	  // Determine which is the bigger number. Prepend zeros to equalise exponents.
	  if (a = xe - ye) {

	    if (xlty = a < 0) {
	      a = -a;
	      t = xc;
	    } else {
	      ye = xe;
	      t = yc;
	    }

	    t.reverse();
	    for (b = a; b--;) t.push(0);
	    t.reverse();
	  } else {

	    // Exponents equal. Check digit by digit.
	    j = ((xlty = xc.length < yc.length) ? xc : yc).length;

	    for (a = b = 0; b < j; b++) {
	      if (xc[b] != yc[b]) {
	        xlty = xc[b] < yc[b];
	        break;
	      }
	    }
	  }

	  // x < y? Point xc to the array of the bigger number.
	  if (xlty) {
	    t = xc;
	    xc = yc;
	    yc = t;
	    y.s = -y.s;
	  }

	  /*
	   * Append zeros to xc if shorter. No need to add zeros to yc if shorter as subtraction only
	   * needs to start at yc.length.
	   */
	  if ((b = (j = yc.length) - (i = xc.length)) > 0) for (; b--;) xc[i++] = 0;

	  // Subtract yc from xc.
	  for (b = i; j > a;) {
	    if (xc[--j] < yc[j]) {
	      for (i = j; i && !xc[--i];) xc[i] = 9;
	      --xc[i];
	      xc[j] += 10;
	    }

	    xc[j] -= yc[j];
	  }

	  // Remove trailing zeros.
	  for (; xc[--b] === 0;) xc.pop();

	  // Remove leading zeros and adjust exponent accordingly.
	  for (; xc[0] === 0;) {
	    xc.shift();
	    --ye;
	  }

	  if (!xc[0]) {

	    // n - n = +0
	    y.s = 1;

	    // Result must be zero.
	    xc = [ye = 0];
	  }

	  y.c = xc;
	  y.e = ye;

	  return y;
	};


	/*
	 * Return a new Big whose value is the value of this Big modulo the value of Big y.
	 */
	P.mod = function (y) {
	  var ygtx,
	    x = this,
	    Big = x.constructor,
	    a = x.s,
	    b = (y = new Big(y)).s;

	  if (!y.c[0]) throw Error(DIV_BY_ZERO);

	  x.s = y.s = 1;
	  ygtx = y.cmp(x) == 1;
	  x.s = a;
	  y.s = b;

	  if (ygtx) return new Big(x);

	  a = Big.DP;
	  b = Big.RM;
	  Big.DP = Big.RM = 0;
	  x = x.div(y);
	  Big.DP = a;
	  Big.RM = b;

	  return this.minus(x.times(y));
	};


	/*
	 * Return a new Big whose value is the value of this Big plus the value of Big y.
	 */
	P.plus = P.add = function (y) {
	  var t,
	    x = this,
	    Big = x.constructor,
	    a = x.s,
	    b = (y = new Big(y)).s;

	  // Signs differ?
	  if (a != b) {
	    y.s = -b;
	    return x.minus(y);
	  }

	  var xe = x.e,
	    xc = x.c,
	    ye = y.e,
	    yc = y.c;

	  // Either zero? y is non-zero? x is non-zero? Or both are zero.
	  if (!xc[0] || !yc[0]) return yc[0] ? y : new Big(xc[0] ? x : a * 0);

	  xc = xc.slice();

	  // Prepend zeros to equalise exponents.
	  // Note: reverse faster than unshifts.
	  if (a = xe - ye) {
	    if (a > 0) {
	      ye = xe;
	      t = yc;
	    } else {
	      a = -a;
	      t = xc;
	    }

	    t.reverse();
	    for (; a--;) t.push(0);
	    t.reverse();
	  }

	  // Point xc to the longer array.
	  if (xc.length - yc.length < 0) {
	    t = yc;
	    yc = xc;
	    xc = t;
	  }

	  a = yc.length;

	  // Only start adding at yc.length - 1 as the further digits of xc can be left as they are.
	  for (b = 0; a; xc[a] %= 10) b = (xc[--a] = xc[a] + yc[a] + b) / 10 | 0;

	  // No need to check for zero, as +x + +y != 0 && -x + -y != 0

	  if (b) {
	    xc.unshift(b);
	    ++ye;
	  }

	  // Remove trailing zeros.
	  for (a = xc.length; xc[--a] === 0;) xc.pop();

	  y.c = xc;
	  y.e = ye;

	  return y;
	};


	/*
	 * Return a Big whose value is the value of this Big raised to the power n.
	 * If n is negative, round to a maximum of Big.DP decimal places using rounding
	 * mode Big.RM.
	 *
	 * n {number} Integer, -MAX_POWER to MAX_POWER inclusive.
	 */
	P.pow = function (n) {
	  var x = this,
	    one = new x.constructor(1),
	    y = one,
	    isneg = n < 0;

	  if (n !== ~~n || n < -MAX_POWER || n > MAX_POWER) throw Error(INVALID + 'exponent');
	  if (isneg) n = -n;

	  for (;;) {
	    if (n & 1) y = y.times(x);
	    n >>= 1;
	    if (!n) break;
	    x = x.times(x);
	  }

	  return isneg ? one.div(y) : y;
	};


	/*
	 * Return a new Big whose value is the value of this Big rounded using rounding mode rm
	 * to a maximum of dp decimal places, or, if dp is negative, to an integer which is a
	 * multiple of 10**-dp.
	 * If dp is not specified, round to 0 decimal places.
	 * If rm is not specified, use Big.RM.
	 *
	 * dp? {number} Integer, -MAX_DP to MAX_DP inclusive.
	 * rm? 0, 1, 2 or 3 (ROUND_DOWN, ROUND_HALF_UP, ROUND_HALF_EVEN, ROUND_UP)
	 */
	P.round = function (dp, rm) {
	  var Big = this.constructor;
	  if (dp === UNDEFINED) dp = 0;
	  else if (dp !== ~~dp || dp < -MAX_DP || dp > MAX_DP) throw Error(INVALID_DP);
	  return round$1(new Big(this), dp, rm === UNDEFINED ? Big.RM : rm);
	};


	/*
	 * Return a new Big whose value is the square root of the value of this Big, rounded, if
	 * necessary, to a maximum of Big.DP decimal places using rounding mode Big.RM.
	 */
	P.sqrt = function () {
	  var r, c, t,
	    x = this,
	    Big = x.constructor,
	    s = x.s,
	    e = x.e,
	    half = new Big(0.5);

	  // Zero?
	  if (!x.c[0]) return new Big(x);

	  // Negative?
	  if (s < 0) throw Error(NAME + 'No square root');

	  // Estimate.
	  s = Math.sqrt(x + '');

	  // Math.sqrt underflow/overflow?
	  // Re-estimate: pass x coefficient to Math.sqrt as integer, then adjust the result exponent.
	  if (s === 0 || s === 1 / 0) {
	    c = x.c.join('');
	    if (!(c.length + e & 1)) c += '0';
	    s = Math.sqrt(c);
	    e = ((e + 1) / 2 | 0) - (e < 0 || e & 1);
	    r = new Big((s == 1 / 0 ? '1e' : (s = s.toExponential()).slice(0, s.indexOf('e') + 1)) + e);
	  } else {
	    r = new Big(s);
	  }

	  e = r.e + (Big.DP += 4);

	  // Newton-Raphson iteration.
	  do {
	    t = r;
	    r = half.times(t.plus(x.div(t)));
	  } while (t.c.slice(0, e).join('') !== r.c.slice(0, e).join(''));

	  return round$1(r, Big.DP -= 4, Big.RM);
	};


	/*
	 * Return a new Big whose value is the value of this Big times the value of Big y.
	 */
	P.times = P.mul = function (y) {
	  var c,
	    x = this,
	    Big = x.constructor,
	    xc = x.c,
	    yc = (y = new Big(y)).c,
	    a = xc.length,
	    b = yc.length,
	    i = x.e,
	    j = y.e;

	  // Determine sign of result.
	  y.s = x.s == y.s ? 1 : -1;

	  // Return signed 0 if either 0.
	  if (!xc[0] || !yc[0]) return new Big(y.s * 0);

	  // Initialise exponent of result as x.e + y.e.
	  y.e = i + j;

	  // If array xc has fewer digits than yc, swap xc and yc, and lengths.
	  if (a < b) {
	    c = xc;
	    xc = yc;
	    yc = c;
	    j = a;
	    a = b;
	    b = j;
	  }

	  // Initialise coefficient array of result with zeros.
	  for (c = new Array(j = a + b); j--;) c[j] = 0;

	  // Multiply.

	  // i is initially xc.length.
	  for (i = b; i--;) {
	    b = 0;

	    // a is yc.length.
	    for (j = a + i; j > i;) {

	      // Current sum of products at this digit position, plus carry.
	      b = c[j] + yc[i] * xc[j - i - 1] + b;
	      c[j--] = b % 10;

	      // carry
	      b = b / 10 | 0;
	    }

	    c[j] = (c[j] + b) % 10;
	  }

	  // Increment result exponent if there is a final carry, otherwise remove leading zero.
	  if (b) ++y.e;
	  else c.shift();

	  // Remove trailing zeros.
	  for (i = c.length; !c[--i];) c.pop();
	  y.c = c;

	  return y;
	};


	/*
	 * Return a string representing the value of this Big in exponential notation to dp fixed decimal
	 * places and rounded using Big.RM.
	 *
	 * dp? {number} Integer, 0 to MAX_DP inclusive.
	 */
	P.toExponential = function (dp) {
	  return stringify$1(this, 1, dp, dp);
	};


	/*
	 * Return a string representing the value of this Big in normal notation to dp fixed decimal
	 * places and rounded using Big.RM.
	 *
	 * dp? {number} Integer, 0 to MAX_DP inclusive.
	 *
	 * (-0).toFixed(0) is '0', but (-0.1).toFixed(0) is '-0'.
	 * (-0).toFixed(1) is '0.0', but (-0.01).toFixed(1) is '-0.0'.
	 */
	P.toFixed = function (dp) {
	  return stringify$1(this, 2, dp, this.e + dp);
	};


	/*
	 * Return a string representing the value of this Big rounded to sd significant digits using
	 * Big.RM. Use exponential notation if sd is less than the number of digits necessary to represent
	 * the integer part of the value in normal notation.
	 *
	 * sd {number} Integer, 1 to MAX_DP inclusive.
	 */
	P.toPrecision = function (sd) {
	  return stringify$1(this, 3, sd, sd - 1);
	};


	/*
	 * Return a string representing the value of this Big.
	 * Return exponential notation if this Big has a positive exponent equal to or greater than
	 * Big.PE, or a negative exponent equal to or less than Big.NE.
	 * Omit the sign for negative zero.
	 */
	P.toString = function () {
	  return stringify$1(this);
	};


	/*
	 * Return a string representing the value of this Big.
	 * Return exponential notation if this Big has a positive exponent equal to or greater than
	 * Big.PE, or a negative exponent equal to or less than Big.NE.
	 * Include the sign for negative zero.
	 */
	P.valueOf = P.toJSON = function () {
	  return stringify$1(this, 4);
	};


	// Export


	var Big = _Big_();

	/**
	 * 求一个数保留小数，不四舍五入
	 * @param num 数字
	 * @param decimal 精度
	 */
	const formatDecimalNoRound = (num, decimal) => {
	    num = num.toString();
	    const index = num.indexOf('.');
	    if (index !== -1) {
	        num = num.substring(0, decimal + index + 1);
	    }
	    else {
	        num = num.substring(0);
	    }
	    return Number(parseFloat(num).toFixed(decimal));
	};

	/**
	 * 小数字转大数字
	 * @param translateUnit
	 */
	const smallToBig = (translateUnit) => {
	    return (num, params) => {
	        if (isEmpty$1(num) || isNil$1(num))
	            return num;
	        if (isNaN(Number(num))) {
	            return NaN;
	        }
	        const newNumber = Number(new Big(Number(num)).mul(translateUnit));
	        if (isNil$1(params === null || params === void 0 ? void 0 : params.decimalNumber) && isNil$1(params === null || params === void 0 ? void 0 : params.fn)) {
	            return newNumber;
	        }
	        if (!isNil$1(params === null || params === void 0 ? void 0 : params.decimalNumber) && isNil$1(params === null || params === void 0 ? void 0 : params.fn)) {
	            return Number(newNumber.toFixed(params === null || params === void 0 ? void 0 : params.decimalNumber));
	        }
	        if (!isNil$1(params === null || params === void 0 ? void 0 : params.decimalNumber) && !isNil$1(params === null || params === void 0 ? void 0 : params.fn)) {
	            if ((params === null || params === void 0 ? void 0 : params.fn) === 'toFixed') {
	                return Number(newNumber.toFixed(params === null || params === void 0 ? void 0 : params.decimalNumber));
	            }
	            else if ((params === null || params === void 0 ? void 0 : params.fn) === 'floor') {
	                return formatDecimalNoRound(newNumber, params === null || params === void 0 ? void 0 : params.decimalNumber);
	            }
	        }
	    };
	};

	/**
	 * 元转分
	 * @param num
	 * @param decimalNumber
	 * @param fn
	 */
	const yuanTofen = (num, params) => {
	    return smallToBig(100)(num, params);
	};

	/**
	 * 大数字转小数字
	 * @param translateUnit
	 */
	const bigToSmall = (translateUnit) => {
	    return (num, params) => {
	        const decimalNumber = (params === null || params === void 0 ? void 0 : params.decimalNumber) || 2;
	        const fn = (params === null || params === void 0 ? void 0 : params.fn) || 'toFixed';
	        if (isEmpty$1(num) || isNil$1(num))
	            return num;
	        if (isNaN(Number(num))) {
	            return NaN;
	        }
	        const newNumber = new Big(Number(num)).div(translateUnit);
	        if (fn === 'toFixed') {
	            return Number(newNumber.toFixed(decimalNumber));
	        }
	        else if (fn === 'floor') {
	            return formatDecimalNoRound(Number(newNumber), decimalNumber);
	        }
	        return num;
	    };
	};

	/**
	 * 分转元
	 * @param num
	 * @param decimalNumber 默认保留两位小数
	 * @param fn
	 */
	const fenToyuan = (num, params) => {
	    return bigToSmall(100)(num, params);
	};

	/**
	 * 万转元
	 * @param num
	 * @param decimalNumber
	 * @param fn
	 */
	const wanToyuan = (num, params) => {
	    return smallToBig(10000)(num, params);
	};

	/**
	 * 元转万
	 * @param num
	 * @param decimalNumber
	 * @param fn
	 */
	const yuanTowan = (num, params) => {
	    return bigToSmall(10000)(num, params);
	};

	/**
	 * kg转g
	 * @param num
	 * @param decimalNumber
	 * @param fn
	 */
	const kgTog = (num, params) => {
	    return smallToBig(1000)(num, params);
	};

	/**
	 * g转kg
	 * @param num
	 * @param decimalNumber
	 * @param fn
	 */
	const gTokg = (num, pararms) => {
	    return bigToSmall(1000)(num, pararms);
	};

	/**
	 * 从头开始，最大截取多少个字符串
	 * @param str
	 * @param len 最大截取多少个字符串
	 * @param isSpot 是否带 ...
	 */
	const maxSubstrWord = (str, len = 5, isSpot = true) => {
	    if (typeof str === 'string') {
	        return isSpot ? `${str.substr(0, len)}...` : str.substr(0, len);
	    }
	    else {
	        return str;
	    }
	};

	/**
	 * 判断类型
	 * @param params
	 */
	const getClass = (params) => {
	    const str = Object.prototype.toString.call(params);
	    const matchResult = /^\[object (.*)\]$/.exec(str);
	    if (matchResult !== null) {
	        return matchResult[1].toLowerCase();
	    }
	    return null;
	};

	const trimParams = (object) => {
	    if (typeof object === 'string') {
	        return trim$1(object);
	    }
	    if (getClass(object) === 'array' || getClass(object) === 'object') {
	        if (Array.isArray(object)) {
	            object.forEach((newParams) => {
	                trimParams(newParams);
	            });
	        }
	        if (typeof object !== null) {
	            Object.keys(object).map((key) => {
	                const newValue = object[key];
	                if (typeof newValue === 'string') {
	                    object[key] = trim$1(newValue);
	                }
	                if (getClass(newValue) === 'object' || getClass(newValue) === 'array') {
	                    trimParams(newValue);
	                }
	            });
	            return object;
	        }
	    }
	    return object;
	};

	/**
	 * 获取字节长度
	 * @param str // 需要获取字节长度的字符串
	 * 中文+2 英文+1
	 */
	const getBiteLen = (str) => {
	    if (typeof str !== 'string')
	        return 0;
	    let len = 0;
	    for (let i = 0; i < str.length; i++) {
	        if (str.charCodeAt(i) > 127 || str.charCodeAt(i) === 94) {
	            len += 2;
	        }
	        else {
	            len += 1;
	        }
	    }
	    return len;
	};

	/**
	 * 下划线转换驼峰
	 * @param str string
	 * @returns string
	 */
	function lineToHump(str) {
	    if (typeof str !== 'string')
	        return str;
	    return str.replace(/\_(\w)/g, function (_all, letter) {
	        return letter.toUpperCase();
	    });
	}

	/**
	 * 驼峰转换下划线
	 * @param str string
	 * @returns srting
	 */
	function humpToLine(str) {
	    if (typeof str !== 'string')
	        return str;
	    return str.replace(/([A-Z])/g, '_$1').toLowerCase();
	}

	const sum = (params, api) => {
	    let resultSum = new Big(0);
	    // 内部递归函数
	    const _sum = (params, api) => {
	        if (getClass(params) === 'array' && Array.isArray(params)) {
	            params.forEach((item) => {
	                if (!isNaN(item)) {
	                    resultSum = resultSum.plus(Number(item));
	                }
	                if (getClass(item) === 'object' && typeof api !== 'undefined' && item[api] !== null) {
	                    resultSum = resultSum.plus(Number(item[api]));
	                }
	                if (getClass(item) === 'array' && Array.isArray(item)) {
	                    _sum(item, api);
	                }
	            });
	        }
	    };
	    _sum(params, api);
	    return Number(resultSum);
	};

	/**
	 *start 到 end 之间的随机数
	 * @param end
	 * @param start
	 * @returns number
	 */
	const round = (end, start = 0) => Math.round(Math.random() * (end - start) + start);

	// Unique ID creation requires a high quality random # generator. In the browser we therefore
	// require the crypto API and do not support built-in fallback to lower quality random number
	// generators (like Math.random()).
	var getRandomValues;
	var rnds8 = new Uint8Array(16);
	function rng() {
	  // lazy load so that environments that need to polyfill have a chance to do so
	  if (!getRandomValues) {
	    // getRandomValues needs to be invoked in a context where "this" is a Crypto implementation. Also,
	    // find the complete implementation of crypto (msCrypto) on IE11.
	    getRandomValues = typeof crypto !== 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto) || typeof msCrypto !== 'undefined' && typeof msCrypto.getRandomValues === 'function' && msCrypto.getRandomValues.bind(msCrypto);

	    if (!getRandomValues) {
	      throw new Error('crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported');
	    }
	  }

	  return getRandomValues(rnds8);
	}

	var REGEX = /^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;

	function validate(uuid) {
	  return typeof uuid === 'string' && REGEX.test(uuid);
	}

	/**
	 * Convert array of 16 byte values to UUID string format of the form:
	 * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
	 */

	var byteToHex = [];

	for (var i = 0; i < 256; ++i) {
	  byteToHex.push((i + 0x100).toString(16).substr(1));
	}

	function stringify(arr) {
	  var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
	  // Note: Be careful editing this code!  It's been tuned for performance
	  // and works in ways you may not expect. See https://github.com/uuidjs/uuid/pull/434
	  var uuid = (byteToHex[arr[offset + 0]] + byteToHex[arr[offset + 1]] + byteToHex[arr[offset + 2]] + byteToHex[arr[offset + 3]] + '-' + byteToHex[arr[offset + 4]] + byteToHex[arr[offset + 5]] + '-' + byteToHex[arr[offset + 6]] + byteToHex[arr[offset + 7]] + '-' + byteToHex[arr[offset + 8]] + byteToHex[arr[offset + 9]] + '-' + byteToHex[arr[offset + 10]] + byteToHex[arr[offset + 11]] + byteToHex[arr[offset + 12]] + byteToHex[arr[offset + 13]] + byteToHex[arr[offset + 14]] + byteToHex[arr[offset + 15]]).toLowerCase(); // Consistency check for valid UUID.  If this throws, it's likely due to one
	  // of the following:
	  // - One or more input array values don't map to a hex octet (leading to
	  // "undefined" in the uuid)
	  // - Invalid input values for the RFC `version` or `variant` fields

	  if (!validate(uuid)) {
	    throw TypeError('Stringified UUID is invalid');
	  }

	  return uuid;
	}

	function v4(options, buf, offset) {
	  options = options || {};
	  var rnds = options.random || (options.rng || rng)(); // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`

	  rnds[6] = rnds[6] & 0x0f | 0x40;
	  rnds[8] = rnds[8] & 0x3f | 0x80; // Copy bytes to buffer, if provided

	  return stringify(rnds);
	}

	const uuidv4 = () => {
	    return v4();
	};

	/**
	 * 2021-07-20 zimu
	 * https://github.com/emn178/js-md5/blob/master/src/md5.js
	 */
	const ERROR = 'input is invalid type';
	const HEX_CHARS = '0123456789abcdef'.split('');
	const EXTRA = [128, 32768, 8388608, -2147483648];
	let blocks = [], buffer8;
	const buffer = new ArrayBuffer(68);
	buffer8 = new Uint8Array(buffer);
	blocks = new Uint32Array(buffer);
	//@ts-ignore
	const createMethod = () => (message) => new Md5().update(message)['hex']();
	function Md5() {
	    blocks[0] = blocks[16] = blocks[1] = blocks[2] = blocks[3] =
	        blocks[4] = blocks[5] = blocks[6] = blocks[7] =
	            blocks[8] = blocks[9] = blocks[10] = blocks[11] =
	                blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
	    this.blocks = blocks;
	    this.buffer8 = buffer8;
	    this.h0 = this.h1 = this.h2 = this.h3 = this.start = this.bytes = this.hBytes = 0;
	    this.finalized = this.hashed = false;
	    this.first = true;
	}
	Md5.prototype.update = function (message) {
	    if (this.finalized) {
	        return;
	    }
	    let notString;
	    const type = typeof message;
	    if (type !== 'string') {
	        if (type === 'object') {
	            if (message === null) {
	                throw ERROR;
	            }
	            else if (message.constructor === ArrayBuffer) {
	                message = new Uint8Array(message);
	            }
	            else if (!Array.isArray(message)) {
	                if (!ArrayBuffer.isView(message)) {
	                    throw ERROR;
	                }
	            }
	        }
	        else {
	            throw ERROR;
	        }
	        notString = true;
	    }
	    let code, index = 0, i, length = message.length, blocks = this.blocks;
	    let buffer8 = this.buffer8;
	    while (index < length) {
	        if (this.hashed) {
	            this.hashed = false;
	            blocks[0] = blocks[16];
	            blocks[16] = blocks[1] = blocks[2] = blocks[3] =
	                blocks[4] = blocks[5] = blocks[6] = blocks[7] =
	                    blocks[8] = blocks[9] = blocks[10] = blocks[11] =
	                        blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
	        }
	        if (notString) {
	            for (i = this.start; index < length && i < 64; ++index) {
	                buffer8[i++] = message[index];
	            }
	        }
	        else {
	            for (i = this.start; index < length && i < 64; ++index) {
	                code = message.charCodeAt(index);
	                if (code < 0x80) {
	                    buffer8[i++] = code;
	                }
	                else if (code < 0x800) {
	                    buffer8[i++] = 0xc0 | (code >> 6);
	                    buffer8[i++] = 0x80 | (code & 0x3f);
	                }
	                else if (code < 0xd800 || code >= 0xe000) {
	                    buffer8[i++] = 0xe0 | (code >> 12);
	                    buffer8[i++] = 0x80 | ((code >> 6) & 0x3f);
	                    buffer8[i++] = 0x80 | (code & 0x3f);
	                }
	                else {
	                    code = 0x10000 + (((code & 0x3ff) << 10) | (message.charCodeAt(++index) & 0x3ff));
	                    buffer8[i++] = 0xf0 | (code >> 18);
	                    buffer8[i++] = 0x80 | ((code >> 12) & 0x3f);
	                    buffer8[i++] = 0x80 | ((code >> 6) & 0x3f);
	                    buffer8[i++] = 0x80 | (code & 0x3f);
	                }
	            }
	        }
	        this.lastByteIndex = i;
	        this.bytes += i - this.start;
	        if (i >= 64) {
	            this.start = i - 64;
	            this.hash();
	            this.hashed = true;
	        }
	        else {
	            this.start = i;
	        }
	    }
	    if (this.bytes > 4294967295) {
	        this.hBytes += this.bytes / 4294967296 << 0;
	        this.bytes = this.bytes % 4294967296;
	    }
	    return this;
	};
	Md5.prototype.finalize = function () {
	    if (this.finalized) {
	        return;
	    }
	    this.finalized = true;
	    const blocks = this.blocks, i = this.lastByteIndex;
	    blocks[i >> 2] |= EXTRA[i & 3];
	    if (i >= 56) {
	        if (!this.hashed) {
	            this.hash();
	        }
	        blocks[0] = blocks[16];
	        blocks[16] = blocks[1] = blocks[2] = blocks[3] =
	            blocks[4] = blocks[5] = blocks[6] = blocks[7] =
	                blocks[8] = blocks[9] = blocks[10] = blocks[11] =
	                    blocks[12] = blocks[13] = blocks[14] = blocks[15] = 0;
	    }
	    blocks[14] = this.bytes << 3;
	    blocks[15] = this.hBytes << 3 | this.bytes >>> 29;
	    this.hash();
	};
	Md5.prototype.hash = function () {
	    let a, b, c, d, bc, da, blocks = this.blocks;
	    if (this.first) {
	        a = blocks[0] - 680876937;
	        a = (a << 7 | a >>> 25) - 271733879 << 0;
	        d = (-1732584194 ^ a & 2004318071) + blocks[1] - 117830708;
	        d = (d << 12 | d >>> 20) + a << 0;
	        c = (-271733879 ^ (d & (a ^ -271733879))) + blocks[2] - 1126478375;
	        c = (c << 17 | c >>> 15) + d << 0;
	        b = (a ^ (c & (d ^ a))) + blocks[3] - 1316259209;
	        b = (b << 22 | b >>> 10) + c << 0;
	    }
	    else {
	        a = this.h0;
	        b = this.h1;
	        c = this.h2;
	        d = this.h3;
	        a += (d ^ (b & (c ^ d))) + blocks[0] - 680876936;
	        a = (a << 7 | a >>> 25) + b << 0;
	        d += (c ^ (a & (b ^ c))) + blocks[1] - 389564586;
	        d = (d << 12 | d >>> 20) + a << 0;
	        c += (b ^ (d & (a ^ b))) + blocks[2] + 606105819;
	        c = (c << 17 | c >>> 15) + d << 0;
	        b += (a ^ (c & (d ^ a))) + blocks[3] - 1044525330;
	        b = (b << 22 | b >>> 10) + c << 0;
	    }
	    a += (d ^ (b & (c ^ d))) + blocks[4] - 176418897;
	    a = (a << 7 | a >>> 25) + b << 0;
	    d += (c ^ (a & (b ^ c))) + blocks[5] + 1200080426;
	    d = (d << 12 | d >>> 20) + a << 0;
	    c += (b ^ (d & (a ^ b))) + blocks[6] - 1473231341;
	    c = (c << 17 | c >>> 15) + d << 0;
	    b += (a ^ (c & (d ^ a))) + blocks[7] - 45705983;
	    b = (b << 22 | b >>> 10) + c << 0;
	    a += (d ^ (b & (c ^ d))) + blocks[8] + 1770035416;
	    a = (a << 7 | a >>> 25) + b << 0;
	    d += (c ^ (a & (b ^ c))) + blocks[9] - 1958414417;
	    d = (d << 12 | d >>> 20) + a << 0;
	    c += (b ^ (d & (a ^ b))) + blocks[10] - 42063;
	    c = (c << 17 | c >>> 15) + d << 0;
	    b += (a ^ (c & (d ^ a))) + blocks[11] - 1990404162;
	    b = (b << 22 | b >>> 10) + c << 0;
	    a += (d ^ (b & (c ^ d))) + blocks[12] + 1804603682;
	    a = (a << 7 | a >>> 25) + b << 0;
	    d += (c ^ (a & (b ^ c))) + blocks[13] - 40341101;
	    d = (d << 12 | d >>> 20) + a << 0;
	    c += (b ^ (d & (a ^ b))) + blocks[14] - 1502002290;
	    c = (c << 17 | c >>> 15) + d << 0;
	    b += (a ^ (c & (d ^ a))) + blocks[15] + 1236535329;
	    b = (b << 22 | b >>> 10) + c << 0;
	    a += (c ^ (d & (b ^ c))) + blocks[1] - 165796510;
	    a = (a << 5 | a >>> 27) + b << 0;
	    d += (b ^ (c & (a ^ b))) + blocks[6] - 1069501632;
	    d = (d << 9 | d >>> 23) + a << 0;
	    c += (a ^ (b & (d ^ a))) + blocks[11] + 643717713;
	    c = (c << 14 | c >>> 18) + d << 0;
	    b += (d ^ (a & (c ^ d))) + blocks[0] - 373897302;
	    b = (b << 20 | b >>> 12) + c << 0;
	    a += (c ^ (d & (b ^ c))) + blocks[5] - 701558691;
	    a = (a << 5 | a >>> 27) + b << 0;
	    d += (b ^ (c & (a ^ b))) + blocks[10] + 38016083;
	    d = (d << 9 | d >>> 23) + a << 0;
	    c += (a ^ (b & (d ^ a))) + blocks[15] - 660478335;
	    c = (c << 14 | c >>> 18) + d << 0;
	    b += (d ^ (a & (c ^ d))) + blocks[4] - 405537848;
	    b = (b << 20 | b >>> 12) + c << 0;
	    a += (c ^ (d & (b ^ c))) + blocks[9] + 568446438;
	    a = (a << 5 | a >>> 27) + b << 0;
	    d += (b ^ (c & (a ^ b))) + blocks[14] - 1019803690;
	    d = (d << 9 | d >>> 23) + a << 0;
	    c += (a ^ (b & (d ^ a))) + blocks[3] - 187363961;
	    c = (c << 14 | c >>> 18) + d << 0;
	    b += (d ^ (a & (c ^ d))) + blocks[8] + 1163531501;
	    b = (b << 20 | b >>> 12) + c << 0;
	    a += (c ^ (d & (b ^ c))) + blocks[13] - 1444681467;
	    a = (a << 5 | a >>> 27) + b << 0;
	    d += (b ^ (c & (a ^ b))) + blocks[2] - 51403784;
	    d = (d << 9 | d >>> 23) + a << 0;
	    c += (a ^ (b & (d ^ a))) + blocks[7] + 1735328473;
	    c = (c << 14 | c >>> 18) + d << 0;
	    b += (d ^ (a & (c ^ d))) + blocks[12] - 1926607734;
	    b = (b << 20 | b >>> 12) + c << 0;
	    bc = b ^ c;
	    a += (bc ^ d) + blocks[5] - 378558;
	    a = (a << 4 | a >>> 28) + b << 0;
	    d += (bc ^ a) + blocks[8] - 2022574463;
	    d = (d << 11 | d >>> 21) + a << 0;
	    da = d ^ a;
	    c += (da ^ b) + blocks[11] + 1839030562;
	    c = (c << 16 | c >>> 16) + d << 0;
	    b += (da ^ c) + blocks[14] - 35309556;
	    b = (b << 23 | b >>> 9) + c << 0;
	    bc = b ^ c;
	    a += (bc ^ d) + blocks[1] - 1530992060;
	    a = (a << 4 | a >>> 28) + b << 0;
	    d += (bc ^ a) + blocks[4] + 1272893353;
	    d = (d << 11 | d >>> 21) + a << 0;
	    da = d ^ a;
	    c += (da ^ b) + blocks[7] - 155497632;
	    c = (c << 16 | c >>> 16) + d << 0;
	    b += (da ^ c) + blocks[10] - 1094730640;
	    b = (b << 23 | b >>> 9) + c << 0;
	    bc = b ^ c;
	    a += (bc ^ d) + blocks[13] + 681279174;
	    a = (a << 4 | a >>> 28) + b << 0;
	    d += (bc ^ a) + blocks[0] - 358537222;
	    d = (d << 11 | d >>> 21) + a << 0;
	    da = d ^ a;
	    c += (da ^ b) + blocks[3] - 722521979;
	    c = (c << 16 | c >>> 16) + d << 0;
	    b += (da ^ c) + blocks[6] + 76029189;
	    b = (b << 23 | b >>> 9) + c << 0;
	    bc = b ^ c;
	    a += (bc ^ d) + blocks[9] - 640364487;
	    a = (a << 4 | a >>> 28) + b << 0;
	    d += (bc ^ a) + blocks[12] - 421815835;
	    d = (d << 11 | d >>> 21) + a << 0;
	    da = d ^ a;
	    c += (da ^ b) + blocks[15] + 530742520;
	    c = (c << 16 | c >>> 16) + d << 0;
	    b += (da ^ c) + blocks[2] - 995338651;
	    b = (b << 23 | b >>> 9) + c << 0;
	    a += (c ^ (b | ~d)) + blocks[0] - 198630844;
	    a = (a << 6 | a >>> 26) + b << 0;
	    d += (b ^ (a | ~c)) + blocks[7] + 1126891415;
	    d = (d << 10 | d >>> 22) + a << 0;
	    c += (a ^ (d | ~b)) + blocks[14] - 1416354905;
	    c = (c << 15 | c >>> 17) + d << 0;
	    b += (d ^ (c | ~a)) + blocks[5] - 57434055;
	    b = (b << 21 | b >>> 11) + c << 0;
	    a += (c ^ (b | ~d)) + blocks[12] + 1700485571;
	    a = (a << 6 | a >>> 26) + b << 0;
	    d += (b ^ (a | ~c)) + blocks[3] - 1894986606;
	    d = (d << 10 | d >>> 22) + a << 0;
	    c += (a ^ (d | ~b)) + blocks[10] - 1051523;
	    c = (c << 15 | c >>> 17) + d << 0;
	    b += (d ^ (c | ~a)) + blocks[1] - 2054922799;
	    b = (b << 21 | b >>> 11) + c << 0;
	    a += (c ^ (b | ~d)) + blocks[8] + 1873313359;
	    a = (a << 6 | a >>> 26) + b << 0;
	    d += (b ^ (a | ~c)) + blocks[15] - 30611744;
	    d = (d << 10 | d >>> 22) + a << 0;
	    c += (a ^ (d | ~b)) + blocks[6] - 1560198380;
	    c = (c << 15 | c >>> 17) + d << 0;
	    b += (d ^ (c | ~a)) + blocks[13] + 1309151649;
	    b = (b << 21 | b >>> 11) + c << 0;
	    a += (c ^ (b | ~d)) + blocks[4] - 145523070;
	    a = (a << 6 | a >>> 26) + b << 0;
	    d += (b ^ (a | ~c)) + blocks[11] - 1120210379;
	    d = (d << 10 | d >>> 22) + a << 0;
	    c += (a ^ (d | ~b)) + blocks[2] + 718787259;
	    c = (c << 15 | c >>> 17) + d << 0;
	    b += (d ^ (c | ~a)) + blocks[9] - 343485551;
	    b = (b << 21 | b >>> 11) + c << 0;
	    if (this.first) {
	        this.h0 = a + 1732584193 << 0;
	        this.h1 = b - 271733879 << 0;
	        this.h2 = c - 1732584194 << 0;
	        this.h3 = d + 271733878 << 0;
	        this.first = false;
	    }
	    else {
	        this.h0 = this.h0 + a << 0;
	        this.h1 = this.h1 + b << 0;
	        this.h2 = this.h2 + c << 0;
	        this.h3 = this.h3 + d << 0;
	    }
	};
	Md5.prototype.hex = function () {
	    this.finalize();
	    let h0 = this.h0, h1 = this.h1, h2 = this.h2, h3 = this.h3;
	    return HEX_CHARS[(h0 >> 4) & 0x0F] + HEX_CHARS[h0 & 0x0F] +
	        HEX_CHARS[(h0 >> 12) & 0x0F] + HEX_CHARS[(h0 >> 8) & 0x0F] +
	        HEX_CHARS[(h0 >> 20) & 0x0F] + HEX_CHARS[(h0 >> 16) & 0x0F] +
	        HEX_CHARS[(h0 >> 28) & 0x0F] + HEX_CHARS[(h0 >> 24) & 0x0F] +
	        HEX_CHARS[(h1 >> 4) & 0x0F] + HEX_CHARS[h1 & 0x0F] +
	        HEX_CHARS[(h1 >> 12) & 0x0F] + HEX_CHARS[(h1 >> 8) & 0x0F] +
	        HEX_CHARS[(h1 >> 20) & 0x0F] + HEX_CHARS[(h1 >> 16) & 0x0F] +
	        HEX_CHARS[(h1 >> 28) & 0x0F] + HEX_CHARS[(h1 >> 24) & 0x0F] +
	        HEX_CHARS[(h2 >> 4) & 0x0F] + HEX_CHARS[h2 & 0x0F] +
	        HEX_CHARS[(h2 >> 12) & 0x0F] + HEX_CHARS[(h2 >> 8) & 0x0F] +
	        HEX_CHARS[(h2 >> 20) & 0x0F] + HEX_CHARS[(h2 >> 16) & 0x0F] +
	        HEX_CHARS[(h2 >> 28) & 0x0F] + HEX_CHARS[(h2 >> 24) & 0x0F] +
	        HEX_CHARS[(h3 >> 4) & 0x0F] + HEX_CHARS[h3 & 0x0F] +
	        HEX_CHARS[(h3 >> 12) & 0x0F] + HEX_CHARS[(h3 >> 8) & 0x0F] +
	        HEX_CHARS[(h3 >> 20) & 0x0F] + HEX_CHARS[(h3 >> 16) & 0x0F] +
	        HEX_CHARS[(h3 >> 28) & 0x0F] + HEX_CHARS[(h3 >> 24) & 0x0F];
	};
	var md5 = createMethod();

	const getMD5 = (md5Key) => {
	    if (isEmpty$1(md5Key) || isNil$1(md5Key))
	        return md5Key;
	    if (is$1(String, md5Key))
	        return md5(md5Key);
	    return md5Key;
	};

	/**
	 * 扩大倍数，数字变大
	 * @param multiple
	 * @param num
	 * @param decimalNumber
	 * @param fn
	 */
	const expandMultiple = (multiple, num, params) => {
	    return smallToBig(multiple)(num, params);
	};

	/**
	 * 缩小倍数，数字变小
	 * @param multiple
	 * @param num
	 * @param decimalNumber
	 * @param fn
	 */
	const reduceMultiple = (multiple, num, params) => {
	    return bigToSmall(multiple)(num, params);
	};

	/**
	 * 数值转化为 千分位 展示
	 * @param num
	 * @param separator 分隔符，默认 ','
	 */
	const numberToThousand = (num, separator = ',') => {
	    if (isEmpty$1(num) || isNil$1(num))
	        return num;
	    if (isNaN(Number(num))) {
	        return NaN;
	    }
	    return num.toString().replace(/\d+/, (n) => n.replace(/(\d)(?=(\d{3})+$)/g, ($1) => `${$1}${separator}`));
	};

	// @ts-nocheck
	/**
	 * @param {{ leading: any; trailing: any; }} value
	 */
	function isObject (value) {
	  const type = typeof value;
	  return value != null && (type === 'object' || type === 'function')
	}


	/**
	 * @param {{ apply: (arg0: any, arg1: any) => any; }} func
	 * @param {number} wait
	 * @param {{ leading: any; trailing: any; maxWait: any; }} options
	 */
	function debounce (func, wait, options) {
	  if (typeof window === 'undefined') {
	    return;
	  }
	  let lastArgs,
	    lastThis,
	    maxWait,
	    result,
	    timerId,
	    lastCallTime;

	  let lastInvokeTime = 0;
	  let leading = false;
	  let maxing = false;
	  let trailing = true;

	  // Bypass `requestAnimationFrame` by explicitly setting `wait=0`.
	  const useRAF = (!wait && wait !== 0 && typeof requestAnimationFrame === 'function');

	  if (typeof func !== 'function') {
	    throw new TypeError('Expected a function')
	  }
	  wait = +wait || 0;
	  if (isObject(options)) {
	    leading = !!options.leading;
	    maxing = 'maxWait' in options;
	    maxWait = maxing ? Math.max(+options.maxWait || 0, wait) : maxWait;
	    trailing = 'trailing' in options ? !!options.trailing : trailing;
	  }

	  /**
	   * @param {number} time
	   */
	  function invokeFunc (time) {
	    const args = lastArgs;
	    const thisArg = lastThis;

	    lastArgs = lastThis = undefined;
	    lastInvokeTime = time;
	    result = func.apply(thisArg, args);
	    return result
	  }

	  /**
	   * @param {FrameRequestCallback} pendingFunc
	   * @param {number} wait
	   */
	  function startTimer (pendingFunc, wait) {
	    if (useRAF) {
	      cancelAnimationFrame(timerId);
	      return requestAnimationFrame(pendingFunc)
	    }
	    return setTimeout(pendingFunc, wait)
	  }

	  /**
	   * @param {number} id
	   */
	  function cancelTimer (id) {
	    if (useRAF) {
	      return cancelAnimationFrame(id)
	    }
	    clearTimeout(id);
	  }

	  /**
	   * @param {number} time
	   */
	  function leadingEdge (time) {
	    // Reset any `maxWait` timer.
	    lastInvokeTime = time;
	    // Start the timer for the trailing edge.
	    timerId = startTimer(timerExpired, wait);
	    // Invoke the leading edge.
	    return leading ? invokeFunc(time) : result
	  }

	  /**
	   * @param {number} time
	   */
	  function remainingWait (time) {
	    const timeSinceLastCall = time - lastCallTime;
	    const timeSinceLastInvoke = time - lastInvokeTime;
	    const timeWaiting = wait - timeSinceLastCall;

	    return maxing
	      ? Math.min(timeWaiting, maxWait - timeSinceLastInvoke)
	      : timeWaiting
	  }

	  /**
	   * @param {number} time
	   */
	  function shouldInvoke (time) {
	    const timeSinceLastCall = time - lastCallTime;
	    const timeSinceLastInvoke = time - lastInvokeTime;

	    // Either this is the first call, activity has stopped and we're at the
	    // trailing edge, the system time has gone backwards and we're treating
	    // it as the trailing edge, or we've hit the `maxWait` limit.
	    return (lastCallTime === undefined || (timeSinceLastCall >= wait) ||
	      (timeSinceLastCall < 0) || (maxing && timeSinceLastInvoke >= maxWait))
	  }

	  function timerExpired () {
	    const time = Date.now();
	    if (shouldInvoke(time)) {
	      return trailingEdge(time)
	    }
	    // Restart the timer.
	    timerId = startTimer(timerExpired, remainingWait(time));
	  }

	  /**
	   * @param {number} time
	   */
	  function trailingEdge (time) {
	    timerId = undefined;

	    // Only invoke if we have `lastArgs` which means `func` has been
	    // debounced at least once.
	    if (trailing && lastArgs) {
	      return invokeFunc(time)
	    }
	    lastArgs = lastThis = undefined;
	    return result
	  }

	  function cancel () {
	    if (timerId !== undefined) {
	      cancelTimer(timerId);
	    }
	    lastInvokeTime = 0;
	    lastArgs = lastCallTime = lastThis = timerId = undefined;
	  }

	  function flush () {
	    return timerId === undefined ? result : trailingEdge(Date.now())
	  }

	  function pending () {
	    return timerId !== undefined
	  }

	  /**
	   * @param {any[]} args
	   */
	  function debounced (...args) {
	    const time = Date.now();
	    const isInvoking = shouldInvoke(time);

	    lastArgs = args;
	    lastThis = this;
	    lastCallTime = time;

	    if (isInvoking) {
	      if (timerId === undefined) {
	        return leadingEdge(lastCallTime)
	      }
	      if (maxing) {
	        // Handle invocations in a tight loop.
	        timerId = startTimer(timerExpired, wait);
	        return invokeFunc(lastCallTime)
	      }
	    }
	    if (timerId === undefined) {
	      timerId = startTimer(timerExpired, wait);
	    }
	    return result
	  }
	  debounced.cancel = cancel;
	  debounced.flush = flush;
	  debounced.pending = pending;
	  return debounced
	}

	/**
	 * @param {any} func
	 * @param {any} wait
	 * @param {{ leading: any; trailing: any; }} options
	 */
	function throttle (func, wait, options) {
	  let leading = true;
	  let trailing = true;

	  if (typeof func !== 'function') {
	    throw new TypeError('Expected a function')
	  }
	  if (isObject(options)) {
	    leading = 'leading' in options ? !!options.leading : leading;
	    trailing = 'trailing' in options ? !!options.trailing : trailing;
	  }
	  return debounce(func, wait, {
	    leading,
	    trailing,
	    'maxWait': wait
	  })
	}

	/**
	 * 获取图片地址
	 * @param img 原始图片地址
	 * @param width 图片宽度
	 * @param width 图片高度
	 * @param defaultImg 默认图片地址
	 * @returns number
	 */
	const defGoodsImg = 'https://cdn.ywwl.com/bps/ywyun/dianhu/assets/def_goods_img.png';
	const getImgUrl = (img, width = 200, height, defaultImg) => {
	    const reg = new RegExp(/resize:(\d+):(\d+)/, 'g');
	    let retImg = '';
	    if (img) {
	        retImg = img;
	        if (reg.test(retImg)) { // 抖音
	            retImg = retImg.replace(reg, `resize:${width}:${height || 0}`);
	        }
	        else { // 阿里云OSS
	            retImg = retImg.indexOf('x-oss-process=image') > -1 || retImg.indexOf('?') > -1 ? retImg
	                : `${retImg}?x-oss-process=image/resize,w_${width},limit_0/quality,q_60`;
	        }
	    }
	    else {
	        retImg = defaultImg || defGoodsImg;
	    }
	    return retImg;
	};

	var lib$2 = {};

	var ieee754 = {};

	/*! ieee754. BSD-3-Clause License. Feross Aboukhadijeh <https://feross.org/opensource> */

	ieee754.read = function (buffer, offset, isLE, mLen, nBytes) {
	  var e, m;
	  var eLen = (nBytes * 8) - mLen - 1;
	  var eMax = (1 << eLen) - 1;
	  var eBias = eMax >> 1;
	  var nBits = -7;
	  var i = isLE ? (nBytes - 1) : 0;
	  var d = isLE ? -1 : 1;
	  var s = buffer[offset + i];

	  i += d;

	  e = s & ((1 << (-nBits)) - 1);
	  s >>= (-nBits);
	  nBits += eLen;
	  for (; nBits > 0; e = (e * 256) + buffer[offset + i], i += d, nBits -= 8) {}

	  m = e & ((1 << (-nBits)) - 1);
	  e >>= (-nBits);
	  nBits += mLen;
	  for (; nBits > 0; m = (m * 256) + buffer[offset + i], i += d, nBits -= 8) {}

	  if (e === 0) {
	    e = 1 - eBias;
	  } else if (e === eMax) {
	    return m ? NaN : ((s ? -1 : 1) * Infinity)
	  } else {
	    m = m + Math.pow(2, mLen);
	    e = e - eBias;
	  }
	  return (s ? -1 : 1) * m * Math.pow(2, e - mLen)
	};

	ieee754.write = function (buffer, value, offset, isLE, mLen, nBytes) {
	  var e, m, c;
	  var eLen = (nBytes * 8) - mLen - 1;
	  var eMax = (1 << eLen) - 1;
	  var eBias = eMax >> 1;
	  var rt = (mLen === 23 ? Math.pow(2, -24) - Math.pow(2, -77) : 0);
	  var i = isLE ? 0 : (nBytes - 1);
	  var d = isLE ? 1 : -1;
	  var s = value < 0 || (value === 0 && 1 / value < 0) ? 1 : 0;

	  value = Math.abs(value);

	  if (isNaN(value) || value === Infinity) {
	    m = isNaN(value) ? 1 : 0;
	    e = eMax;
	  } else {
	    e = Math.floor(Math.log(value) / Math.LN2);
	    if (value * (c = Math.pow(2, -e)) < 1) {
	      e--;
	      c *= 2;
	    }
	    if (e + eBias >= 1) {
	      value += rt / c;
	    } else {
	      value += rt * Math.pow(2, 1 - eBias);
	    }
	    if (value * c >= 2) {
	      e++;
	      c /= 2;
	    }

	    if (e + eBias >= eMax) {
	      m = 0;
	      e = eMax;
	    } else if (e + eBias >= 1) {
	      m = ((value * c) - 1) * Math.pow(2, mLen);
	      e = e + eBias;
	    } else {
	      m = value * Math.pow(2, eBias - 1) * Math.pow(2, mLen);
	      e = 0;
	    }
	  }

	  for (; mLen >= 8; buffer[offset + i] = m & 0xff, i += d, m /= 256, mLen -= 8) {}

	  e = (e << mLen) | m;
	  eLen += mLen;
	  for (; eLen > 0; buffer[offset + i] = e & 0xff, i += d, e /= 256, eLen -= 8) {}

	  buffer[offset + i - d] |= s * 128;
	};

	(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.AnsiStringType = exports.StringType = exports.BufferType = exports.Uint8ArrayType = exports.IgnoreType = exports.Float80_LE = exports.Float80_BE = exports.Float64_LE = exports.Float64_BE = exports.Float32_LE = exports.Float32_BE = exports.Float16_LE = exports.Float16_BE = exports.INT64_BE = exports.UINT64_BE = exports.INT64_LE = exports.UINT64_LE = exports.INT32_LE = exports.INT32_BE = exports.INT24_BE = exports.INT24_LE = exports.INT16_LE = exports.INT16_BE = exports.INT8 = exports.UINT32_BE = exports.UINT32_LE = exports.UINT24_BE = exports.UINT24_LE = exports.UINT16_BE = exports.UINT16_LE = exports.UINT8 = void 0;
	const ieee754$1 = ieee754;
	// Primitive types
	function dv(array) {
	    return new DataView(array.buffer, array.byteOffset);
	}
	/**
	 * 8-bit unsigned integer
	 */
	exports.UINT8 = {
	    len: 1,
	    get(array, offset) {
	        return dv(array).getUint8(offset);
	    },
	    put(array, offset, value) {
	        dv(array).setUint8(offset, value);
	        return offset + 1;
	    }
	};
	/**
	 * 16-bit unsigned integer, Little Endian byte order
	 */
	exports.UINT16_LE = {
	    len: 2,
	    get(array, offset) {
	        return dv(array).getUint16(offset, true);
	    },
	    put(array, offset, value) {
	        dv(array).setUint16(offset, value, true);
	        return offset + 2;
	    }
	};
	/**
	 * 16-bit unsigned integer, Big Endian byte order
	 */
	exports.UINT16_BE = {
	    len: 2,
	    get(array, offset) {
	        return dv(array).getUint16(offset);
	    },
	    put(array, offset, value) {
	        dv(array).setUint16(offset, value);
	        return offset + 2;
	    }
	};
	/**
	 * 24-bit unsigned integer, Little Endian byte order
	 */
	exports.UINT24_LE = {
	    len: 3,
	    get(array, offset) {
	        const dataView = dv(array);
	        return dataView.getUint8(offset) + (dataView.getUint16(offset + 1, true) << 8);
	    },
	    put(array, offset, value) {
	        const dataView = dv(array);
	        dataView.setUint8(offset, value & 0xff);
	        dataView.setUint16(offset + 1, value >> 8, true);
	        return offset + 3;
	    }
	};
	/**
	 * 24-bit unsigned integer, Big Endian byte order
	 */
	exports.UINT24_BE = {
	    len: 3,
	    get(array, offset) {
	        const dataView = dv(array);
	        return (dataView.getUint16(offset) << 8) + dataView.getUint8(offset + 2);
	    },
	    put(array, offset, value) {
	        const dataView = dv(array);
	        dataView.setUint16(offset, value >> 8);
	        dataView.setUint8(offset + 2, value & 0xff);
	        return offset + 3;
	    }
	};
	/**
	 * 32-bit unsigned integer, Little Endian byte order
	 */
	exports.UINT32_LE = {
	    len: 4,
	    get(array, offset) {
	        return dv(array).getUint32(offset, true);
	    },
	    put(array, offset, value) {
	        dv(array).setUint32(offset, value, true);
	        return offset + 4;
	    }
	};
	/**
	 * 32-bit unsigned integer, Big Endian byte order
	 */
	exports.UINT32_BE = {
	    len: 4,
	    get(array, offset) {
	        return dv(array).getUint32(offset);
	    },
	    put(array, offset, value) {
	        dv(array).setUint32(offset, value);
	        return offset + 4;
	    }
	};
	/**
	 * 8-bit signed integer
	 */
	exports.INT8 = {
	    len: 1,
	    get(array, offset) {
	        return dv(array).getInt8(offset);
	    },
	    put(array, offset, value) {
	        dv(array).setInt8(offset, value);
	        return offset + 1;
	    }
	};
	/**
	 * 16-bit signed integer, Big Endian byte order
	 */
	exports.INT16_BE = {
	    len: 2,
	    get(array, offset) {
	        return dv(array).getInt16(offset);
	    },
	    put(array, offset, value) {
	        dv(array).setInt16(offset, value);
	        return offset + 2;
	    }
	};
	/**
	 * 16-bit signed integer, Little Endian byte order
	 */
	exports.INT16_LE = {
	    len: 2,
	    get(array, offset) {
	        return dv(array).getInt16(offset, true);
	    },
	    put(array, offset, value) {
	        dv(array).setInt16(offset, value, true);
	        return offset + 2;
	    }
	};
	/**
	 * 24-bit signed integer, Little Endian byte order
	 */
	exports.INT24_LE = {
	    len: 3,
	    get(array, offset) {
	        const unsigned = exports.UINT24_LE.get(array, offset);
	        return unsigned > 0x7fffff ? unsigned - 0x1000000 : unsigned;
	    },
	    put(array, offset, value) {
	        const dataView = dv(array);
	        dataView.setUint8(offset, value & 0xff);
	        dataView.setUint16(offset + 1, value >> 8, true);
	        return offset + 3;
	    }
	};
	/**
	 * 24-bit signed integer, Big Endian byte order
	 */
	exports.INT24_BE = {
	    len: 3,
	    get(array, offset) {
	        const unsigned = exports.UINT24_BE.get(array, offset);
	        return unsigned > 0x7fffff ? unsigned - 0x1000000 : unsigned;
	    },
	    put(array, offset, value) {
	        const dataView = dv(array);
	        dataView.setUint16(offset, value >> 8);
	        dataView.setUint8(offset + 2, value & 0xff);
	        return offset + 3;
	    }
	};
	/**
	 * 32-bit signed integer, Big Endian byte order
	 */
	exports.INT32_BE = {
	    len: 4,
	    get(array, offset) {
	        return dv(array).getInt32(offset);
	    },
	    put(array, offset, value) {
	        dv(array).setInt32(offset, value);
	        return offset + 4;
	    }
	};
	/**
	 * 32-bit signed integer, Big Endian byte order
	 */
	exports.INT32_LE = {
	    len: 4,
	    get(array, offset) {
	        return dv(array).getInt32(offset, true);
	    },
	    put(array, offset, value) {
	        dv(array).setInt32(offset, value, true);
	        return offset + 4;
	    }
	};
	/**
	 * 64-bit unsigned integer, Little Endian byte order
	 */
	exports.UINT64_LE = {
	    len: 8,
	    get(array, offset) {
	        return dv(array).getBigUint64(offset, true);
	    },
	    put(array, offset, value) {
	        dv(array).setBigUint64(offset, value, true);
	        return offset + 8;
	    }
	};
	/**
	 * 64-bit signed integer, Little Endian byte order
	 */
	exports.INT64_LE = {
	    len: 8,
	    get(array, offset) {
	        return dv(array).getBigInt64(offset, true);
	    },
	    put(array, offset, value) {
	        dv(array).setBigInt64(offset, value, true);
	        return offset + 8;
	    }
	};
	/**
	 * 64-bit unsigned integer, Big Endian byte order
	 */
	exports.UINT64_BE = {
	    len: 8,
	    get(array, offset) {
	        return dv(array).getBigUint64(offset);
	    },
	    put(array, offset, value) {
	        dv(array).setBigUint64(offset, value);
	        return offset + 8;
	    }
	};
	/**
	 * 64-bit signed integer, Big Endian byte order
	 */
	exports.INT64_BE = {
	    len: 8,
	    get(array, offset) {
	        return dv(array).getBigInt64(offset);
	    },
	    put(array, offset, value) {
	        dv(array).setBigInt64(offset, value);
	        return offset + 8;
	    }
	};
	/**
	 * IEEE 754 16-bit (half precision) float, big endian
	 */
	exports.Float16_BE = {
	    len: 2,
	    get(dataView, offset) {
	        return ieee754$1.read(dataView, offset, false, 10, this.len);
	    },
	    put(dataView, offset, value) {
	        ieee754$1.write(dataView, value, offset, false, 10, this.len);
	        return offset + this.len;
	    }
	};
	/**
	 * IEEE 754 16-bit (half precision) float, little endian
	 */
	exports.Float16_LE = {
	    len: 2,
	    get(array, offset) {
	        return ieee754$1.read(array, offset, true, 10, this.len);
	    },
	    put(array, offset, value) {
	        ieee754$1.write(array, value, offset, true, 10, this.len);
	        return offset + this.len;
	    }
	};
	/**
	 * IEEE 754 32-bit (single precision) float, big endian
	 */
	exports.Float32_BE = {
	    len: 4,
	    get(array, offset) {
	        return dv(array).getFloat32(offset);
	    },
	    put(array, offset, value) {
	        dv(array).setFloat32(offset, value);
	        return offset + 4;
	    }
	};
	/**
	 * IEEE 754 32-bit (single precision) float, little endian
	 */
	exports.Float32_LE = {
	    len: 4,
	    get(array, offset) {
	        return dv(array).getFloat32(offset, true);
	    },
	    put(array, offset, value) {
	        dv(array).setFloat32(offset, value, true);
	        return offset + 4;
	    }
	};
	/**
	 * IEEE 754 64-bit (double precision) float, big endian
	 */
	exports.Float64_BE = {
	    len: 8,
	    get(array, offset) {
	        return dv(array).getFloat64(offset);
	    },
	    put(array, offset, value) {
	        dv(array).setFloat64(offset, value);
	        return offset + 8;
	    }
	};
	/**
	 * IEEE 754 64-bit (double precision) float, little endian
	 */
	exports.Float64_LE = {
	    len: 8,
	    get(array, offset) {
	        return dv(array).getFloat64(offset, true);
	    },
	    put(array, offset, value) {
	        dv(array).setFloat64(offset, value, true);
	        return offset + 8;
	    }
	};
	/**
	 * IEEE 754 80-bit (extended precision) float, big endian
	 */
	exports.Float80_BE = {
	    len: 10,
	    get(array, offset) {
	        return ieee754$1.read(array, offset, false, 63, this.len);
	    },
	    put(array, offset, value) {
	        ieee754$1.write(array, value, offset, false, 63, this.len);
	        return offset + this.len;
	    }
	};
	/**
	 * IEEE 754 80-bit (extended precision) float, little endian
	 */
	exports.Float80_LE = {
	    len: 10,
	    get(array, offset) {
	        return ieee754$1.read(array, offset, true, 63, this.len);
	    },
	    put(array, offset, value) {
	        ieee754$1.write(array, value, offset, true, 63, this.len);
	        return offset + this.len;
	    }
	};
	/**
	 * Ignore a given number of bytes
	 */
	class IgnoreType {
	    /**
	     * @param len number of bytes to ignore
	     */
	    constructor(len) {
	        this.len = len;
	    }
	    // ToDo: don't read, but skip data
	    get(array, off) {
	    }
	}
	exports.IgnoreType = IgnoreType;
	class Uint8ArrayType {
	    constructor(len) {
	        this.len = len;
	    }
	    get(array, offset) {
	        return array.subarray(offset, offset + this.len);
	    }
	}
	exports.Uint8ArrayType = Uint8ArrayType;
	class BufferType {
	    constructor(len) {
	        this.len = len;
	    }
	    get(uint8Array, off) {
	        return Buffer.from(uint8Array.subarray(off, off + this.len));
	    }
	}
	exports.BufferType = BufferType;
	/**
	 * Consume a fixed number of bytes from the stream and return a string with a specified encoding.
	 */
	class StringType {
	    constructor(len, encoding) {
	        this.len = len;
	        this.encoding = encoding;
	    }
	    get(uint8Array, offset) {
	        return Buffer.from(uint8Array).toString(this.encoding, offset, offset + this.len);
	    }
	}
	exports.StringType = StringType;
	/**
	 * ANSI Latin 1 String
	 * Using windows-1252 / ISO 8859-1 decoding
	 */
	class AnsiStringType {
	    constructor(len) {
	        this.len = len;
	    }
	    static decode(buffer, offset, until) {
	        let str = '';
	        for (let i = offset; i < until; ++i) {
	            str += AnsiStringType.codePointToString(AnsiStringType.singleByteDecoder(buffer[i]));
	        }
	        return str;
	    }
	    static inRange(a, min, max) {
	        return min <= a && a <= max;
	    }
	    static codePointToString(cp) {
	        if (cp <= 0xFFFF) {
	            return String.fromCharCode(cp);
	        }
	        else {
	            cp -= 0x10000;
	            return String.fromCharCode((cp >> 10) + 0xD800, (cp & 0x3FF) + 0xDC00);
	        }
	    }
	    static singleByteDecoder(bite) {
	        if (AnsiStringType.inRange(bite, 0x00, 0x7F)) {
	            return bite;
	        }
	        const codePoint = AnsiStringType.windows1252[bite - 0x80];
	        if (codePoint === null) {
	            throw Error('invaliding encoding');
	        }
	        return codePoint;
	    }
	    get(buffer, offset = 0) {
	        return AnsiStringType.decode(buffer, offset, offset + this.len);
	    }
	}
	exports.AnsiStringType = AnsiStringType;
	AnsiStringType.windows1252 = [8364, 129, 8218, 402, 8222, 8230, 8224, 8225, 710, 8240, 352,
	    8249, 338, 141, 381, 143, 144, 8216, 8217, 8220, 8221, 8226, 8211, 8212, 732,
	    8482, 353, 8250, 339, 157, 382, 376, 160, 161, 162, 163, 164, 165, 166, 167, 168,
	    169, 170, 171, 172, 173, 174, 175, 176, 177, 178, 179, 180, 181, 182, 183, 184,
	    185, 186, 187, 188, 189, 190, 191, 192, 193, 194, 195, 196, 197, 198, 199, 200,
	    201, 202, 203, 204, 205, 206, 207, 208, 209, 210, 211, 212, 213, 214, 215, 216,
	    217, 218, 219, 220, 221, 222, 223, 224, 225, 226, 227, 228, 229, 230, 231, 232,
	    233, 234, 235, 236, 237, 238, 239, 240, 241, 242, 243, 244, 245, 246, 247,
	    248, 249, 250, 251, 252, 253, 254, 255];
	}(lib$2));

	var lib$1 = {};

	var FsPromise = {};

	/**
	 * Module convert fs functions to promise based functions
	 */
	Object.defineProperty(FsPromise, "__esModule", { value: true });
	FsPromise.readFile = FsPromise.writeFileSync = FsPromise.writeFile = FsPromise.read = FsPromise.open = FsPromise.close = FsPromise.stat = FsPromise.createReadStream = FsPromise.pathExists = void 0;
	const fs$1 = require$$0__default["default"];
	FsPromise.pathExists = fs$1.existsSync;
	FsPromise.createReadStream = fs$1.createReadStream;
	async function stat(path) {
	    return new Promise((resolve, reject) => {
	        fs$1.stat(path, (err, stats) => {
	            if (err)
	                reject(err);
	            else
	                resolve(stats);
	        });
	    });
	}
	FsPromise.stat = stat;
	async function close(fd) {
	    return new Promise((resolve, reject) => {
	        fs$1.close(fd, err => {
	            if (err)
	                reject(err);
	            else
	                resolve();
	        });
	    });
	}
	FsPromise.close = close;
	async function open(path, mode) {
	    return new Promise((resolve, reject) => {
	        fs$1.open(path, mode, (err, fd) => {
	            if (err)
	                reject(err);
	            else
	                resolve(fd);
	        });
	    });
	}
	FsPromise.open = open;
	async function read(fd, buffer, offset, length, position) {
	    return new Promise((resolve, reject) => {
	        fs$1.read(fd, buffer, offset, length, position, (err, bytesRead, _buffer) => {
	            if (err)
	                reject(err);
	            else
	                resolve({ bytesRead, buffer: _buffer });
	        });
	    });
	}
	FsPromise.read = read;
	async function writeFile(path, data) {
	    return new Promise((resolve, reject) => {
	        fs$1.writeFile(path, data, err => {
	            if (err)
	                reject(err);
	            else
	                resolve();
	        });
	    });
	}
	FsPromise.writeFile = writeFile;
	function writeFileSync(path, data) {
	    fs$1.writeFileSync(path, data);
	}
	FsPromise.writeFileSync = writeFileSync;
	async function readFile(path) {
	    return new Promise((resolve, reject) => {
	        fs$1.readFile(path, (err, buffer) => {
	            if (err)
	                reject(err);
	            else
	                resolve(buffer);
	        });
	    });
	}
	FsPromise.readFile = readFile;

	var core = {};

	var ReadStreamTokenizer$1 = {};

	var AbstractTokenizer$1 = {};

	var lib = {};

	var EndOfFileStream = {};

	(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.EndOfStreamError = exports.defaultMessages = void 0;
	exports.defaultMessages = 'End-Of-Stream';
	/**
	 * Thrown on read operation of the end of file or stream has been reached
	 */
	class EndOfStreamError extends Error {
	    constructor() {
	        super(exports.defaultMessages);
	    }
	}
	exports.EndOfStreamError = EndOfStreamError;
	}(EndOfFileStream));

	var StreamReader = {};

	var Deferred$1 = {};

	Object.defineProperty(Deferred$1, "__esModule", { value: true });
	Deferred$1.Deferred = void 0;
	class Deferred {
	    constructor() {
	        this.resolve = () => null;
	        this.reject = () => null;
	        this.promise = new Promise((resolve, reject) => {
	            this.reject = reject;
	            this.resolve = resolve;
	        });
	    }
	}
	Deferred$1.Deferred = Deferred;

	(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.StreamReader = exports.EndOfStreamError = void 0;
	const EndOfFileStream_1 = EndOfFileStream;
	const Deferred_1 = Deferred$1;
	var EndOfFileStream_2 = EndOfFileStream;
	Object.defineProperty(exports, "EndOfStreamError", { enumerable: true, get: function () { return EndOfFileStream_2.EndOfStreamError; } });
	const maxStreamReadSize = 1 * 1024 * 1024; // Maximum request length on read-stream operation
	class StreamReader {
	    constructor(s) {
	        this.s = s;
	        /**
	         * Deferred used for postponed read request (as not data is yet available to read)
	         */
	        this.deferred = null;
	        this.endOfStream = false;
	        /**
	         * Store peeked data
	         * @type {Array}
	         */
	        this.peekQueue = [];
	        if (!s.read || !s.once) {
	            throw new Error('Expected an instance of stream.Readable');
	        }
	        this.s.once('end', () => this.reject(new EndOfFileStream_1.EndOfStreamError()));
	        this.s.once('error', err => this.reject(err));
	        this.s.once('close', () => this.reject(new Error('Stream closed')));
	    }
	    /**
	     * Read ahead (peek) from stream. Subsequent read or peeks will return the same data
	     * @param uint8Array - Uint8Array (or Buffer) to store data read from stream in
	     * @param offset - Offset target
	     * @param length - Number of bytes to read
	     * @returns Number of bytes peeked
	     */
	    async peek(uint8Array, offset, length) {
	        const bytesRead = await this.read(uint8Array, offset, length);
	        this.peekQueue.push(uint8Array.subarray(offset, offset + bytesRead)); // Put read data back to peek buffer
	        return bytesRead;
	    }
	    /**
	     * Read chunk from stream
	     * @param buffer - Target Uint8Array (or Buffer) to store data read from stream in
	     * @param offset - Offset target
	     * @param length - Number of bytes to read
	     * @returns Number of bytes read
	     */
	    async read(buffer, offset, length) {
	        if (length === 0) {
	            return 0;
	        }
	        if (this.peekQueue.length === 0 && this.endOfStream) {
	            throw new EndOfFileStream_1.EndOfStreamError();
	        }
	        let remaining = length;
	        let bytesRead = 0;
	        // consume peeked data first
	        while (this.peekQueue.length > 0 && remaining > 0) {
	            const peekData = this.peekQueue.pop(); // Front of queue
	            if (!peekData)
	                throw new Error('peekData should be defined');
	            const lenCopy = Math.min(peekData.length, remaining);
	            buffer.set(peekData.subarray(0, lenCopy), offset + bytesRead);
	            bytesRead += lenCopy;
	            remaining -= lenCopy;
	            if (lenCopy < peekData.length) {
	                // remainder back to queue
	                this.peekQueue.push(peekData.subarray(lenCopy));
	            }
	        }
	        // continue reading from stream if required
	        while (remaining > 0 && !this.endOfStream) {
	            const reqLen = Math.min(remaining, maxStreamReadSize);
	            const chunkLen = await this.readFromStream(buffer, offset + bytesRead, reqLen);
	            bytesRead += chunkLen;
	            if (chunkLen < reqLen)
	                break;
	            remaining -= chunkLen;
	        }
	        return bytesRead;
	    }
	    /**
	     * Read chunk from stream
	     * @param buffer Target Uint8Array (or Buffer) to store data read from stream in
	     * @param offset Offset target
	     * @param length Number of bytes to read
	     * @returns Number of bytes read
	     */
	    async readFromStream(buffer, offset, length) {
	        const readBuffer = this.s.read(length);
	        if (readBuffer) {
	            buffer.set(readBuffer, offset);
	            return readBuffer.length;
	        }
	        else {
	            const request = {
	                buffer,
	                offset,
	                length,
	                deferred: new Deferred_1.Deferred()
	            };
	            this.deferred = request.deferred;
	            this.s.once('readable', () => {
	                this.readDeferred(request);
	            });
	            return request.deferred.promise;
	        }
	    }
	    /**
	     * Process deferred read request
	     * @param request Deferred read request
	     */
	    readDeferred(request) {
	        const readBuffer = this.s.read(request.length);
	        if (readBuffer) {
	            request.buffer.set(readBuffer, request.offset);
	            request.deferred.resolve(readBuffer.length);
	            this.deferred = null;
	        }
	        else {
	            this.s.once('readable', () => {
	                this.readDeferred(request);
	            });
	        }
	    }
	    reject(err) {
	        this.endOfStream = true;
	        if (this.deferred) {
	            this.deferred.reject(err);
	            this.deferred = null;
	        }
	    }
	}
	exports.StreamReader = StreamReader;
	}(StreamReader));

	(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.StreamReader = exports.EndOfStreamError = void 0;
	var EndOfFileStream_1 = EndOfFileStream;
	Object.defineProperty(exports, "EndOfStreamError", { enumerable: true, get: function () { return EndOfFileStream_1.EndOfStreamError; } });
	var StreamReader_1 = StreamReader;
	Object.defineProperty(exports, "StreamReader", { enumerable: true, get: function () { return StreamReader_1.StreamReader; } });
	}(lib));

	Object.defineProperty(AbstractTokenizer$1, "__esModule", { value: true });
	AbstractTokenizer$1.AbstractTokenizer = void 0;
	const peek_readable_1$3 = lib;
	/**
	 * Core tokenizer
	 */
	class AbstractTokenizer {
	    constructor(fileInfo) {
	        /**
	         * Tokenizer-stream position
	         */
	        this.position = 0;
	        this.numBuffer = new Uint8Array(8);
	        this.fileInfo = fileInfo ? fileInfo : {};
	    }
	    /**
	     * Read a token from the tokenizer-stream
	     * @param token - The token to read
	     * @param position - If provided, the desired position in the tokenizer-stream
	     * @returns Promise with token data
	     */
	    async readToken(token, position = this.position) {
	        const uint8Array = Buffer.alloc(token.len);
	        const len = await this.readBuffer(uint8Array, { position });
	        if (len < token.len)
	            throw new peek_readable_1$3.EndOfStreamError();
	        return token.get(uint8Array, 0);
	    }
	    /**
	     * Peek a token from the tokenizer-stream.
	     * @param token - Token to peek from the tokenizer-stream.
	     * @param position - Offset where to begin reading within the file. If position is null, data will be read from the current file position.
	     * @returns Promise with token data
	     */
	    async peekToken(token, position = this.position) {
	        const uint8Array = Buffer.alloc(token.len);
	        const len = await this.peekBuffer(uint8Array, { position });
	        if (len < token.len)
	            throw new peek_readable_1$3.EndOfStreamError();
	        return token.get(uint8Array, 0);
	    }
	    /**
	     * Read a numeric token from the stream
	     * @param token - Numeric token
	     * @returns Promise with number
	     */
	    async readNumber(token) {
	        const len = await this.readBuffer(this.numBuffer, { length: token.len });
	        if (len < token.len)
	            throw new peek_readable_1$3.EndOfStreamError();
	        return token.get(this.numBuffer, 0);
	    }
	    /**
	     * Read a numeric token from the stream
	     * @param token - Numeric token
	     * @returns Promise with number
	     */
	    async peekNumber(token) {
	        const len = await this.peekBuffer(this.numBuffer, { length: token.len });
	        if (len < token.len)
	            throw new peek_readable_1$3.EndOfStreamError();
	        return token.get(this.numBuffer, 0);
	    }
	    /**
	     * Ignore number of bytes, advances the pointer in under tokenizer-stream.
	     * @param length - Number of bytes to ignore
	     * @return resolves the number of bytes ignored, equals length if this available, otherwise the number of bytes available
	     */
	    async ignore(length) {
	        if (this.fileInfo.size !== undefined) {
	            const bytesLeft = this.fileInfo.size - this.position;
	            if (length > bytesLeft) {
	                this.position += bytesLeft;
	                return bytesLeft;
	            }
	        }
	        this.position += length;
	        return length;
	    }
	    async close() {
	        // empty
	    }
	    normalizeOptions(uint8Array, options) {
	        if (options && options.position !== undefined && options.position < this.position) {
	            throw new Error('`options.position` must be equal or greater than `tokenizer.position`');
	        }
	        if (options) {
	            return {
	                mayBeLess: options.mayBeLess === true,
	                offset: options.offset ? options.offset : 0,
	                length: options.length ? options.length : (uint8Array.length - (options.offset ? options.offset : 0)),
	                position: options.position ? options.position : this.position
	            };
	        }
	        return {
	            mayBeLess: false,
	            offset: 0,
	            length: uint8Array.length,
	            position: this.position
	        };
	    }
	}
	AbstractTokenizer$1.AbstractTokenizer = AbstractTokenizer;

	Object.defineProperty(ReadStreamTokenizer$1, "__esModule", { value: true });
	ReadStreamTokenizer$1.ReadStreamTokenizer = void 0;
	const AbstractTokenizer_1$2 = AbstractTokenizer$1;
	const peek_readable_1$2 = lib;
	const maxBufferSize = 256000;
	class ReadStreamTokenizer extends AbstractTokenizer_1$2.AbstractTokenizer {
	    constructor(stream, fileInfo) {
	        super(fileInfo);
	        this.streamReader = new peek_readable_1$2.StreamReader(stream);
	    }
	    /**
	     * Get file information, an HTTP-client may implement this doing a HEAD request
	     * @return Promise with file information
	     */
	    async getFileInfo() {
	        return this.fileInfo;
	    }
	    /**
	     * Read buffer from tokenizer
	     * @param uint8Array - Target Uint8Array to fill with data read from the tokenizer-stream
	     * @param options - Read behaviour options
	     * @returns Promise with number of bytes read
	     */
	    async readBuffer(uint8Array, options) {
	        const normOptions = this.normalizeOptions(uint8Array, options);
	        const skipBytes = normOptions.position - this.position;
	        if (skipBytes > 0) {
	            await this.ignore(skipBytes);
	            return this.readBuffer(uint8Array, options);
	        }
	        else if (skipBytes < 0) {
	            throw new Error('`options.position` must be equal or greater than `tokenizer.position`');
	        }
	        if (normOptions.length === 0) {
	            return 0;
	        }
	        const bytesRead = await this.streamReader.read(uint8Array, normOptions.offset, normOptions.length);
	        this.position += bytesRead;
	        if ((!options || !options.mayBeLess) && bytesRead < normOptions.length) {
	            throw new peek_readable_1$2.EndOfStreamError();
	        }
	        return bytesRead;
	    }
	    /**
	     * Peek (read ahead) buffer from tokenizer
	     * @param uint8Array - Uint8Array (or Buffer) to write data to
	     * @param options - Read behaviour options
	     * @returns Promise with number of bytes peeked
	     */
	    async peekBuffer(uint8Array, options) {
	        const normOptions = this.normalizeOptions(uint8Array, options);
	        let bytesRead = 0;
	        if (normOptions.position) {
	            const skipBytes = normOptions.position - this.position;
	            if (skipBytes > 0) {
	                const skipBuffer = new Uint8Array(normOptions.length + skipBytes);
	                bytesRead = await this.peekBuffer(skipBuffer, { mayBeLess: normOptions.mayBeLess });
	                uint8Array.set(skipBuffer.subarray(skipBytes), normOptions.offset);
	                return bytesRead - skipBytes;
	            }
	            else if (skipBytes < 0) {
	                throw new Error('Cannot peek from a negative offset in a stream');
	            }
	        }
	        if (normOptions.length > 0) {
	            try {
	                bytesRead = await this.streamReader.peek(uint8Array, normOptions.offset, normOptions.length);
	            }
	            catch (err) {
	                if (options && options.mayBeLess && err instanceof peek_readable_1$2.EndOfStreamError) {
	                    return 0;
	                }
	                throw err;
	            }
	            if ((!normOptions.mayBeLess) && bytesRead < normOptions.length) {
	                throw new peek_readable_1$2.EndOfStreamError();
	            }
	        }
	        return bytesRead;
	    }
	    async ignore(length) {
	        // debug(`ignore ${this.position}...${this.position + length - 1}`);
	        const bufSize = Math.min(maxBufferSize, length);
	        const buf = new Uint8Array(bufSize);
	        let totBytesRead = 0;
	        while (totBytesRead < length) {
	            const remaining = length - totBytesRead;
	            const bytesRead = await this.readBuffer(buf, { length: Math.min(bufSize, remaining) });
	            if (bytesRead < 0) {
	                return bytesRead;
	            }
	            totBytesRead += bytesRead;
	        }
	        return totBytesRead;
	    }
	}
	ReadStreamTokenizer$1.ReadStreamTokenizer = ReadStreamTokenizer;

	var BufferTokenizer$1 = {};

	Object.defineProperty(BufferTokenizer$1, "__esModule", { value: true });
	BufferTokenizer$1.BufferTokenizer = void 0;
	const peek_readable_1$1 = lib;
	const AbstractTokenizer_1$1 = AbstractTokenizer$1;
	class BufferTokenizer extends AbstractTokenizer_1$1.AbstractTokenizer {
	    /**
	     * Construct BufferTokenizer
	     * @param uint8Array - Uint8Array to tokenize
	     * @param fileInfo - Pass additional file information to the tokenizer
	     */
	    constructor(uint8Array, fileInfo) {
	        super(fileInfo);
	        this.uint8Array = uint8Array;
	        this.fileInfo.size = this.fileInfo.size ? this.fileInfo.size : uint8Array.length;
	    }
	    /**
	     * Read buffer from tokenizer
	     * @param uint8Array - Uint8Array to tokenize
	     * @param options - Read behaviour options
	     * @returns {Promise<number>}
	     */
	    async readBuffer(uint8Array, options) {
	        if (options && options.position) {
	            if (options.position < this.position) {
	                throw new Error('`options.position` must be equal or greater than `tokenizer.position`');
	            }
	            this.position = options.position;
	        }
	        const bytesRead = await this.peekBuffer(uint8Array, options);
	        this.position += bytesRead;
	        return bytesRead;
	    }
	    /**
	     * Peek (read ahead) buffer from tokenizer
	     * @param uint8Array
	     * @param options - Read behaviour options
	     * @returns {Promise<number>}
	     */
	    async peekBuffer(uint8Array, options) {
	        const normOptions = this.normalizeOptions(uint8Array, options);
	        const bytes2read = Math.min(this.uint8Array.length - normOptions.position, normOptions.length);
	        if ((!normOptions.mayBeLess) && bytes2read < normOptions.length) {
	            throw new peek_readable_1$1.EndOfStreamError();
	        }
	        else {
	            uint8Array.set(this.uint8Array.subarray(normOptions.position, normOptions.position + bytes2read), normOptions.offset);
	            return bytes2read;
	        }
	    }
	    async close() {
	        // empty
	    }
	}
	BufferTokenizer$1.BufferTokenizer = BufferTokenizer;

	(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.fromBuffer = exports.fromStream = exports.EndOfStreamError = void 0;
	const ReadStreamTokenizer_1 = ReadStreamTokenizer$1;
	const BufferTokenizer_1 = BufferTokenizer$1;
	var peek_readable_1 = lib;
	Object.defineProperty(exports, "EndOfStreamError", { enumerable: true, get: function () { return peek_readable_1.EndOfStreamError; } });
	/**
	 * Construct ReadStreamTokenizer from given Stream.
	 * Will set fileSize, if provided given Stream has set the .path property/
	 * @param stream - Read from Node.js Stream.Readable
	 * @param fileInfo - Pass the file information, like size and MIME-type of the corresponding stream.
	 * @returns ReadStreamTokenizer
	 */
	function fromStream(stream, fileInfo) {
	    fileInfo = fileInfo ? fileInfo : {};
	    return new ReadStreamTokenizer_1.ReadStreamTokenizer(stream, fileInfo);
	}
	exports.fromStream = fromStream;
	/**
	 * Construct ReadStreamTokenizer from given Buffer.
	 * @param uint8Array - Uint8Array to tokenize
	 * @param fileInfo - Pass additional file information to the tokenizer
	 * @returns BufferTokenizer
	 */
	function fromBuffer(uint8Array, fileInfo) {
	    return new BufferTokenizer_1.BufferTokenizer(uint8Array, fileInfo);
	}
	exports.fromBuffer = fromBuffer;
	}(core));

	var FileTokenizer$1 = {};

	Object.defineProperty(FileTokenizer$1, "__esModule", { value: true });
	FileTokenizer$1.fromFile = FileTokenizer$1.FileTokenizer = void 0;
	const AbstractTokenizer_1 = AbstractTokenizer$1;
	const peek_readable_1 = lib;
	const fs = FsPromise;
	class FileTokenizer extends AbstractTokenizer_1.AbstractTokenizer {
	    constructor(fd, fileInfo) {
	        super(fileInfo);
	        this.fd = fd;
	    }
	    /**
	     * Read buffer from file
	     * @param uint8Array - Uint8Array to write result to
	     * @param options - Read behaviour options
	     * @returns Promise number of bytes read
	     */
	    async readBuffer(uint8Array, options) {
	        const normOptions = this.normalizeOptions(uint8Array, options);
	        this.position = normOptions.position;
	        const res = await fs.read(this.fd, uint8Array, normOptions.offset, normOptions.length, normOptions.position);
	        this.position += res.bytesRead;
	        if (res.bytesRead < normOptions.length && (!options || !options.mayBeLess)) {
	            throw new peek_readable_1.EndOfStreamError();
	        }
	        return res.bytesRead;
	    }
	    /**
	     * Peek buffer from file
	     * @param uint8Array - Uint8Array (or Buffer) to write data to
	     * @param options - Read behaviour options
	     * @returns Promise number of bytes read
	     */
	    async peekBuffer(uint8Array, options) {
	        const normOptions = this.normalizeOptions(uint8Array, options);
	        const res = await fs.read(this.fd, uint8Array, normOptions.offset, normOptions.length, normOptions.position);
	        if ((!normOptions.mayBeLess) && res.bytesRead < normOptions.length) {
	            throw new peek_readable_1.EndOfStreamError();
	        }
	        return res.bytesRead;
	    }
	    async close() {
	        return fs.close(this.fd);
	    }
	}
	FileTokenizer$1.FileTokenizer = FileTokenizer;
	async function fromFile(sourceFilePath) {
	    const stat = await fs.stat(sourceFilePath);
	    if (!stat.isFile) {
	        throw new Error(`File not a file: ${sourceFilePath}`);
	    }
	    const fd = await fs.open(sourceFilePath, 'r');
	    return new FileTokenizer(fd, { path: sourceFilePath, size: stat.size });
	}
	FileTokenizer$1.fromFile = fromFile;

	(function (exports) {
	Object.defineProperty(exports, "__esModule", { value: true });
	exports.fromStream = exports.fromBuffer = exports.EndOfStreamError = exports.fromFile = void 0;
	const fs = FsPromise;
	const core$1 = core;
	var FileTokenizer_1 = FileTokenizer$1;
	Object.defineProperty(exports, "fromFile", { enumerable: true, get: function () { return FileTokenizer_1.fromFile; } });
	var core_1 = core;
	Object.defineProperty(exports, "EndOfStreamError", { enumerable: true, get: function () { return core_1.EndOfStreamError; } });
	Object.defineProperty(exports, "fromBuffer", { enumerable: true, get: function () { return core_1.fromBuffer; } });
	/**
	 * Construct ReadStreamTokenizer from given Stream.
	 * Will set fileSize, if provided given Stream has set the .path property.
	 * @param stream - Node.js Stream.Readable
	 * @param fileInfo - Pass additional file information to the tokenizer
	 * @returns Tokenizer
	 */
	async function fromStream(stream, fileInfo) {
	    fileInfo = fileInfo ? fileInfo : {};
	    if (stream.path) {
	        const stat = await fs.stat(stream.path);
	        fileInfo.path = stream.path;
	        fileInfo.size = stat.size;
	    }
	    return core$1.fromStream(stream, fileInfo);
	}
	exports.fromStream = fromStream;
	}(lib$1));

	function stringToBytes(string) {
	    return Object.values(string).map(character => {
	        return character.charCodeAt(0);
	    });
	}
	/**
	Checks whether the TAR checksum is valid.

	@param {Buffer} buffer - The TAR header `[offset ... offset + 512]`.
	@param {number} offset - TAR header offset.
	@returns {boolean} `true` if the TAR checksum is valid, otherwise `false`.
	*/
	function tarHeaderChecksumMatches(buffer, offset = 0) {
	    const readSum = Number.parseInt(buffer.toString('utf8', 148, 154).replace(/\0.*$/, '').trim(), 8); // Read sum in header
	    if (Number.isNaN(readSum)) {
	        return false;
	    }
	    let sum = 8 * 0x20; // Initialize signed bit sum
	    for (let i = offset; i < offset + 148; i++) {
	        sum += buffer[i];
	    }
	    for (let i = offset + 156; i < offset + 512; i++) {
	        sum += buffer[i];
	    }
	    return readSum === sum;
	}
	/**
	ID3 UINT32 sync-safe tokenizer token.
	28 bits (representing up to 256MB) integer, the msb is 0 to avoid "false syncsignals".
	*/
	const uint32SyncSafeToken = {
	    get: (buffer, offset) => (buffer[offset + 3] & 0x7F) | ((buffer[offset + 2]) << 7) | ((buffer[offset + 1]) << 14) | ((buffer[offset]) << 21),
	    len: 4,
	};

	const minimumBytes = 4100; // A fair amount of file-types are detectable within this range.
	// 没有的情况下，均通过
	const checkFileType = (file, callback) => {
	    const reader = new FileReader();
	    reader.readAsArrayBuffer(file);
	    reader.onload = async (event) => {
	        var _a, _b;
	        try {
	            const buffers = new Uint8Array((_a = event.target) === null || _a === void 0 ? void 0 : _a.result);
	            const tokenizer = await lib$1.fromBuffer(buffers);
	            const fileType = await fileTypeFromTokenizer(tokenizer);
	            const suffix = file.name.indexOf('.') > -1 ? (file.name.split('.').pop() || '').toLocaleLowerCase() : '';
	            let check = fileType ? suffix === fileType.ext : true;
	            // 兼容处理
	            if (suffix.indexOf('xls') > -1 && (((_b = fileType === null || fileType === void 0 ? void 0 : fileType.ext) === null || _b === void 0 ? void 0 : _b.indexOf('xls')) > -1 || (fileType === null || fileType === void 0 ? void 0 : fileType.ext) === 'cfb')) {
	                check = true;
	            }
	            callback(check, fileType);
	        }
	        catch (error) {
	            if (!(error instanceof lib$1.EndOfStreamError)) {
	                throw error;
	            }
	            callback(true, undefined);
	        }
	    };
	};
	async function fileTypeFromTokenizer(tokenizer) {
	    try {
	        return new FileTypeParser().parse(tokenizer);
	    }
	    catch (error) {
	        if (!(error instanceof lib$1.EndOfStreamError)) {
	            throw error;
	        }
	    }
	}
	function _check(buffer, headers, options) {
	    options = Object.assign({ offset: 0 }, options);
	    for (const [index, header] of headers.entries()) {
	        // If a bitmask is set
	        if (options.mask) {
	            // If header doesn't equal `buf` with bits masked off
	            if (header !== (options.mask[index] & buffer[index + options.offset])) {
	                return false;
	            }
	        }
	        else if (header !== buffer[index + options.offset]) {
	            return false;
	        }
	    }
	    return true;
	}
	class FileTypeParser {
	    constructor() {
	        this.buffer = Buffer.alloc(minimumBytes);
	    }
	    check(header, options) {
	        return _check(this.buffer, header, options);
	    }
	    checkString(header, options) {
	        return this.check(stringToBytes(header), options);
	    }
	    async readTiffTag(bigEndian) {
	        if (this.tokenizer) {
	            const tagId = await this.tokenizer.readToken(bigEndian ? lib$2.UINT16_BE : lib$2.UINT16_LE);
	            this.tokenizer.ignore(10);
	            switch (tagId) {
	                case 50341:
	                    return {
	                        ext: 'arw',
	                        mime: 'image/x-sony-arw',
	                    };
	                case 50706:
	                    return {
	                        ext: 'dng',
	                        mime: 'image/x-adobe-dng',
	                    };
	            }
	        }
	    }
	    async readTiffIFD(bigEndian) {
	        if (this.tokenizer) {
	            const numberOfTags = await this.tokenizer.readToken(bigEndian ? lib$2.UINT16_BE : lib$2.UINT16_LE);
	            for (let n = 0; n < numberOfTags; ++n) {
	                const fileType = await this.readTiffTag(bigEndian);
	                if (fileType) {
	                    return fileType;
	                }
	            }
	        }
	    }
	    async readTiffHeader(bigEndian) {
	        const version = (bigEndian ? lib$2.UINT16_BE : lib$2.UINT16_LE).get(this.buffer, 2);
	        const ifdOffset = (bigEndian ? lib$2.UINT32_BE : lib$2.UINT32_LE).get(this.buffer, 4);
	        if (version === 42) {
	            // TIFF file header
	            if (ifdOffset >= 6) {
	                if (this.checkString('CR', { offset: 8 })) {
	                    return {
	                        ext: 'cr2',
	                        mime: 'image/x-canon-cr2',
	                    };
	                }
	                if (ifdOffset >= 8 && (this.check([0x1C, 0x00, 0xFE, 0x00], { offset: 8 }) || this.check([0x1F, 0x00, 0x0B, 0x00], { offset: 8 }))) {
	                    return {
	                        ext: 'nef',
	                        mime: 'image/x-nikon-nef',
	                    };
	                }
	            }
	            if (this.tokenizer) {
	                await this.tokenizer.ignore(ifdOffset);
	                const fileType = await this.readTiffIFD(false);
	                return fileType ? fileType : {
	                    ext: 'tif',
	                    mime: 'image/tiff',
	                };
	            }
	        }
	        if (version === 43) { // Big TIFF file header
	            return {
	                ext: 'tif',
	                mime: 'image/tiff',
	            };
	        }
	    }
	    async parse(tokenizer) {
	        this.buffer = Buffer.alloc(minimumBytes);
	        // Keep reading until EOF if the file size is unknown.
	        if (tokenizer.fileInfo.size === undefined) {
	            tokenizer.fileInfo.size = Number.MAX_SAFE_INTEGER;
	        }
	        this.tokenizer = tokenizer;
	        await tokenizer.peekBuffer(this.buffer, { length: 12, mayBeLess: true });
	        // -- 2-byte signatures --
	        if (this.check([0x42, 0x4D])) {
	            return {
	                ext: 'bmp',
	                mime: 'image/bmp',
	            };
	        }
	        if (this.check([0x0B, 0x77])) {
	            return {
	                ext: 'ac3',
	                mime: 'audio/vnd.dolby.dd-raw',
	            };
	        }
	        if (this.check([0x78, 0x01])) {
	            return {
	                ext: 'dmg',
	                mime: 'application/x-apple-diskimage',
	            };
	        }
	        if (this.check([0x4D, 0x5A])) {
	            return {
	                ext: 'exe',
	                mime: 'application/x-msdownload',
	            };
	        }
	        if (this.check([0x25, 0x21])) {
	            await tokenizer.peekBuffer(this.buffer, { length: 24, mayBeLess: true });
	            if (this.checkString('PS-Adobe-', { offset: 2 })
	                && this.checkString(' EPSF-', { offset: 14 })) {
	                return {
	                    ext: 'eps',
	                    mime: 'application/eps',
	                };
	            }
	            return {
	                ext: 'ps',
	                mime: 'application/postscript',
	            };
	        }
	        if (this.check([0x1F, 0xA0]) || this.check([0x1F, 0x9D])) {
	            return {
	                ext: 'Z',
	                mime: 'application/x-compress',
	            };
	        }
	        // -- 3-byte signatures --
	        if (this.check([0x47, 0x49, 0x46])) {
	            return {
	                ext: 'gif',
	                mime: 'image/gif',
	            };
	        }
	        if (this.check([0xFF, 0xD8, 0xFF])) {
	            return {
	                ext: 'jpg',
	                mime: 'image/jpeg',
	            };
	        }
	        if (this.check([0x49, 0x49, 0xBC])) {
	            return {
	                ext: 'jxr',
	                mime: 'image/vnd.ms-photo',
	            };
	        }
	        if (this.check([0x1F, 0x8B, 0x8])) {
	            return {
	                ext: 'gz',
	                mime: 'application/gzip',
	            };
	        }
	        if (this.check([0x42, 0x5A, 0x68])) {
	            return {
	                ext: 'bz2',
	                mime: 'application/x-bzip2',
	            };
	        }
	        if (this.checkString('ID3')) {
	            await tokenizer.ignore(6); // Skip ID3 header until the header size
	            const id3HeaderLength = await tokenizer.readToken(uint32SyncSafeToken);
	            if (tokenizer.position + id3HeaderLength > tokenizer.fileInfo.size) {
	                // Guess file type based on ID3 header for backward compatibility
	                return {
	                    ext: 'mp3',
	                    mime: 'audio/mpeg',
	                };
	            }
	            await tokenizer.ignore(id3HeaderLength);
	            return fileTypeFromTokenizer(tokenizer); // Skip ID3 header, recursion
	        }
	        // Musepack, SV7
	        if (this.checkString('MP+')) {
	            return {
	                ext: 'mpc',
	                mime: 'audio/x-musepack',
	            };
	        }
	        if ((this.buffer[0] === 0x43 || this.buffer[0] === 0x46) && this.check([0x57, 0x53], { offset: 1 })) {
	            return {
	                ext: 'swf',
	                mime: 'application/x-shockwave-flash',
	            };
	        }
	        // -- 4-byte signatures --
	        if (this.checkString('FLIF')) {
	            return {
	                ext: 'flif',
	                mime: 'image/flif',
	            };
	        }
	        if (this.checkString('8BPS')) {
	            return {
	                ext: 'psd',
	                mime: 'image/vnd.adobe.photoshop',
	            };
	        }
	        if (this.checkString('WEBP', { offset: 8 })) {
	            return {
	                ext: 'webp',
	                mime: 'image/webp',
	            };
	        }
	        // Musepack, SV8
	        if (this.checkString('MPCK')) {
	            return {
	                ext: 'mpc',
	                mime: 'audio/x-musepack',
	            };
	        }
	        if (this.checkString('FORM')) {
	            return {
	                ext: 'aif',
	                mime: 'audio/aiff',
	            };
	        }
	        if (this.checkString('icns', { offset: 0 })) {
	            return {
	                ext: 'icns',
	                mime: 'image/icns',
	            };
	        }
	        // Zip-based file formats
	        // Need to be before the `zip` check
	        if (this.check([0x50, 0x4B, 0x3, 0x4])) { // Local file header signature
	            try {
	                while (tokenizer.position + 30 < tokenizer.fileInfo.size) {
	                    await tokenizer.readBuffer(this.buffer, { length: 30 });
	                    // https://en.wikipedia.org/wiki/Zip_(file_format)#File_headers
	                    const zipHeader = {
	                        compressedSize: this.buffer.readUInt32LE(18),
	                        uncompressedSize: this.buffer.readUInt32LE(22),
	                        filenameLength: this.buffer.readUInt16LE(26),
	                        extraFieldLength: this.buffer.readUInt16LE(28),
	                    };
	                    zipHeader.filename = await tokenizer.readToken(new lib$2.StringType(zipHeader.filenameLength, 'utf-8'));
	                    await tokenizer.ignore(zipHeader.extraFieldLength);
	                    // Assumes signed `.xpi` from addons.mozilla.org
	                    if (zipHeader.filename === 'META-INF/mozilla.rsa') {
	                        return {
	                            ext: 'xpi',
	                            mime: 'application/x-xpinstall',
	                        };
	                    }
	                    if (zipHeader.filename.endsWith('.rels') || zipHeader.filename.endsWith('.xml')) {
	                        const type = zipHeader.filename.split('/')[0];
	                        switch (type) {
	                            case '_rels':
	                                break;
	                            case 'word':
	                                return {
	                                    ext: 'docx',
	                                    mime: 'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
	                                };
	                            case 'ppt':
	                                return {
	                                    ext: 'pptx',
	                                    mime: 'application/vnd.openxmlformats-officedocument.presentationml.presentation',
	                                };
	                            case 'xl':
	                                return {
	                                    ext: 'xlsx',
	                                    mime: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
	                                };
	                            default:
	                                break;
	                        }
	                    }
	                    if (zipHeader.filename.startsWith('xl/')) {
	                        return {
	                            ext: 'xlsx',
	                            mime: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
	                        };
	                    }
	                    if (zipHeader.filename.startsWith('3D/') && zipHeader.filename.endsWith('.model')) {
	                        return {
	                            ext: '3mf',
	                            mime: 'model/3mf',
	                        };
	                    }
	                    // The docx, xlsx and pptx file types extend the Office Open XML file format:
	                    // https://en.wikipedia.org/wiki/Office_Open_XML_file_formats
	                    // We look for:
	                    // - one entry named '[Content_Types].xml' or '_rels/.rels',
	                    // - one entry indicating specific type of file.
	                    // MS Office, OpenOffice and LibreOffice may put the parts in different order, so the check should not rely on it.
	                    if (zipHeader.filename === 'mimetype' && zipHeader.compressedSize === zipHeader.uncompressedSize) {
	                        const mimeType = await tokenizer.readToken(new lib$2.StringType(zipHeader.compressedSize, 'utf-8'));
	                        switch (mimeType) {
	                            case 'application/epub+zip':
	                                return {
	                                    ext: 'epub',
	                                    mime: 'application/epub+zip',
	                                };
	                            case 'application/vnd.oasis.opendocument.text':
	                                return {
	                                    ext: 'odt',
	                                    mime: 'application/vnd.oasis.opendocument.text',
	                                };
	                            case 'application/vnd.oasis.opendocument.spreadsheet':
	                                return {
	                                    ext: 'ods',
	                                    mime: 'application/vnd.oasis.opendocument.spreadsheet',
	                                };
	                            case 'application/vnd.oasis.opendocument.presentation':
	                                return {
	                                    ext: 'odp',
	                                    mime: 'application/vnd.oasis.opendocument.presentation',
	                                };
	                            default:
	                        }
	                    }
	                    // Try to find next header manually when current one is corrupted
	                    if (zipHeader.compressedSize === 0) {
	                        let nextHeaderIndex = -1;
	                        while (nextHeaderIndex < 0 && (tokenizer.position < tokenizer.fileInfo.size)) {
	                            await tokenizer.peekBuffer(this.buffer, { mayBeLess: true });
	                            nextHeaderIndex = this.buffer.indexOf('504B0304', 0, 'hex');
	                            // Move position to the next header if found, skip the whole buffer otherwise
	                            await tokenizer.ignore(nextHeaderIndex >= 0 ? nextHeaderIndex : this.buffer.length);
	                        }
	                    }
	                    else {
	                        await tokenizer.ignore(zipHeader.compressedSize);
	                    }
	                }
	            }
	            catch (error) {
	                if (!(error instanceof lib$1.EndOfStreamError)) {
	                    throw error;
	                }
	            }
	            return {
	                ext: 'zip',
	                mime: 'application/zip',
	            };
	        }
	        if (this.checkString('OggS')) {
	            // This is an OGG container
	            await tokenizer.ignore(28);
	            const type = Buffer.alloc(8);
	            await tokenizer.readBuffer(type);
	            // Needs to be before `ogg` check
	            if (_check(type, [0x4F, 0x70, 0x75, 0x73, 0x48, 0x65, 0x61, 0x64])) {
	                return {
	                    ext: 'opus',
	                    mime: 'audio/opus',
	                };
	            }
	            // If ' theora' in header.
	            if (_check(type, [0x80, 0x74, 0x68, 0x65, 0x6F, 0x72, 0x61])) {
	                return {
	                    ext: 'ogv',
	                    mime: 'video/ogg',
	                };
	            }
	            // If '\x01video' in header.
	            if (_check(type, [0x01, 0x76, 0x69, 0x64, 0x65, 0x6F, 0x00])) {
	                return {
	                    ext: 'ogm',
	                    mime: 'video/ogg',
	                };
	            }
	            // If ' FLAC' in header  https://xiph.org/flac/faq.html
	            if (_check(type, [0x7F, 0x46, 0x4C, 0x41, 0x43])) {
	                return {
	                    ext: 'oga',
	                    mime: 'audio/ogg',
	                };
	            }
	            // 'Speex  ' in header https://en.wikipedia.org/wiki/Speex
	            if (_check(type, [0x53, 0x70, 0x65, 0x65, 0x78, 0x20, 0x20])) {
	                return {
	                    ext: 'spx',
	                    mime: 'audio/ogg',
	                };
	            }
	            // If '\x01vorbis' in header
	            if (_check(type, [0x01, 0x76, 0x6F, 0x72, 0x62, 0x69, 0x73])) {
	                return {
	                    ext: 'ogg',
	                    mime: 'audio/ogg',
	                };
	            }
	            // Default OGG container https://www.iana.org/assignments/media-types/application/ogg
	            return {
	                ext: 'ogx',
	                mime: 'application/ogg',
	            };
	        }
	        if (this.check([0x50, 0x4B])
	            && (this.buffer[2] === 0x3 || this.buffer[2] === 0x5 || this.buffer[2] === 0x7)
	            && (this.buffer[3] === 0x4 || this.buffer[3] === 0x6 || this.buffer[3] === 0x8)) {
	            return {
	                ext: 'zip',
	                mime: 'application/zip',
	            };
	        }
	        //
	        // File Type Box (https://en.wikipedia.org/wiki/ISO_base_media_file_format)
	        // It's not required to be first, but it's recommended to be. Almost all ISO base media files start with `ftyp` box.
	        // `ftyp` box must contain a brand major identifier, which must consist of ISO 8859-1 printable characters.
	        // Here we check for 8859-1 printable characters (for simplicity, it's a mask which also catches one non-printable character).
	        if (this.checkString('ftyp', { offset: 4 })
	            && (this.buffer[8] & 0x60) !== 0x00 // Brand major, first character ASCII?
	        ) {
	            // They all can have MIME `video/mp4` except `application/mp4` special-case which is hard to detect.
	            // For some cases, we're specific, everything else falls to `video/mp4` with `mp4` extension.
	            const brandMajor = this.buffer.toString('binary', 8, 12).replace('\0', ' ').trim();
	            switch (brandMajor) {
	                case 'avif':
	                case 'avis':
	                    return { ext: 'avif', mime: 'image/avif' };
	                case 'mif1':
	                    return { ext: 'heic', mime: 'image/heif' };
	                case 'msf1':
	                    return { ext: 'heic', mime: 'image/heif-sequence' };
	                case 'heic':
	                case 'heix':
	                    return { ext: 'heic', mime: 'image/heic' };
	                case 'hevc':
	                case 'hevx':
	                    return { ext: 'heic', mime: 'image/heic-sequence' };
	                case 'qt':
	                    return { ext: 'mov', mime: 'video/quicktime' };
	                case 'M4V':
	                case 'M4VH':
	                case 'M4VP':
	                    return { ext: 'm4v', mime: 'video/x-m4v' };
	                case 'M4P':
	                    return { ext: 'm4p', mime: 'video/mp4' };
	                case 'M4B':
	                    return { ext: 'm4b', mime: 'audio/mp4' };
	                case 'M4A':
	                    return { ext: 'm4a', mime: 'audio/x-m4a' };
	                case 'F4V':
	                    return { ext: 'f4v', mime: 'video/mp4' };
	                case 'F4P':
	                    return { ext: 'f4p', mime: 'video/mp4' };
	                case 'F4A':
	                    return { ext: 'f4a', mime: 'audio/mp4' };
	                case 'F4B':
	                    return { ext: 'f4b', mime: 'audio/mp4' };
	                case 'crx':
	                    return { ext: 'cr3', mime: 'image/x-canon-cr3' };
	                default:
	                    if (brandMajor.startsWith('3g')) {
	                        if (brandMajor.startsWith('3g2')) {
	                            return { ext: '3g2', mime: 'video/3gpp2' };
	                        }
	                        return { ext: '3gp', mime: 'video/3gpp' };
	                    }
	                    return { ext: 'mp4', mime: 'video/mp4' };
	            }
	        }
	        if (this.checkString('MThd')) {
	            return {
	                ext: 'mid',
	                mime: 'audio/midi',
	            };
	        }
	        if (this.checkString('wOFF')
	            && (this.check([0x00, 0x01, 0x00, 0x00], { offset: 4 })
	                || this.checkString('OTTO', { offset: 4 }))) {
	            return {
	                ext: 'woff',
	                mime: 'font/woff',
	            };
	        }
	        if (this.checkString('wOF2')
	            && (this.check([0x00, 0x01, 0x00, 0x00], { offset: 4 })
	                || this.checkString('OTTO', { offset: 4 }))) {
	            return {
	                ext: 'woff2',
	                mime: 'font/woff2',
	            };
	        }
	        if (this.check([0xD4, 0xC3, 0xB2, 0xA1]) || this.check([0xA1, 0xB2, 0xC3, 0xD4])) {
	            return {
	                ext: 'pcap',
	                mime: 'application/vnd.tcpdump.pcap',
	            };
	        }
	        // Sony DSD Stream File (DSF)
	        if (this.checkString('DSD ')) {
	            return {
	                ext: 'dsf',
	                mime: 'audio/x-dsf', // Non-standard
	            };
	        }
	        if (this.checkString('LZIP')) {
	            return {
	                ext: 'lz',
	                mime: 'application/x-lzip',
	            };
	        }
	        if (this.checkString('fLaC')) {
	            return {
	                ext: 'flac',
	                mime: 'audio/flac', // todo: audio/x-flac
	            };
	        }
	        if (this.check([0x42, 0x50, 0x47, 0xFB])) {
	            return {
	                ext: 'bpg',
	                mime: 'image/bpg',
	            };
	        }
	        if (this.checkString('wvpk')) {
	            return {
	                ext: 'wv',
	                mime: 'audio/wavpack',
	            };
	        }
	        if (this.checkString('%PDF')) {
	            await tokenizer.ignore(1350);
	            const maxBufferSize = 10 * 1024 * 1024;
	            const buffer = Buffer.alloc(Math.min(maxBufferSize, tokenizer.fileInfo.size));
	            await tokenizer.readBuffer(buffer, { mayBeLess: true });
	            // Check if this is an Adobe Illustrator file
	            if (buffer.includes(Buffer.from('AIPrivateData'))) {
	                return {
	                    ext: 'ai',
	                    mime: 'application/postscript',
	                };
	            }
	            // Assume this is just a normal PDF
	            return {
	                ext: 'pdf',
	                mime: 'application/pdf',
	            };
	        }
	        if (this.check([0x00, 0x61, 0x73, 0x6D])) {
	            return {
	                ext: 'wasm',
	                mime: 'application/wasm',
	            };
	        }
	        // TIFF, little-endian type
	        if (this.check([0x49, 0x49])) {
	            const fileType = await this.readTiffHeader(false);
	            if (fileType) {
	                return fileType;
	            }
	        }
	        // TIFF, big-endian type
	        if (this.check([0x4D, 0x4D])) {
	            const fileType = await this.readTiffHeader(true);
	            if (fileType) {
	                return fileType;
	            }
	        }
	        if (this.checkString('MAC ')) {
	            return {
	                ext: 'ape',
	                mime: 'audio/ape',
	            };
	        }
	        // https://github.com/threatstack/libmagic/blob/master/magic/Magdir/matroska
	        if (this.check([0x1A, 0x45, 0xDF, 0xA3])) { // Root element: EBML
	            async function readField() {
	                const msb = await tokenizer.peekNumber(lib$2.UINT8);
	                let mask = 0x80;
	                let ic = 0; // 0 = A, 1 = B, 2 = C, 3
	                // = D
	                while ((msb & mask) === 0) {
	                    ++ic;
	                    mask >>= 1;
	                }
	                const id = Buffer.alloc(ic + 1);
	                await tokenizer.readBuffer(id);
	                return id;
	            }
	            async function readElement() {
	                const id = await readField();
	                const lengthField = await readField();
	                lengthField[0] ^= 0x80 >> (lengthField.length - 1);
	                const nrLength = Math.min(6, lengthField.length); // JavaScript can max read 6 bytes integer
	                return {
	                    id: id.readUIntBE(0, id.length),
	                    len: lengthField.readUIntBE(lengthField.length - nrLength, nrLength),
	                };
	            }
	            async function readChildren(_level, children) {
	                while (children > 0) {
	                    const element = await readElement();
	                    if (element.id === 17026) {
	                        const rawValue = await tokenizer.readToken(new lib$2.StringType(element.len, 'utf-8'));
	                        return rawValue.replace(/\00.*$/g, ''); // Return DocType
	                    }
	                    await tokenizer.ignore(element.len); // ignore payload
	                    --children;
	                }
	            }
	            const re = await readElement();
	            const docType = await readChildren(1, re.len);
	            switch (docType) {
	                case 'webm':
	                    return {
	                        ext: 'webm',
	                        mime: 'video/webm',
	                    };
	                case 'matroska':
	                    return {
	                        ext: 'mkv',
	                        mime: 'video/x-matroska',
	                    };
	                default:
	                    return;
	            }
	        }
	        // RIFF file format which might be AVI, WAV, QCP, etc
	        if (this.check([0x52, 0x49, 0x46, 0x46])) {
	            if (this.check([0x41, 0x56, 0x49], { offset: 8 })) {
	                return {
	                    ext: 'avi',
	                    mime: 'video/vnd.avi',
	                };
	            }
	            if (this.check([0x57, 0x41, 0x56, 0x45], { offset: 8 })) {
	                return {
	                    ext: 'wav',
	                    mime: 'audio/vnd.wave',
	                };
	            }
	            // QLCM, QCP file
	            if (this.check([0x51, 0x4C, 0x43, 0x4D], { offset: 8 })) {
	                return {
	                    ext: 'qcp',
	                    mime: 'audio/qcelp',
	                };
	            }
	        }
	        if (this.checkString('SQLi')) {
	            return {
	                ext: 'sqlite',
	                mime: 'application/x-sqlite3',
	            };
	        }
	        if (this.check([0x4E, 0x45, 0x53, 0x1A])) {
	            return {
	                ext: 'nes',
	                mime: 'application/x-nintendo-nes-rom',
	            };
	        }
	        if (this.checkString('Cr24')) {
	            return {
	                ext: 'crx',
	                mime: 'application/x-google-chrome-extension',
	            };
	        }
	        if (this.checkString('MSCF')
	            || this.checkString('ISc(')) {
	            return {
	                ext: 'cab',
	                mime: 'application/vnd.ms-cab-compressed',
	            };
	        }
	        if (this.check([0xED, 0xAB, 0xEE, 0xDB])) {
	            return {
	                ext: 'rpm',
	                mime: 'application/x-rpm',
	            };
	        }
	        if (this.check([0xC5, 0xD0, 0xD3, 0xC6])) {
	            return {
	                ext: 'eps',
	                mime: 'application/eps',
	            };
	        }
	        if (this.check([0x28, 0xB5, 0x2F, 0xFD])) {
	            return {
	                ext: 'zst',
	                mime: 'application/zstd',
	            };
	        }
	        if (this.check([0x7F, 0x45, 0x4C, 0x46])) {
	            return {
	                ext: 'elf',
	                mime: 'application/x-elf',
	            };
	        }
	        // -- 5-byte signatures --
	        if (this.check([0x4F, 0x54, 0x54, 0x4F, 0x00])) {
	            return {
	                ext: 'otf',
	                mime: 'font/otf',
	            };
	        }
	        if (this.checkString('#!AMR')) {
	            return {
	                ext: 'amr',
	                mime: 'audio/amr',
	            };
	        }
	        if (this.checkString('{\\rtf')) {
	            return {
	                ext: 'rtf',
	                mime: 'application/rtf',
	            };
	        }
	        if (this.check([0x46, 0x4C, 0x56, 0x01])) {
	            return {
	                ext: 'flv',
	                mime: 'video/x-flv',
	            };
	        }
	        if (this.checkString('IMPM')) {
	            return {
	                ext: 'it',
	                mime: 'audio/x-it',
	            };
	        }
	        if (this.checkString('-lh0-', { offset: 2 })
	            || this.checkString('-lh1-', { offset: 2 })
	            || this.checkString('-lh2-', { offset: 2 })
	            || this.checkString('-lh3-', { offset: 2 })
	            || this.checkString('-lh4-', { offset: 2 })
	            || this.checkString('-lh5-', { offset: 2 })
	            || this.checkString('-lh6-', { offset: 2 })
	            || this.checkString('-lh7-', { offset: 2 })
	            || this.checkString('-lzs-', { offset: 2 })
	            || this.checkString('-lz4-', { offset: 2 })
	            || this.checkString('-lz5-', { offset: 2 })
	            || this.checkString('-lhd-', { offset: 2 })) {
	            return {
	                ext: 'lzh',
	                mime: 'application/x-lzh-compressed',
	            };
	        }
	        // MPEG program stream (PS or MPEG-PS)
	        if (this.check([0x00, 0x00, 0x01, 0xBA])) {
	            //  MPEG-PS, MPEG-1 Part 1
	            if (this.check([0x21], { offset: 4, mask: [0xF1] })) {
	                return {
	                    ext: 'mpg',
	                    mime: 'video/MP1S',
	                };
	            }
	            // MPEG-PS, MPEG-2 Part 1
	            if (this.check([0x44], { offset: 4, mask: [0xC4] })) {
	                return {
	                    ext: 'mpg',
	                    mime: 'video/MP2P',
	                };
	            }
	        }
	        if (this.checkString('ITSF')) {
	            return {
	                ext: 'chm',
	                mime: 'application/vnd.ms-htmlhelp',
	            };
	        }
	        // -- 6-byte signatures --
	        if (this.check([0xFD, 0x37, 0x7A, 0x58, 0x5A, 0x00])) {
	            return {
	                ext: 'xz',
	                mime: 'application/x-xz',
	            };
	        }
	        if (this.checkString('<?xml ')) {
	            return {
	                ext: 'xml',
	                mime: 'application/xml',
	            };
	        }
	        if (this.check([0x37, 0x7A, 0xBC, 0xAF, 0x27, 0x1C])) {
	            return {
	                ext: '7z',
	                mime: 'application/x-7z-compressed',
	            };
	        }
	        if (this.check([0x52, 0x61, 0x72, 0x21, 0x1A, 0x7])
	            && (this.buffer[6] === 0x0 || this.buffer[6] === 0x1)) {
	            return {
	                ext: 'rar',
	                mime: 'application/x-rar-compressed',
	            };
	        }
	        if (this.checkString('solid ')) {
	            return {
	                ext: 'stl',
	                mime: 'model/stl',
	            };
	        }
	        // -- 7-byte signatures --
	        if (this.checkString('BLENDER')) {
	            return {
	                ext: 'blend',
	                mime: 'application/x-blender',
	            };
	        }
	        if (this.checkString('!<arch>')) {
	            await tokenizer.ignore(8);
	            const string = await tokenizer.readToken(new lib$2.StringType(13, 'ascii'));
	            if (string === 'debian-binary') {
	                return {
	                    ext: 'deb',
	                    mime: 'application/x-deb',
	                };
	            }
	            return {
	                ext: 'ar',
	                mime: 'application/x-unix-archive',
	            };
	        }
	        // -- 8-byte signatures --
	        if (this.check([0x89, 0x50, 0x4E, 0x47, 0x0D, 0x0A, 0x1A, 0x0A])) {
	            // APNG format (https://wiki.mozilla.org/APNG_Specification)
	            // 1. Find the first IDAT (image data) chunk (49 44 41 54)
	            // 2. Check if there is an "acTL" chunk before the IDAT one (61 63 54 4C)
	            // Offset calculated as follows:
	            // - 8 bytes: PNG signature
	            // - 4 (length) + 4 (chunk type) + 13 (chunk data) + 4 (CRC): IHDR chunk
	            await tokenizer.ignore(8); // ignore PNG signature
	            async function readChunkHeader() {
	                return {
	                    length: await tokenizer.readToken(lib$2.INT32_BE),
	                    type: await tokenizer.readToken(new lib$2.StringType(4, 'binary')),
	                };
	            }
	            do {
	                const chunk = await readChunkHeader();
	                if (chunk.length < 0) {
	                    return; // Invalid chunk length
	                }
	                switch (chunk.type) {
	                    case 'IDAT':
	                        return {
	                            ext: 'png',
	                            mime: 'image/png',
	                        };
	                    case 'acTL':
	                        return {
	                            ext: 'apng',
	                            mime: 'image/apng',
	                        };
	                    default:
	                        await tokenizer.ignore(chunk.length + 4); // Ignore chunk-data + CRC
	                }
	            } while (tokenizer.position + 8 < tokenizer.fileInfo.size);
	            return {
	                ext: 'png',
	                mime: 'image/png',
	            };
	        }
	        if (this.check([0x41, 0x52, 0x52, 0x4F, 0x57, 0x31, 0x00, 0x00])) {
	            return {
	                ext: 'arrow',
	                mime: 'application/x-apache-arrow',
	            };
	        }
	        if (this.check([0x67, 0x6C, 0x54, 0x46, 0x02, 0x00, 0x00, 0x00])) {
	            return {
	                ext: 'glb',
	                mime: 'model/gltf-binary',
	            };
	        }
	        // `mov` format variants
	        if (this.check([0x66, 0x72, 0x65, 0x65], { offset: 4 }) // `free`
	            || this.check([0x6D, 0x64, 0x61, 0x74], { offset: 4 }) // `mdat` MJPEG
	            || this.check([0x6D, 0x6F, 0x6F, 0x76], { offset: 4 }) // `moov`
	            || this.check([0x77, 0x69, 0x64, 0x65], { offset: 4 }) // `wide`
	        ) {
	            return {
	                ext: 'mov',
	                mime: 'video/quicktime',
	            };
	        }
	        if (this.check([0xEF, 0xBB, 0xBF]) && this.checkString('<?xml', { offset: 3 })) { // UTF-8-BOM
	            return {
	                ext: 'xml',
	                mime: 'application/xml',
	            };
	        }
	        // -- 9-byte signatures --
	        if (this.check([0x49, 0x49, 0x52, 0x4F, 0x08, 0x00, 0x00, 0x00, 0x18])) {
	            return {
	                ext: 'orf',
	                mime: 'image/x-olympus-orf',
	            };
	        }
	        if (this.checkString('gimp xcf ')) {
	            return {
	                ext: 'xcf',
	                mime: 'image/x-xcf',
	            };
	        }
	        // -- 12-byte signatures --
	        if (this.check([0x49, 0x49, 0x55, 0x00, 0x18, 0x00, 0x00, 0x00, 0x88, 0xE7, 0x74, 0xD8])) {
	            return {
	                ext: 'rw2',
	                mime: 'image/x-panasonic-rw2',
	            };
	        }
	        // ASF_Header_Object first 80 bytes
	        if (this.check([0x30, 0x26, 0xB2, 0x75, 0x8E, 0x66, 0xCF, 0x11, 0xA6, 0xD9])) {
	            async function readHeader() {
	                const guid = Buffer.alloc(16);
	                await tokenizer.readBuffer(guid);
	                return {
	                    id: guid,
	                    size: Number(await tokenizer.readToken(lib$2.UINT64_LE)),
	                };
	            }
	            await tokenizer.ignore(30);
	            // Search for header should be in first 1KB of file.
	            while (tokenizer.position + 24 < tokenizer.fileInfo.size) {
	                const header = await readHeader();
	                let payload = header.size - 24;
	                if (_check(header.id, [0x91, 0x07, 0xDC, 0xB7, 0xB7, 0xA9, 0xCF, 0x11, 0x8E, 0xE6, 0x00, 0xC0, 0x0C, 0x20, 0x53, 0x65])) {
	                    // Sync on Stream-Properties-Object (B7DC0791-A9B7-11CF-8EE6-00C00C205365)
	                    const typeId = Buffer.alloc(16);
	                    payload -= await tokenizer.readBuffer(typeId);
	                    if (_check(typeId, [0x40, 0x9E, 0x69, 0xF8, 0x4D, 0x5B, 0xCF, 0x11, 0xA8, 0xFD, 0x00, 0x80, 0x5F, 0x5C, 0x44, 0x2B])) {
	                        // Found audio:
	                        return {
	                            ext: 'asf',
	                            mime: 'audio/x-ms-asf',
	                        };
	                    }
	                    if (_check(typeId, [0xC0, 0xEF, 0x19, 0xBC, 0x4D, 0x5B, 0xCF, 0x11, 0xA8, 0xFD, 0x00, 0x80, 0x5F, 0x5C, 0x44, 0x2B])) {
	                        // Found video:
	                        return {
	                            ext: 'asf',
	                            mime: 'video/x-ms-asf',
	                        };
	                    }
	                    break;
	                }
	                await tokenizer.ignore(payload);
	            }
	            // Default to ASF generic extension
	            return {
	                ext: 'asf',
	                mime: 'application/vnd.ms-asf',
	            };
	        }
	        if (this.check([0xAB, 0x4B, 0x54, 0x58, 0x20, 0x31, 0x31, 0xBB, 0x0D, 0x0A, 0x1A, 0x0A])) {
	            return {
	                ext: 'ktx',
	                mime: 'image/ktx',
	            };
	        }
	        if ((this.check([0x7E, 0x10, 0x04]) || this.check([0x7E, 0x18, 0x04])) && this.check([0x30, 0x4D, 0x49, 0x45], { offset: 4 })) {
	            return {
	                ext: 'mie',
	                mime: 'application/x-mie',
	            };
	        }
	        if (this.check([0x27, 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00], { offset: 2 })) {
	            return {
	                ext: 'shp',
	                mime: 'application/x-esri-shape',
	            };
	        }
	        if (this.check([0x00, 0x00, 0x00, 0x0C, 0x6A, 0x50, 0x20, 0x20, 0x0D, 0x0A, 0x87, 0x0A])) {
	            // JPEG-2000 family
	            await tokenizer.ignore(20);
	            const type = await tokenizer.readToken(new lib$2.StringType(4, 'ascii'));
	            switch (type) {
	                case 'jp2 ':
	                    return {
	                        ext: 'jp2',
	                        mime: 'image/jp2',
	                    };
	                case 'jpx ':
	                    return {
	                        ext: 'jpx',
	                        mime: 'image/jpx',
	                    };
	                case 'jpm ':
	                    return {
	                        ext: 'jpm',
	                        mime: 'image/jpm',
	                    };
	                case 'mjp2':
	                    return {
	                        ext: 'mj2',
	                        mime: 'image/mj2',
	                    };
	                default:
	                    return;
	            }
	        }
	        if (this.check([0xFF, 0x0A])
	            || this.check([0x00, 0x00, 0x00, 0x0C, 0x4A, 0x58, 0x4C, 0x20, 0x0D, 0x0A, 0x87, 0x0A])) {
	            return {
	                ext: 'jxl',
	                mime: 'image/jxl',
	            };
	        }
	        if (this.check([0xFE, 0xFF, 0, 60, 0, 63, 0, 120, 0, 109, 0, 108]) // UTF-16-BOM-LE
	            || this.check([0xFF, 0xFE, 60, 0, 63, 0, 120, 0, 109, 0, 108, 0]) // UTF-16-BOM-LE
	        ) {
	            return {
	                ext: 'xml',
	                mime: 'application/xml',
	            };
	        }
	        // -- Unsafe signatures --
	        if (this.check([0x0, 0x0, 0x1, 0xBA])
	            || this.check([0x0, 0x0, 0x1, 0xB3])) {
	            return {
	                ext: 'mpg',
	                mime: 'video/mpeg',
	            };
	        }
	        if (this.check([0x00, 0x01, 0x00, 0x00, 0x00])) {
	            return {
	                ext: 'ttf',
	                mime: 'font/ttf',
	            };
	        }
	        if (this.check([0x00, 0x00, 0x01, 0x00])) {
	            return {
	                ext: 'ico',
	                mime: 'image/x-icon',
	            };
	        }
	        if (this.check([0x00, 0x00, 0x02, 0x00])) {
	            return {
	                ext: 'cur',
	                mime: 'image/x-icon',
	            };
	        }
	        if (this.check([0xD0, 0xCF, 0x11, 0xE0, 0xA1, 0xB1, 0x1A, 0xE1])) {
	            // Detected Microsoft Compound File Binary File (MS-CFB) Format.
	            return {
	                ext: 'cfb',
	                mime: 'application/x-cfb',
	            };
	        }
	        // Increase sample size from 12 to 256.
	        await tokenizer.peekBuffer(this.buffer, { length: Math.min(256, tokenizer.fileInfo.size), mayBeLess: true });
	        // -- 15-byte signatures --
	        if (this.checkString('BEGIN:')) {
	            if (this.checkString('VCARD', { offset: 6 })) {
	                return {
	                    ext: 'vcf',
	                    mime: 'text/vcard',
	                };
	            }
	            if (this.checkString('VCALENDAR', { offset: 6 })) {
	                return {
	                    ext: 'ics',
	                    mime: 'text/calendar',
	                };
	            }
	        }
	        // `raf` is here just to keep all the raw image detectors together.
	        if (this.checkString('FUJIFILMCCD-RAW')) {
	            return {
	                ext: 'raf',
	                mime: 'image/x-fujifilm-raf',
	            };
	        }
	        if (this.checkString('Extended Module:')) {
	            return {
	                ext: 'xm',
	                mime: 'audio/x-xm',
	            };
	        }
	        if (this.checkString('Creative Voice File')) {
	            return {
	                ext: 'voc',
	                mime: 'audio/x-voc',
	            };
	        }
	        if (this.check([0x04, 0x00, 0x00, 0x00]) && this.buffer.length >= 16) { // Rough & quick check Pickle/ASAR
	            const jsonSize = this.buffer.readUInt32LE(12);
	            if (jsonSize > 12 && this.buffer.length >= jsonSize + 16) {
	                try {
	                    const header = this.buffer.slice(16, jsonSize + 16).toString();
	                    const json = JSON.parse(header);
	                    // Check if Pickle is ASAR
	                    if (json.files) { // Final check, assuring Pickle/ASAR format
	                        return {
	                            ext: 'asar',
	                            mime: 'application/x-asar',
	                        };
	                    }
	                }
	                catch (_a) { }
	            }
	        }
	        if (this.check([0x06, 0x0E, 0x2B, 0x34, 0x02, 0x05, 0x01, 0x01, 0x0D, 0x01, 0x02, 0x01, 0x01, 0x02])) {
	            return {
	                ext: 'mxf',
	                mime: 'application/mxf',
	            };
	        }
	        if (this.checkString('SCRM', { offset: 44 })) {
	            return {
	                ext: 's3m',
	                mime: 'audio/x-s3m',
	            };
	        }
	        // Raw MPEG-2 transport stream (188-byte packets)
	        if (this.check([0x47]) && this.check([0x47], { offset: 188 })) {
	            return {
	                ext: 'mts',
	                mime: 'video/mp2t',
	            };
	        }
	        // Blu-ray Disc Audio-Video (BDAV) MPEG-2 transport stream has 4-byte TP_extra_header before each 188-byte packet
	        if (this.check([0x47], { offset: 4 }) && this.check([0x47], { offset: 196 })) {
	            return {
	                ext: 'mts',
	                mime: 'video/mp2t',
	            };
	        }
	        if (this.check([0x42, 0x4F, 0x4F, 0x4B, 0x4D, 0x4F, 0x42, 0x49], { offset: 60 })) {
	            return {
	                ext: 'mobi',
	                mime: 'application/x-mobipocket-ebook',
	            };
	        }
	        if (this.check([0x44, 0x49, 0x43, 0x4D], { offset: 128 })) {
	            return {
	                ext: 'dcm',
	                mime: 'application/dicom',
	            };
	        }
	        if (this.check([0x4C, 0x00, 0x00, 0x00, 0x01, 0x14, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46])) {
	            return {
	                ext: 'lnk',
	                mime: 'application/x.ms.shortcut', // Invented by us
	            };
	        }
	        if (this.check([0x62, 0x6F, 0x6F, 0x6B, 0x00, 0x00, 0x00, 0x00, 0x6D, 0x61, 0x72, 0x6B, 0x00, 0x00, 0x00, 0x00])) {
	            return {
	                ext: 'alias',
	                mime: 'application/x.apple.alias', // Invented by us
	            };
	        }
	        if (this.check([0x4C, 0x50], { offset: 34 })
	            && (this.check([0x00, 0x00, 0x01], { offset: 8 })
	                || this.check([0x01, 0x00, 0x02], { offset: 8 })
	                || this.check([0x02, 0x00, 0x02], { offset: 8 }))) {
	            return {
	                ext: 'eot',
	                mime: 'application/vnd.ms-fontobject',
	            };
	        }
	        if (this.check([0x06, 0x06, 0xED, 0xF5, 0xD8, 0x1D, 0x46, 0xE5, 0xBD, 0x31, 0xEF, 0xE7, 0xFE, 0x74, 0xB7, 0x1D])) {
	            return {
	                ext: 'indd',
	                mime: 'application/x-indesign',
	            };
	        }
	        // Increase sample size from 256 to 512
	        await tokenizer.peekBuffer(this.buffer, { length: Math.min(512, tokenizer.fileInfo.size), mayBeLess: true });
	        // Requires a buffer size of 512 bytes
	        if (tarHeaderChecksumMatches(this.buffer)) {
	            return {
	                ext: 'tar',
	                mime: 'application/x-tar',
	            };
	        }
	        if (this.check([0xFF, 0xFE, 0xFF, 0x0E, 0x53, 0x00, 0x6B, 0x00, 0x65, 0x00, 0x74, 0x00, 0x63, 0x00, 0x68, 0x00, 0x55, 0x00, 0x70, 0x00, 0x20, 0x00, 0x4D, 0x00, 0x6F, 0x00, 0x64, 0x00, 0x65, 0x00, 0x6C, 0x00])) {
	            return {
	                ext: 'skp',
	                mime: 'application/vnd.sketchup.skp',
	            };
	        }
	        if (this.checkString('-----BEGIN PGP MESSAGE-----')) {
	            return {
	                ext: 'pgp',
	                mime: 'application/pgp-encrypted',
	            };
	        }
	        // Check MPEG 1 or 2 Layer 3 header, or 'layer 0' for ADTS (MPEG sync-word 0xFFE)
	        if (this.buffer.length >= 2 && this.check([0xFF, 0xE0], { offset: 0, mask: [0xFF, 0xE0] })) {
	            if (this.check([0x10], { offset: 1, mask: [0x16] })) {
	                // Check for (ADTS) MPEG-2
	                if (this.check([0x08], { offset: 1, mask: [0x08] })) {
	                    return {
	                        ext: 'aac',
	                        mime: 'audio/aac',
	                    };
	                }
	                // Must be (ADTS) MPEG-4
	                return {
	                    ext: 'aac',
	                    mime: 'audio/aac',
	                };
	            }
	            // MPEG 1 or 2 Layer 3 header
	            // Check for MPEG layer 3
	            if (this.check([0x02], { offset: 1, mask: [0x06] })) {
	                return {
	                    ext: 'mp3',
	                    mime: 'audio/mpeg',
	                };
	            }
	            // Check for MPEG layer 2
	            if (this.check([0x04], { offset: 1, mask: [0x06] })) {
	                return {
	                    ext: 'mp2',
	                    mime: 'audio/mpeg',
	                };
	            }
	            // Check for MPEG layer 1
	            if (this.check([0x06], { offset: 1, mask: [0x06] })) {
	                return {
	                    ext: 'mp1',
	                    mime: 'audio/mpeg',
	                };
	            }
	        }
	    }
	}

	exports.YC = YC;
	exports.YL = YL;
	exports.YR = YR;
	exports.YS = YS;
	exports.calTimeLen = calTimeLen;
	exports.checkFileType = checkFileType;
	exports.dateFormat = dateFormat;
	exports.debounce = debounce;
	exports.expandMultiple = expandMultiple;
	exports.exportExcel = exportExcel;
	exports.fenToyuan = fenToyuan;
	exports.fileTypeFromTokenizer = fileTypeFromTokenizer;
	exports.formatData = formatData;
	exports.formatTime = formatTime;
	exports.gTokg = gTokg;
	exports.getBiteLen = getBiteLen;
	exports.getDate = getDate;
	exports.getEnv = getEnv;
	exports.getHost = getHost;
	exports.getImgUrl = getImgUrl;
	exports.getMD5 = getMD5;
	exports.getMock = getMock;
	exports.getQueries = getQueries;
	exports.getQuery = getQuery;
	exports.getQueryName = getQueryName;
	exports.getQueryOfNextPageContext = getQueryOfNextPageContext;
	exports.getRoutes = getRoutes;
	exports.humpToLine = humpToLine;
	exports.isChinaMobile = isChinaMobile;
	exports.isDate = isDate;
	exports.isURL = isURL;
	exports.joinPath = joinPath;
	exports.kgTog = kgTog;
	exports.lineToHump = lineToHump;
	exports.loadScript = loadScript;
	exports.maxSubstrWord = maxSubstrWord;
	exports.niceNumShow = niceNumShow;
	exports.numberToThousand = numberToThousand;
	exports.omadownload = omadownload;
	exports.parseParams = parseParams;
	exports.pickAll = pickAll;
	exports.querystring = querystring;
	exports.reduceMultiple = reduceMultiple;
	exports.reduceParams = reduceParams;
	exports.remove = remove;
	exports.round = round;
	exports.slicePath = slicePath;
	exports.split = split;
	exports.strPad = strPad;
	exports.sum = sum;
	exports.throttle = throttle;
	exports.timeFlow = timeFlow;
	exports.toDate = toDate;
	exports.transformShortNum = transformShortNum;
	exports.translateMapToArray = translateMapToArray;
	exports.treeFind = treeFind;
	exports.treePaths = treePaths;
	exports.treeReduce = treeReduce;
	exports.trimAll = trimAll;
	exports.trimParams = trimParams;
	exports.unLoadScript = unLoadScript;
	exports.uuidv4 = uuidv4;
	exports.wanToyuan = wanToyuan;
	exports.yuanTofen = yuanTofen;
	exports.yuanTowan = yuanTowan;
	
} (ywfeUtils_esm));

function request(_a) {
    return __awaiter(this, arguments, void 0, function (_b) {
        var method, basePathMap, getBasePath, isValidURL, prefix, requestUrl, fetchOption, res;
        var input = _b.input;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    method = input.method || 'GET';
                    basePathMap = new Map([
                        ['prod', 'https://gateway.ywwl.com'],
                        ['test', 'https://test-gateway.ywwl.com'],
                        ['test2', 'https://test2-gateway.ywwl.com'],
                        ['dev', 'https://dev-gateway.ywwl.com'],
                    ]);
                    getBasePath = function () {
                        var env = '{{env}}';
                        return basePathMap.get(env);
                    };
                    isValidURL = function (url) {
                        var pattern = new RegExp('^(https?:\\/\\/)?' + // protocol
                            '((([a-z\\d]([a-z\\d-]*[a-z\\d])*)\\.)+[a-z]{2,}|' + // domain name
                            '((\\d{1,3}\\.){3}\\d{1,3}))' + // OR ip (v4) address
                            '(\\:\\d+)?(\\/[-a-z\\d%_.&#126;+]*)*' + // port and path
                            '(\\?[;&a-z\\d%_.&#126;+=-]*)?' + // query string
                            '(\\#[-a-z\\d_]*)?$', 'i'); // fragment locator
                        return !!pattern.test(url);
                    };
                    prefix = getBasePath();
                    requestUrl = isValidURL(input.url) ? input.url : "".concat(prefix).concat(input.url);
                    fetchOption = {
                        method: method,
                        headers: {
                            'Content-type': 'application/json',
                            'x-token': '{{token}}',
                        },
                    };
                    if (method.toUpperCase() === 'POST') {
                        fetchOption.body = JSON.stringify(input.params);
                    }
                    else if (method.toUpperCase() === 'GET') {
                        requestUrl = "".concat(requestUrl, "?").concat(ywfeUtils_esm.querystring.stringify(input.params || {}));
                    }
                    return [4 /*yield*/, fetch(requestUrl, fetchOption)];
                case 1:
                    res = _c.sent();
                    return [2 /*return*/, res.json()];
            }
        });
    });
}

function userInputToJson(_a) {
    return __awaiter(this, arguments, void 0, function (_b) {
        var input = _b.input;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    input.userInput, input.rules;
                    return [4 /*yield*/, request({
                            input: {
                                url: "https://fc-typechat.ywwl.com/userInputToJson",
                                method: "GET"
                            }
                        })];
                case 1:
                    _c.sent();
                    return [2 /*return*/, "2"];
            }
        });
    });
}

exports.request = request;
exports.userInputToJson = userInputToJson;
//# sourceMappingURL=ywfe-tools.cjs.map
